2026-07-25  Andrea Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/126138
	* tree-ssa-phiopt.cc (one_feeding_comparison_into_p): New function.
	(comparison_combine): New function.
	(pass_phiopt::execute): Call comparison_combine.

2026-07-25  Andrea Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/126138
	* tree-ssa-ifcombine.cc (bb_no_side_effects_p): Don't reject GIMPLE_COND
	that can trap.
	(ifcombine_ifandif): Handle trapping inner conditional specially.

2026-07-25  Andrea Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/126138
	* fold-const.cc (combine_comparisons): Allow eq to combine
	with || and ne combine with && if the original rcode was trapping
	and the new code is trapping.

2026-07-25  Jakub Jelinek  <jakub@redhat.com>

	* sym-exec/sym-exec-expression.cc (symbolic_bit::print): Use
	HOST_SIZE_T_PRINT_UNSIGNED instead of "%zu" and add cast to
	fmt_size_t.
	* genoutput.cc (main): Likewise.

2026-07-25  Kyrylo Tkachov  <ktkachov@nvidia.com>

	PR rtl-optimization/126184
	* ifcvt.cc (init_noce_multiple_sets_info): Record only the most
	recent prior definition of each pseudo register.

2026-07-25  Kyrylo Tkachov  <ktkachov@nvidia.com>

	PR rtl-optimization/126184
	* ifcvt.cc (init_noce_multiple_sets_info): Assert that destinations
	are pseudos.
	(bb_ok_for_noce_convert_multiple_sets): Reject hard-register
	destinations.

2026-07-25  Ashley Chekhova  <giraffe.commits@aol.com>

	PR tree-optimization/92408
	* tree-ssa-forwprop.cc (optimize_strlen_comp): Rewrite
	strlen(s) == 0 as *s == 0 and strlen(s) != 0 as *s != 0.
	(simplify_builtin_call): Added call to optimize_strlen_comp.

2026-07-25  Robin Dapp  <robin.dapp@oss.qualcomm.com>

	PR target/126334
	* config/riscv/riscv-v.cc (get_gather_scatter_code): Use ordered
	indexed stores.

2026-07-25  Kael Andrew Alonzo Franco  <kaelfandrew@gmail.com>

	PR middle-end/125507
	* cfgloop.h (class loop): Remove ENUM_BITFIELD.
	* cgraph.h (struct toplevel_node): Ditto.
	(struct symtab_node): Ditto.
	(struct cgraph_node): Ditto.
	* combine.cc (struct reg_stat_type): Ditto.
	* config/i386/i386.h (struct machine_function): Ditto.
	* cse.cc (struct qty_table_elem): Ditto.
	(struct table_elt): Ditto.
	(struct set): Ditto.
	* df.h (struct df_mw_hardreg): Ditto.
	(struct df_base_ref): Ditto.
	* domwalk.h (class dom_walker): Ditto.
	* dwarf2out.h (struct dw_val_node): Ditto.
	* gimple.h (struct gimple): Ditto.
	* ipa-predicate.h (struct expr_eval_op): Ditto.
	(struct condition): Ditto.
	* ipa-ref.h (struct ipa_ref): Ditto.
	* ira-int.h (struct ira_dependent_filter): Ditto.
	(struct ira_allocno): Ditto.
	* lra-int.h (struct lra_operand_data): Ditto.
	(struct lra_insn_reg): Ditto.
	* optabs.h (class expand_operand): Ditto.
	* recog.h (struct operand_alternative): Ditto.
	(struct insn_operand_data): Ditto.
	* ree.cc (struct ext_modified): Ditto.
	* regrename.h (struct du_chain): Ditto.
	* rtl.h (struct rtx_def): Ditto.
	* sched-int.h (struct _dep): Ditto.
	* tree-into-ssa.cc (struct common_info): Ditto.
	* tree-ssa-loop-ivopts.cc (struct iv_cand): Ditto.
	* tree-ssa-sccvn.h (struct vn_nary_op_s): Ditto.
	(struct vn_reference_op_struct): Ditto.
	* value-range-storage.h (class vrange_storage): Ditto.
	* value-range.h (class vrange): Ditto.
	* var-tracking.cc (struct variable): Ditto.
	* vmsdbg.h (struct _DST_HEADER): Ditto.

2026-07-24  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	* print-rtl.cc (print_exp): Avoid -Wempty-body warning.

2026-07-24  H.J. Lu  <hjl.tools@gmail.com>
	    Uros Bizjak  <ubizjak@gmail.com>

	PR target/126320
	* config/i386/i386.cc (ix86_spill_register_argument_p): New
	function.
	(ix86_argument_passed_on_stack_p): Add a pattern argument.  Call
	ix86_spill_register_argument_p to check spill of register argument
	by callee.
	(ix86_update_stack_alignment): Pass pat to
	ix86_argument_passed_on_stack_p.

2026-07-24  Kael Andrew Alonzo Franco  <kaelfandrew@gmail.com>

	PR middle-end/126363
	* builtins.cc (fold_builtin_atomic_always_lock_free): Replace
	INTEGER_CST + expand_normal with tree_to_uwhi.

2026-07-24  Tobias Burnus  <tburnus@baylibre.com>

	* config/gcn/mkoffload.cc (main): Pass -L<dir> on to the
	device compiler.

2026-07-24  Pengfei Li  <Pengfei.Li2@arm.com>

	* config/aarch64/tuning_models/neoversev2.h: Update the costs
	of SVE structure loads and stores.

2026-07-24  Richard Biener  <rguenther@suse.de>

	PR target/126328
	PR target/126383
	* config/i386/i386.md (cost_special): New attribute.
	* config/i386/sse.md (avx_h<insn>v4df3): Add cost_special
	attribute with value haddsub.
	(*sse3_haddv2df3): Likewise.
	(sse3_hsubv2df3): Likewise.
	(*sse3_haddv2df3_low): Likewise.
	(*sse3_hsubv2df3_low): Likewise.
	(avx_h<insn>v8sf3): Likewise.
	(sse3_h<insn>v4sf3): Likewise.
	* config/i386/i386.cc (ix86_insn_cost): Cost insns with
	the cost_special attribute value of haddsub like an add.

2026-07-24  Richard Biener  <rguenther@suse.de>

	* tree-vect-slp.cc (vect_build_slp_tree_1): Remove failure
	on unvectorizable shifts.

2026-07-24  Richard Biener  <rguenther@suse.de>

	PR target/126328
	* combine.cc (combine_validate_cost): New arguments for
	the insn codes.  Set INSN_CODE to recognized values
	before calling insn_cost.
	(try_combine): Adjust.

2026-07-24  Roger Sayle  <roger@nextmovesoftware.com>
	    Hongtao Liu  <hongtao.liu@intel.com>

	* config/i386/i386-expand.cc (ix86_expand_vec_set_builtin): Don't
	force op1 to a register when it is CONST0_RTX (mode1).
	(ix86_expand_vector_set_var): For now, force VAL to a register.
	(ix86_expand_vector_set): If val is CONST0_RTX, expand using
	the new sse4_1_insertps_v4s[if]_zero patterns on TARGET_SSE4_1.
	Otherwise, force val to a register (restoring previous behaviour).
	* config/i386/sse.md (sse4_1_insertps_<mode>_zero): New insn
	using vec_merge to select which elements to clear/preserve.
	(vec_set<mode>): Tweak operand 1 to allow both REGs and CONST0_RTX.

2026-07-24  Philipp Tomsich  <philipp.tomsich@vrull.eu>

	* ifcvt.cc (noce_emit_store_flag): Document that a NULL_RTX
	return signals an unreversible condition.
	(noce_try_store_flag): Drop redundant noce_reversed_cond_code
	pre-check.
	(noce_try_shifted_store_flag): Likewise.
	(noce_try_store_flag_constants): Drop redundant can_reverse
	guards on the reversed 2^n and -1 cases.
	(noce_try_store_flag_mask): Set reversep unconditionally; the
	store-flag emission now handles an unreversible condition.

2026-07-23  John David Anglin  <danglin@gcc.gnu.org>

	* crc-verification.cc (sb_match): Use HOST_SIZE_T_PRINT_UNSIGNED
	instead of "%zu".
	(lfsr_and_crc_bits_match): Likewise.

2026-07-23  Surya Kumari Jangala  <jskumari@linux.ibm.com>

	* config/rs6000/mma.md (UNSPEC_DMF_DMXVF16GERX2): New UNSPEC entry.
	(UNSPEC_DMF_DMXVF16GERX2PP): Likewise.
	(UNSPEC_DMF_DMXVF16GERX2PN): Likewise.
	(UNSPEC_DMF_DMXVF16GERX2NP): Likewise.
	(UNSPEC_DMF_DMXVF16GERX2NN): Likewise.
	(UNSPEC_DMF_PMDMXVF16GERX2): Likewise.
	(UNSPEC_DMF_PMDMXVF16GERX2PP): Likewise.
	(UNSPEC_DMF_PMDMXVF16GERX2PN): Likewise.
	(UNSPEC_DMF_PMDMXVF16GERX2NP): Likewise.
	(UNSPEC_DMF_PMDMXVF16GERX2NN): Likewise.
	(DMF_PV): Add UNSPEC_DMF_DMXVF16GERX2.
	(DMF_DPV): Add f16 variants.
	(DMF_PVI8I4I2): Add UNSPEC_DMF_PMDMXVF16GERX2.
	(DMF_DPVI8I4I2): Add f16 prefixed variants.
	(pv): Add dmxvf16gerx2 attribute.
	(dpv): Add f16 attributes.
	(pvi8i4i2): Add pmdmxvf16gerx2 attribute.
	(dpvi8i4i2): Add f16 prefixed attributes.
	* config/rs6000/rs6000-builtins.def (__builtin_mma_dmxvf16gerx2): New
	builtin.
	(__builtin_mma_dmxvf16gerx2pp): Likewise.
	(__builtin_mma_dmxvf16gerx2pn): Likewise.
	(__builtin_mma_dmxvf16gerx2np): Likewise.
	(__builtin_mma_dmxvf16gerx2nn): Likewise.
	(__builtin_mma_pmdmxvf16gerx2): Likewise.
	(__builtin_mma_pmdmxvf16gerx2pp): Likewise.
	(__builtin_mma_pmdmxvf16gerx2pn): Likewise.
	(__builtin_mma_pmdmxvf16gerx2np): Likewise.
	(__builtin_mma_pmdmxvf16gerx2nn): Likewise.
	(__builtin_mma_dmxvf16gerx2_internal): New internal builtin.
	(__builtin_mma_dmxvf16gerx2pp_internal): Likewise.
	(__builtin_mma_dmxvf16gerx2pn_internal): Likewise.
	(__builtin_mma_dmxvf16gerx2np_internal): Likewise.
	(__builtin_mma_dmxvf16gerx2nn_internal): Likewise.
	(__builtin_mma_pmdmxvf16gerx2_internal): Likewise.
	(__builtin_mma_pmdmxvf16gerx2pp_internal): Likewise.
	(__builtin_mma_pmdmxvf16gerx2pn_internal): Likewise.
	(__builtin_mma_pmdmxvf16gerx2np_internal): Likewise.
	(__builtin_mma_pmdmxvf16gerx2nn_internal): Likewise.
	* doc/extend.texi (PowerPC Matrix-Multiply Assist Built-in Functions):
	Document new MMA+ builtins for f16 operations.

2026-07-23  Odysseas Georgoudis  <odygrd@hotmail.com>

	PR middle-end/122715
	* match.pd: Fold IFN_AVG_FLOOR and IFN_AVG_CEIL with equal
	operands.

2026-07-23  Philipp Tomsich  <philipp.tomsich@vrull.eu>

	PR rtl-optimization/126347
	* ifcvt.cc (noce_emit_store_flag): Return NULL_RTX when the
	comparison code is UNKNOWN.

2026-07-23  Surya Kumari Jangala  <jskumari@linux.ibm.com>

	* config/rs6000/mma.md (UNSPEC_DMF_DMXVI8GERX4SPP): New UNSPEC entry.
	(UNSPEC_DMF_PMDMXVI8GERX4SPP): Likewise.
	(UNSPEC_DMF_DMXVBF16GERX2): Likewise.
	(UNSPEC_DMF_DMXVBF16GERX2PP): Likewise.
	(UNSPEC_DMF_DMXVBF16GERX2PN): Likewise.
	(UNSPEC_DMF_DMXVBF16GERX2NP): Likewise.
	(UNSPEC_DMF_DMXVBF16GERX2NN): Likewise.
	(UNSPEC_DMF_PMDMXVBF16GERX2): Likewise.
	(UNSPEC_DMF_PMDMXVBF16GERX2PP): Likewise.
	(UNSPEC_DMF_PMDMXVBF16GERX2PN): Likewise.
	(UNSPEC_DMF_PMDMXVBF16GERX2NP): Likewise.
	(UNSPEC_DMF_PMDMXVBF16GERX2NN): Likewise.
	(DMF_PV): Add UNSPEC_DMF_DMXVBF16GERX2.
	(DMF_DPV): Add bf16 and int8 signed accumulate variants.
	(DMF_DPVI8I4I4): Add UNSPEC_DMF_PMDMXVI8GERX4SPP.
	(DMF_PVI8I4I2): New int iterator.
	(DMF_DPVI8I4I2): Likewise.
	(pv): Add dmxvbf16gerx2 attribute.
	(apv): Removed dmxvi8gerx4pp attribute.
	(dpv): New attribute.
	(dpvi8i4i4): Add pmdmxvi8gerx4spp attribute.
	(pvi8i4i2): New attribute.
	(dpvi8i4i2): Likewise.
	(dmf_<dpv>): Rename from dmf_<apv> and update to use dpv attribute.
	(dmf_<pvi8i4i2>): New insn pattern.
	(dmf_<dpvi8i4i2>): Likewise.
	* config/rs6000/rs6000-builtins.def (__builtin_mma_dmxvi8gerx4spp): New
	builtin.
	(__builtin_mma_pmdmxvi8gerx4spp): Likewise.
	(__builtin_mma_dmxvbf16gerx2): Likewise.
	(__builtin_mma_dmxvbf16gerx2pp): Likewise.
	(__builtin_mma_dmxvbf16gerx2pn): Likewise.
	(__builtin_mma_dmxvbf16gerx2np): Likewise.
	(__builtin_mma_dmxvbf16gerx2nn): Likewise.
	(__builtin_mma_pmdmxvbf16gerx2): Likewise.
	(__builtin_mma_pmdmxvbf16gerx2pp): Likewise.
	(__builtin_mma_pmdmxvbf16gerx2pn): Likewise.
	(__builtin_mma_pmdmxvbf16gerx2np): Likewise.
	(__builtin_mma_pmdmxvbf16gerx2nn): Likewise.
	(__builtin_mma_dmxvi8gerx4spp_internal): New internal builtin.
	(__builtin_mma_pmdmxvi8gerx4spp_internal): Likewise.
	(__builtin_mma_dmxvbf16gerx2_internal): Likewise.
	(__builtin_mma_dmxvbf16gerx2pp_internal): Likewise.
	(__builtin_mma_dmxvbf16gerx2pn_internal): Likewise.
	(__builtin_mma_dmxvbf16gerx2np_internal): Likewise.
	(__builtin_mma_dmxvbf16gerx2nn_internal): Likewise.
	(__builtin_mma_pmdmxvbf16gerx2_internal): Likewise.
	(__builtin_mma_pmdmxvbf16gerx2pp_internal): Likewise.
	(__builtin_mma_pmdmxvbf16gerx2pn_internal): Likewise.
	(__builtin_mma_pmdmxvbf16gerx2np_internal): Likewise.
	(__builtin_mma_pmdmxvbf16gerx2nn_internal): Likewise.
	* doc/extend.texi (PowerPC Matrix-Multiply Assist Built-in Functions):
	Document new MMA+ builtins for int8 and bf16 operations.

2026-07-23  Surya Kumari Jangala  <jskumari@linux.ibm.com>

	* config/rs6000/rs6000-builtins.def (__builtin_dmr_extract512): New
	built-in.
	(__builtin_disassemble_dmr): Likewise.
	(__builtin_dmr_extract512_internal): New internal built-in.
	* config/rs6000/rs6000-builtin.cc (rs6000_gimple_fold_mma_builtin):
	Exempt RS6000_BIF_DISASSEMBLE_DMR from the early-return guard.
	Generate appropriate gimple code for the extract builtins.

2026-07-23  Tobias Burnus  <tburnus@baylibre.com>

	* config/gcn/gcn-devices.def (gfx9-4-generic): Set sram-ecc
	default to HSACO_ATTR_ANY.

2026-07-23  Jakub Jelinek  <jakub@redhat.com>

	* configure.ac: Fix a typo, respones -> response.
	* configure: Regenerate.

2026-07-23  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* configure.ac (HAVE_GAS_SECTION_LINK_ORDER): Clarify comment.
	* config.in: Regenerate.
	* doc/sourcebuild.texi (Effective-Target Keywords)
	(o_flag_in_section): Rename to shf_link_order.  Update description.

2026-07-23  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/126028
	* tree-vect-slp.cc (vect_slp_check_for_roots): Move
	fold-left reduction check ...
	(vectorizable_bb_reduc_epilogue): ... here and allow
	two reduction lanes to be unaffected.  Handle the two
	vector lane without target support for the reduction.
	(vectorize_slp_instance_root_stmt): Implement manual two-lane
	reduction.

2026-07-23  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* configure.ac (HAVE_GAS_SHF_GNU_RETAIN): Clarify comment.
	* config.in: Regenerate.
	* doc/sourcebuild.texi (Effective-Target Keywords)
	(R_flag_in_section): Remove.
	(Effective-Target Keywords, gnu_retain): New keyword.
	(Effective-Target Keywords, shf_gnu_retain): Likewise.
	(Effective-Target Keywords, sht_init_array): Likewise.

2026-07-23  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* doc/sourcebuild.texi (Effective-Target Keywords, Other
	attributes): Document solaris_ld.

2026-07-23  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* doc/sourcebuild.texi (Effective-Target Keywords, Other
	attributes): Document solaris_as.

2026-07-23  Hu, Lin1  <lin1.hu@intel.com>

	* config/i386/avx10_2satcvtintrin.h
	(_mm_cvtts_sd_i32): Renamed from _mm_cvtts_sd_epi32.
	(_mm_cvtts_sd_si32): New alias of _mm_cvtts_sd_i32.
	(_mm_cvtts_sd_u32): Renamed from _mm_cvtts_sd_epu32.
	(_mm_cvtts_ss_i32): Renamed from _mm_cvtts_ss_epi32.
	(_mm_cvtts_ss_si32): New alias of _mm_cvtts_ss_i32.
	(_mm_cvtts_ss_u32): Renamed from _mm_cvtts_ss_epu32.
	(_mm_cvtts_roundsd_i32): Renamed from _mm_cvtts_roundsd_epi32.
	(_mm_cvtts_roundsd_si32): New alias of _mm_cvtts_roundsd_i32.
	(_mm_cvtts_roundsd_u32): Renamed from _mm_cvtts_roundsd_epu32.
	(_mm_cvtts_roundss_i32): Renamed from _mm_cvtts_roundss_epi32.
	(_mm_cvtts_roundss_si32): New alias of _mm_cvtts_roundss_i32.
	(_mm_cvtts_roundss_u32): Renamed from _mm_cvtts_roundss_epu32.
	(_mm_cvtts_sd_i64): Renamed from _mm_cvtts_sd_epi64.
	(_mm_cvtts_sd_si64): New alias of _mm_cvtts_sd_i64.
	(_mm_cvtts_sd_u64): Renamed from _mm_cvtts_sd_epu64.
	(_mm_cvtts_ss_i64): Renamed from _mm_cvtts_ss_epi64.
	(_mm_cvtts_ss_si64): New alias of _mm_cvtts_ss_i64.
	(_mm_cvtts_ss_u64): Renamed from _mm_cvtts_ss_epu64.
	(_mm_cvtts_roundsd_i64): Renamed from _mm_cvtts_roundsd_epi64.
	(_mm_cvtts_roundsd_si64): New alias of _mm_cvtts_roundsd_i64.
	(_mm_cvtts_roundsd_u64): Renamed from _mm_cvtts_roundsd_epu64.
	(_mm_cvtts_roundss_i64): Renamed from _mm_cvtts_roundss_epi64.
	(_mm_cvtts_roundss_si64): New alias of _mm_cvtts_roundss_i64.
	(_mm_cvtts_roundss_u64): Renamed from _mm_cvtts_roundss_epu64.

2026-07-23  liuhongt  <hongtao.liu@intel.com>

	PR target/126160
	* config/i386/sse.md (lrint<ssePSmode2lower><mode>2): New expander.
	(lrintv2sfv2di2): Likewise.
	(ssedfsimode): New mode attribute.
	(ssedfsimodelower): Likewise.
	(lrint<mode><ssedfsimodelower>2): New expander.

2026-07-23  Avinash Jayakar  <avinashd@linux.ibm.com>
	    Vijay Shankar  <vijay@linux.ibm.com>

	* config/rs6000/mma.md (mma_xxsetaccz): Use wD constraint and
	accumulator operand.
	(mma_<vv>): Likewise.
	(mma_<avv>): Likewise.
	(mma_<pv>): Likewise.
	(mma_<apv>): Likewise.
	(mma_<vvi4i4i8>): Likewise.
	(mma_<avvi4i4i8>): Likewise.
	(mma_<vvi4i4i2>): Likewise.
	(mma_<avvi4i4i2>): Likewise.
	(mma_<vvi4i4>): Likewise.
	(mma_<avvi4i4>): Likewise.
	(mma_<pvi4i2>): Likewise.
	(mma_<apvi4i2>): Likewise.
	(mma_<vvi4i4i4>): Likewise.
	(mma_<avvi4i4i4>): Likewise.
	* config/rs6000/rs6000.cc (print_operand): Print DMR register
	numbers if dense math option enabled.

2026-07-23  Aldy Hernandez  <aldy@quesejoda.com>

	* value-range.cc (frange_cmp): New.
	(frange::combine_zeros): Remove.
	(frange::union_): Use frange_cmp to merge endpoints.
	(frange::intersect): Likewise.
	(frange::contains_p): Use frange_cmp.
	(frange::verify_range): Use frange_cmp.
	* value-range.h (class frange): Remove combine_zeros.

2026-07-23  Peter Bergner  <bergner@linux.ibm.com>
	    Surya Kumari Jangala  <jskumari@linux.ibm.com>
	    Kishan Parmar  <kishan@linux.ibm.com>

	* config/rs6000/mma.md (MAX_MMA_OPERANDS): Increase from 7 to 9.
	(UNSPEC_DMF_DMXOR): New unspec.
	(UNSPEC_DMF_DMXVI8GERX4): Likewise.
	(UNSPEC_DMF_DMXVI8GERX4PP): Likewise.
	(UNSPEC_DMF_PMDMXVI8GERX4): Likewise.
	(UNSPEC_DMF_PMDMXVI8GERX4PP): Likewise.
	(UNSPEC_DMF_DMSETDMRZ): Likewise.
	(DMF_PV): New iterator.
	(DMF_DPV): Likewise.
	(DMF_PVI8I4I4): Likewise.
	(DMF_DPVI8I4I4): Likewise.
	(pv): Add DMF mappings.
	(apv): Likewise.
	(pvi8i4i4): New attribute.
	(dpvi8i4i4): Likewise.
	(dmf_build_dmr): New define_expand.
	(dmf_dmsetdmrz): New insn.
	(dmf_dmxor): Likewise.
	(dmf_<pv>): New insn pattern.
	(dmf_<apv>): Likewise.
	(dmf_<pvi8i4i4>): Likewise.
	(dmf_<dpvi8i4i4>): Likewise.
	* config/rs6000/rs6000-builtin.cc (rs6000_gimple_fold_mma_builtin): Add
	DMF builtin support. Handle DMR pass-by-reference semantics.
	Support up to nine builtin operands.
	(mma_expand_builtin): Likewise.
	(rs6000_expand_builtin): Handle DMF builtins.
	* config/rs6000/rs6000-builtins.def: Add DMF and MMA+ builtin
	definitions.
	* doc/extend.texi
	(PowerPC Matrix-Multiply Assist Built-in Functions): Document
	MMA+ builtins.
	(PowerPC Dense Math Facility Built-in Functions): Document DMF builtins.

2026-07-23  Manjunath Matti  <mmatti@linux.ibm.com>

	* config/rs6000/rs6000.h (RS6000_BTI_dmr1024): New enumerator.
	(RS6000_BTI_ptr_dmr1024): New enumerator.
	(dmr1024_type_node): New macro.
	(ptr_dmr1024_type_node): New macro.
	* config/rs6000/rs6000-builtin.cc (rs6000_type_string): Handle
	dmr1024_type_node.
	(rs6000_init_builtins): Register the __dmr1024 opaque type and
	its pointer-to-const variant, with 512-bit alignment.
	* config/rs6000/rs6000.cc (rs6000_mangle_type): Handle
	dmr1024_type_node.
	(rs6000_invalid_conversion): Reject conversions to/from TDOmode.
	(rs6000_opaque_type_invalid_use_p): Gate __vector_quad and
	__vector_pair on TARGET_MMA and __dmr1024 on TARGET_DMF
	independently, and require -mdense-math for __dmr1024.

2026-07-23  Filip Kastl  <fkastl@suse.cz>

	* lto-streamer.h: Remove the field 'stream_linemap_order' from
	the class 'lto_location_cache'.

2026-07-23  Pan Li  <pan2.li@intel.com>

	* config/riscv/vector.md: Leverage Wvr constraint.

2026-07-23  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	* tree-ssa-phiopt.cc (factor_out_all): Call
	cond_store_replacement_limited too.

2026-07-23  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	* tree-eh.cc (lhs_could_trap_p): New function.
	* tree-eh.h (lhs_could_trap_p): New decl.
	* tree-ssa-phiopt.cc (copy_mem_with_alias_set_zero): New function.
	(cond_store_replacement_limited): New function.
	(pass_cselim::execute): Call cond_store_replacement_limited before

2026-07-22  Aldy Hernandez  <aldy@quesejoda.com>

	* value-range.cc (frange::flush_denormals_to_zero): Collapse a
	denormal endpoint to the zero of the same sign and defer the sign
	to canonicalize_zeros.
	(frange::canonicalize_zeros): New.
	(frange::set): Use it.
	(range_tests_flush_denormals): New.
	(range_tests_floats): Call it.
	* value-range.h (class frange): Declare canonicalize_zeros.

2026-07-22  Vijay Shankar  <vijay@linux.ibm.com>

	* config/rs6000/mma.md (*movxo): renamed to movxo_nodmf
	(*movxo_nodmf): updated contraint to use wD and add !TARGET_DMF
	(*movxo_dmf): New pattern to handle dmf insert/extract from vsx

2026-07-22  Richard Biener  <rguenther@suse.de>

	* tree-vect-slp.cc (vect_schedule_slp_node): Simplify scheduling.

2026-07-22  Richard Biener  <rguenther@suse.de>

	* tree-vect-slp.cc (vect_schedule_slp_node): Correct in-region
	stmt check.

2026-07-22  Surya Kumari Jangala  <jskumari@linux.ibm.com>
	    Peter Bergner  <bergner@linux.ibm.com>

	* config/rs6000/mma.md (UNSPEC_DMR_RELOAD_FROM_MEMORY): New unspec.
	(UNSPEC_DMR_RELOAD_TO_MEMORY): Likewise.
	(reload_tdo_load): New define_insn_and_split.
	(reload_tdo_store): Likewise.
	* config/rs6000/rs6000.cc (rs6000_init_hard_regno_mode_ok): Set
	reload_load and reload_store for TDOmode when TARGET_DMF.

2026-07-22  Tobias Burnus  <tburnus@baylibre.com>

	* doc/invoke.texi (-fopenmp-ompt): Add 'scope' construct.
	(-fopenmp-ompt-detailed): Fix typo.

2026-07-22  Jeevitha Palanisamy  <jeevitha@linux.ibm.com>

	* config/rs6000/mma.md (UNSPEC_DMF_EXTRACT512): New unspec.
	(dm_extract512): New insn.
	(movtdo): New expander.
	(*movtdo): New insn_and_split to support TDOmode moves between
	memory, VSX registers, and Dense Math Registers.
	* config/rs6000/rs6000.cc (rs6000_emit_move): Diagnose constant
	assignments to TDOmode objects.
	(rs6000_split_multireg_move): Handle TDOmode when splitting
	multi-register moves.

2026-07-22  Kishan Parmar  <kishan@linux.ibm.com>

	* config/rs6000/mma.md (UNSPEC_DMF_INSERT512): New unspec.
	(UNSPEC_DMF_INSERT1024): Likewise.
	(movoo): Enable for TARGET_DMF.
	(*movoo): Likewise.
	(vsx_assemble_pair): Likewise.
	(*vsx_assemble_pair): Likewise.
	(vsx_disassemble_pair): Likewise.
	(*vsx_disassemble_pair): Likewise.
	(dm_insert512): New insn.
	(dm_insert1024): Likewise.
	(mma_assemble_acc): Use accumulator_operand.
	Build accumulators via DMR insert operations when TARGET_DMF.
	(*mma_assemble_acc): Use accumulator_operand.
	(mma_<acc>): New define_expand treating xxmtacc/xxmfacc as no-ops
	for TARGET_DMF.
	(*mma_<acc>): Restrict to !TARGET_DMF and use accumulator_operand.
	(mma_disassemble_acc): Use accumulator_operand.
	* config/rs6000/predicates.md (dmr_register_operand): New predicate.
	(gpc_reg_operand): Accept DMR registers.
	* config/rs6000/rs6000-builtin.cc (rs6000_gimple_fold_mma_builtin): Do
	not emit xxmfacc for DISASSEMBLE_ACC when TARGET_DMF.
	* config/rs6000/rs6000.cc (rs6000_hard_regno_mode_ok_uncached): Allow
	OOmode in VSX register pairs for TARGET_DMF.
	(rs6000_split_multireg_move): Avoid emitting xxmtacc/xxmfacc when
	TARGET_DMF.
	* config/rs6000/rs6000.md (type): Add dmf type.
	(isa): Add mma and dmf ISA attributes.
	(enabled): Add mma and dmf enable conditions.

2026-07-22  Juergen Christ  <jchrist@linux.ibm.com>

	* config/s390/s390-protos.h (s390_expand_vec_compare_gen_cc):
	New function.
	* config/s390/s390.cc (s390_expand_vec_compare_cc): Extract
	part of this function into a ...
	(s390_expand_vec_compare_gen_cc): ... new function.
	* config/s390/vector.md (vec_cbranch_any<mode>): Implement.
	(vec_cbranch_all<mode>): Implement.

2026-07-22  Avinash Jayakar  <avinashd@linux.ibm.com>

	* config/rs6000/constraints.md
	(rs6000_constraints[RS6000_CONSTRAINT_wD]): New wD constraint.
	* config/rs6000/predicates.md (accumulator_operand): New predicate.
	* config/rs6000/rs6000.cc (rs6000_debug_reg_global): Support wD
	register class.
	(rs6000_init_hard_regno_mode_ok): Map wD to FLOAT_REGS.
	* config/rs6000/rs6000.h (enum r6000_reg_class_enum): Add wD constraint.
	* doc/md.texi: Document the new constraint.

2026-07-22  Surya Kumari jangala  <jskumari@linux.ibm.com>

	* config/rs6000/rs6000.cc (enum rs6000_reg_type): Add DMR_REG_TYPE.
	(enum rs6000_reload_reg_type): Add RELOAD_REG_DMR.
	(LAST_RELOAD_REG_CLASS): Update to RELOAD_REG_DMR.
	(reload_reg_map): Add DMR entry.
	(rs6000_reg_names): Add DMR register names.
	(alt_reg_names): Add alternate DMR register names.
	(rs6000_hard_regno_nregs_internal): Handle DMR registers.
	(rs6000_hard_regno_mode_ok_uncached): Add TDOmode and XOmode support for
	DMR registers.
	(rs6000_debug_reg_global): Add TDOmode to debug modes and print DMR
	register range.
	(rs6000_setup_reg_addr_masks): Handle RELOAD_REG_DMR.
	Allow offset loads for TDOmode values.
	(rs6000_init_hard_regno_mode_ok): Add DMR_REGS to reg_class_to_reg_type
	mapping.
	Update precalculation of CLASS_MAX_NREGS.
	(rs6000_secondary_reload_memory): Handle DMR_REGS class.
	(rs6000_secondary_reload_simple_move): Add DMR to VSX moves.
	(rs6000_preferred_reload_class): Handle DMR_REGS.
	(rs6000_modes_tieable_p): Exclude TDOmode from register tying.
	(reg_offset_addressing_ok_p): Allow XOmode with TARGET_DMF.
	Add TDOmode support with TARGET_DMF.
	(rs6000_secondary_reload_class): Handle DMR_REGS reload routing.
	(rs6000_dmr_register_move_cost): New helper.
	(rs6000_register_move_cost): Handle DMR_REGS as source or destination.
	(rs6000_memory_move_cost): Add DMR_REGS case routing cost through VSX.
	(rs6000_compute_pressure_classes): Add DMR_REGS when TARGET_DMF.
	(rs6000_debugger_regno): Add DMR register numbering.
	* config/rs6000/rs6000.h (UNITS_PER_DMR_WORD): Define as 128.
	(FIRST_PSEUDO_REGISTER): Increase from 111 to 119.
	(FIXED_REGISTERS): Add 8 DMR registers as non-fixed.
	(CALL_USED_REGISTERS): Mark all DMR registers as call-used.
	(REG_ALLOC_ORDER): Add DMR registers to allocation order.
	(DMR_REGNO_P): New macro.
	(VECTOR_ALIGNMENT_P): Add TDOmode.
	(enum reg_class): Add DMR_REGS entry.
	(REG_CLASS_CONTENTS): Add DMR_REGS bitmask.
	(REGISTER_NAMES): Add dmr0-dmr7 register names.
	(ADDITIONAL_REGISTER_NAMES): Add dmr0-dmr7 mappings.
	* config/rs6000/rs6000.md (FIRST_DMR_REGNO): Define as 111.
	(LAST_DMR_REGNO): Define as 118.

2026-07-21  Torbjörn SVENSSON  <torbjorn.svensson@foss.st.com>

	PR tree-optimization/124663
	* match.pd: Fold constant conditional selects.

2026-07-21  Tamar Christina  <tamar.christina@arm.com>

	* config/aarch64/aarch64.cc (aarch64_fold_while_ult_to_ptrue): New.
	(aarch64_instruction_selection): Use it.

2026-07-21  Tamar Christina  <tamar.christina@arm.com>

	* config/aarch64/aarch64-acle-builtins.cc
	(gimple_folder::fold_to_vl_pred): Refactor folding logic into
	aarch64_fold_sve_ptrue_vl.
	* config/aarch64/aarch64-protos.h (aarch64_fold_sve_ptrue_vl): New.
	* config/aarch64/aarch64.cc (aarch64_instruction_selection): Move down.
	(aarch64_fold_sve_ptrue_vl): New.

2026-07-21  Tamar Christina  <tamar.christina@arm.com>

	* gimple-isel.cc (pass_gimple_isel::execute): Enable and disable ranger
	on fun.

2026-07-21  Takayuki 'January June' Suwa  <jjsuwa_sys3175@yahoo.co.jp>

	* config/xtensa/xtensa.cc (xtensa_legitimize_address):
	Completely rewrite it into an equivalent but more easily under-
	standable description.

2026-07-21  Takayuki 'January June' Suwa  <jjsuwa_sys3175@yahoo.co.jp>

	* config/xtensa/xtensa.h (LOCAL_REGNO):
	New macro definition.

2026-07-21  Tamar Christina  <tamar.christina@arm.com>

	* tree-vect-slp-patterns.cc (compatible_complex_nodes_p): Support
	mismatched group sizes and use group size to iterate.
	* tree-vect-slp.cc (vect_build_slp_instance,
	vect_analyze_slp_reduc_chain, vect_analyze_slp_reduction,
	vect_analyze_slp_reduction_group, vect_analyze_slp_instance,
	vect_analyze_slp): Compare against lanes instead of .length ().
	(vect_optimize_slp_pass::get_result_with_layout): replace .length ()
	with .exist ().
	(vect_transform_slp_perm_load_1): Use lanes instead of .length ().
	(vect_remove_slp_scalar_calls): Replace iterators.
	* tree-vect-stmts.cc (vectorizable_shift): Use group size over ops
	length.

2026-07-21  Jeevitha Palanisamy  <jeevitha@linux.ibm.com>
	    Kishan Parmar  <kishan@linux.ibm.com>

	* config/rs6000/rs6000.cc (print_operand): Add the `%W`
	print modifier to print the VSX register number plus two.

2026-07-21  Pan Li  <pan2.li@intel.com>

	* config/riscv/vector.md: Leverage Wvr constraint.

2026-07-21  Kyrylo Tkachov  <ktkachov@nvidia.com>

	PR middle-end/126341
	* tree-outof-ssa.cc (split_overlapping_partition_decls): Preserve
	DECL_IGNORED_P.  Check that the replacement uses memory.

2026-07-21  Richard Biener  <rguenther@suse.de>

	* simplify-rtx.cc (simplify_context::simplify_binary_operation_1):
	Simplify scalar vec_select of vec_concat.

2026-07-21  Robin Dapp  <robin.dapp@oss.qualcomm.com>

	* doc/md.texi: Document that scatters are left-to-right.

2026-07-21  Roger Sayle  <roger@nextmovesoftware.com>
	    Uros Bizjak  <ubizjak@gmail.com>

	* config/i386/sse.md (define_split): Split *vec_extractv2di_0_sse
	before reload on !TARGET_64BIT with TARGET_SSE2.
	(define_split): Likewise split *vec_concatv2di_0 before reload
	on !TARGET_64BIT with TARGET_SSE2.

2026-07-21  H.J. Lu  <hjl.tools@gmail.com>

	PR target/125297
	* config/i386/i386.cc (init_cumulative_args): Don't set
	cum->preserve_none_abi to true for MS ABI functions.
	* doc/extend.texi: Update x86-64 preserve_none attribute
	documentation.

2026-07-20  Kael Andrew Alonzo Franco  <kaelfandrew@gmail.com>

	PR tree-optimization/64992
	* match.pd: Combine two patterns into for neeq (ne eq) and fix typo.

2026-07-20  Vineet Gupta  <vineet.gupta@linux.dev>

	* config/bpf/bpf.cc (bpf_insn_cost): Return pattern_cost () by default.

2026-07-20  Vineet Gupta  <vineet.gupta@linux.dev>

	* config/bpf/bpf.cc (bpf_rtx_costs): set CONST_INT 0 insns.
	* config/bpf/bpf.h (BPF_IMM32_P): New helper macro.
	* config/bpf/predicates.md (imm32_operand): Use new macro.

2026-07-20  Vineet Gupta  <vineet.gupta@linux.dev>

	* config/bpf/bpf.cc (bpf_rtx_costs): Assign MPY/DIV/MOD cost 1.

2026-07-20  Jakub Jelinek  <jakub@redhat.com>

	* gen-pass-instances.awk: Use [ \t] instead of [[:blank:]]
	for compatibility with mawk <= 1.3.3.

2026-07-20  Alex Coplan  <alex.coplan@arm.com>

	* config/aarch64/aarch64.cc (aarch64_handle_attr_isa_flags):
	Warn if +tme is enabled by the target attribute/pragma, relying
	on the feature flags from aarch64_parse_extension.
	(aarch64_process_target_attr): Drop +tme warning based on custom
	string parsing.

2026-07-20  Paul-Antoine Arras  <parras@baylibre.com>

	* builtin-types.def (BT_FN_VOID_ULONGLONG_ULONGLONG): New.
	(BT_FN_VOID_ULONGLONG_ULONGLONG_ULONGLONG_ULONGLONG_ULONGLONG):
	Remove.
	* omp-builtins.def (BUILT_IN_GOMP_LOOP_STATIC_WORKSHARING_DISPATCH,
	BUILT_IN_GOMP_DISTRIBUTE_STATIC_WORKSHARING_DISPATCH): Update
	signature.
	* omp-expand.cc (expand_omp_for_static_nochunk): Pass chunk start
	and iteration count instead of loop bounds.
	(expand_omp_for_static_chunk): Likewise.

2026-07-20  Paul-Antoine Arras  <parras@baylibre.com>

	* omp-builtins.def (BUILT_IN_GOMP_SCOPE_START_WITH_END): New
	builtin.
	(BUILT_IN_GOMP_SCOPE_END): Likewise.
	* omp-low.cc (lower_omp_scope): Emit calls to
	GOMP_scope_start_with_end and GOMP_scope_end when -fopenmp-ompt.

2026-07-20  Torbjörn SVENSSON  <torbjorn.svensson@foss.st.com>

	PR testsuite/126261
	* doc/sourcebuild.texi (can_deref_null): Document.

2026-07-20  Shreya Munnangi  <smunnang@qti.qualcomm.com>
	    Jeff Law  <jeffrey.law@oss.qualcomm.com>

	PR target/124741
	* config/riscv/constraints.md (B1, B2, B3, B4): New constraints for
	atomic loads with and without ZALASR & MEMMODEL_ACQUIRE.
	* config/riscv/iterators.md (cond_extend): New iterator to for use
	in extending atomic loads.
	* config/riscv/sync-rvwmo.md (atomic_load_rvwmo<mode>): Adjust
	contraints to enable folding small offsets into memory load.
	(atomic_store_rvwmo): Likewise.
	(extending atomic_load_rvwmo): New pattern.
	* config/riscv/sync-ztso.md (atomic_load_ztso<mode>): Adjust
	constraints to enable folding small offsets into memory load.
	(atomic_store_ztso): Likewise.
	(extending atomic_load_ztso): New pattern.

2026-07-20  Juergen Christ  <jchrist@linux.ibm.com>

	* config/s390/vector.md (VEC_SET_SINGLEFLOAT): Remove V1TF.

2026-07-20  Richard Biener  <rguenther@suse.de>

	PR target/126271
	* config/i386/i386-expand.cc (ix86_expand_reduc): Honor
	TARGET_V2DF_REDUCTION_PREFER_HADDPD and expand via
	gen_sse3_haddv2df3.

2026-07-20  Pan Li  <pan2.li@intel.com>

	* config/riscv/vector.md: Leverage Wvr constraint.

2026-07-20  Philipp Tomsich  <philipp.tomsich@vrull.eu>

	PR tree-optimization/126291
	* match.pd ((trunc)copysign ((extend)x, (extend)y) -> copysign
	(x, y), (trunc)copysign ((extend)x, CST) -> copysign (x, CST)):
	Use element_precision.

2026-07-19  Philipp Tomsich  <philipp.tomsich@vrull.eu>

	PR tree-optimization/126291
	* match.pd ((trunc)abs (extend x) -> abs (x)): Use
	element_precision. Require target ABS support for the
	vector case.

2026-07-19  Jiawei  <jiawei@iscas.ac.cn>

	* config/riscv/riscv-ext.def (svrsw60t59b): Add new extension.
	* config/riscv/riscv-ext.opt: Ditto.
	* doc/riscv-ext.texi: Ditto.

2026-07-19  Jiawei  <jiawei@iscas.ac.cn>

	* config/riscv/riscv-ext.def (ssqosid): Add new extension.
	* config/riscv/riscv-ext.opt: Ditto.
	* doc/riscv-ext.texi: Ditto.

2026-07-19  Jiawei  <jiawei@iscas.ac.cn>

	* config/riscv/riscv-ext.def (ssctr): Add new extension.
	* config/riscv/riscv-ext.opt: Ditto.
	* doc/riscv-ext.texi: Ditto.

2026-07-19  Jiawei  <jiawei@iscas.ac.cn>

	* config/riscv/riscv-ext.def (smctr): Add new extension.
	* config/riscv/riscv-ext.opt: Ditto.
	* doc/riscv-ext.texi: Ditto.

2026-07-19  Jiawei  <jiawei@iscas.ac.cn>

	* config/riscv/riscv-ext.def (smcdeleg): Add new extension.
	* config/riscv/riscv-ext.opt: Ditto.
	* doc/riscv-ext.texi: Ditto.

2026-07-19  Jiawei  <jiawei@iscas.ac.cn>

	* config/riscv/riscv-ext.def (ssccfg): Add new extension.
	* config/riscv/riscv-ext.opt: Ditto.
	* doc/riscv-ext.texi: Ditto.

2026-07-19  Jiawei  <jiawei@iscas.ac.cn>

	* config/riscv/riscv-ext.def (ziccamoc): Add new extension.
	* config/riscv/riscv-ext.opt: Ditto.
	* doc/riscv-ext.texi: Ditto.

2026-07-19  Jiawei  <jiawei@iscas.ac.cn>

	* config/riscv/riscv-ext.def (ziccid): Add new extension.
	* config/riscv/riscv-ext.opt: Ditto.
	* doc/riscv-ext.texi: Ditto.

2026-07-19  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	PR target/125731
	* ifcvt.cc (noce_cond_zero_binary_op_supported): Move earlier.
	(noce_try_shifted_store_flag): New function.
	(noce_process_if_block): Use it.

2026-07-19  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/126222
	* value-range-storage.cc (prange_storage::equal_p): Comment change.
	* value-range.h (prange::pt_equal_p): Use vrp_operand_equal_p.

2026-07-19  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/126212
	* value-relation.cc (dom_oracle::set_one_relation): Start with
	first dominator in the dominator search.
	(dom_oracle::recomputed_relation): New.
	(dom_oracle::find_relation_dom): query recomputed_relation.
	* value-relation.h (dom_oracle::recomputed_relation): New prototype.

2026-07-19  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/126212
	* range-op.cc (operator_logical_and::op1_range): Add case for
	[0, 0] = op1 & [1, 1]
	(operator_logical_or::op1_range): Add case for [1, 1] = op1 | [0, 0]

2026-07-18  Luke Zhuang  <luke.zhuang@linux.alibaba.com>
	    Kito Cheng  <kito.cheng@sifive.com>

	* config/riscv/riscv.md (@tlsdesc<mode>): Use individual
	RVVM1QI clobbers instead of four RVVM8QI.

2026-07-18  wangjue  <juewang@linux.alibaba.com>

	* config/riscv/riscv.cc (riscv_override_options_after_change): New
	function.
	(riscv_option_override): Call it.
	(TARGET_OVERRIDE_OPTIONS_AFTER_CHANGE): Define.

2026-07-18  Dusan Stojkovic  <Dusan.Stojkovic@rt-rk.com>

	PR target/123883
	* match.pd ((1<<N) & (1<<N) with different types): New
	pattern.

2026-07-18  Matt Turner  <mattst88@gmail.com>

	PR target/117184
	* lra-eliminations.cc (setup_can_eliminate): Mark the hard frame
	pointer live when setting frame_pointer_needed.

2026-07-18  Xi Ruoyao  <xry111@xry111.site>

	PR target/126200
	* config/loongarch/predicates.md
	(par_const_vector_shf_set_operand): Define as special predicate.
	* config/loongarch/lsx.md (lsx_vshuf4i_<lsxfmt_f>): Pass VIMODE
	to the predicate of selector.

2026-07-18  Pan Li  <pan2.li@intel.com>

	* config/riscv/vector.md: Leverage Wvr constraint.

2026-07-17  Iain Sandoe  <iain@sandoe.co.uk>

	* doc/sourcebuild.texi: Document aarch64_mbig_endian.

2026-07-17  Kael Andrew Alonzo Franco  <kaelfandrew@gmail.com>

	PR tree-optimization/126087
	* match.pd: Move tree_expr_nonnegative_p (@1) to tree_expr_nonnegative_p@1.

2026-07-17  Tobias Burnus  <tburnus@baylibre.com>

	* doc/invoke.texi (-fopenmp-ompt, -fopenmp-ompt-detailed): Improve
	wording.

2026-07-17  Richard Earnshaw  <rearnsha@arm.com>

	* config/aarch64/aarch64.cc (aarch64_override_options): Warn if
	+tme is used as an architecture feature
	(aarch64_process_target_attr): Similarly, but only if TME
	was previously disabled.
	* doc/invoke.texi (aarch64): Remove mentions of +tme.

2026-07-17  Matt Turner  <mattst88@gmail.com>

	* config/alpha/alpha.cc (alpha_cannot_copy_insn_p): Do not return
	false before reload_completed.  Update comment.

2026-07-17  Wang Yaduo  <wangyaduo@linux.alibaba.com>

	* config/riscv/riscv-cores.def (RISCV_CORE): Remove zama16b from
	xt-c9501fdvt.

2026-07-17  Lewis Hyatt  <lhyatt@gmail.com>

	PR middle-end/80922
	PR middle-end/106823
	PR lto/107936
	* lto-streamer-in.cc (lto_create_loc_map): Process diagnostic
	pragmas from the linemap sections.
	* lto-streamer-out.cc (location_output::produce_linemap_section):
	Stream diagnostic pragmas into the linemap section.

2026-07-17  Lewis Hyatt  <lhyatt@gmail.com>

	PR lto/65536
	* doc/lto.texi: Document the new LTO_section_linemap and the new
	option -fltrans-linemap-file.
	* lto-opts.cc (lto_write_options): Handle the new option.
	* opts.cc (gen_command_line_string): Likewise.
	* lto-section-in.cc (lto_section_name[]): Add new name for
	LTO_section_linemap.
	* lto-streamer-in.cc (get_location_from_idx): New function.
	(lto_location_cache::cmp_loc): Remove.
	(bp_unpack_delta): New function.
	(create_loc_map): New function.
	(get_loc_map): New function.
	(lto_location_cache::override_loc_map): New function.
	(lto_location_cache::apply_location_cache): Pervasive changes to
	implement new location streaming format.
	(lto_location_cache::input_location_and_block): Likewise.
	(lto_location_cache::input_location): Rename argument LOC -> DEST
	for clarity.
	(lto_read_body_or_constructor): Handle LINEMAP_ID in the decl state.
	(lto_data_in_create): Add NEED_LOCATION_CACHE argument. Rename local
	variable DATA_IN to D to avoid clash with the type name.
	* lto-streamer-out.cc (clear_line_info): Update for change to class
	output_block.
	(compute_map_hash): New function.
	(class location_output): New class.
	(location_output::record_location): New function.
	(bp_pack_delta): New function.
	(location_output::produce_linemap_section): New function.
	(lto_output_location_1): Pervasive changes to implement new location
	streaming format.
	(copy_function_or_variable): Set the LINEMAP_ID in the decl state.
	(copy_linemap_section): New function.
	(copy_linemap_sections): New function.
	(lto_copy_linemaps): New function.
	(lto_register_linemap_for_output): New function.
	(lto_output_decl_state_refs): Output the LINEMAP_ID for function
	decls.
	(lto_out_decl_state_written_size): Adapt for new LINEMAP_ID output.
	(produce_asm_for_decls): Output the linemap section when needed.
	* lto-streamer.cc (lto_get_section_name): Handle linemap sections,
	which need an order suffix.
	* lto-streamer.h (enum lto_section_type): Fix typo in the
	comment. Add LTO_section_linemap.
	(struct lto_loc_map): New struct.
	(class lto_location_cache): Pervasive changes to implement new
	location streaming format.
	(struct lto_in_decl_state): Add LINEMAP_ID member.
	(struct lto_out_decl_state): Likewise.
	(struct lto_file_decl_data): Add LOC_MAP_DECL_DATA, LOC_MAPS,
	and NUM_LINEMAP_SECTIONS members.
	(lto_linemap_output_id): New function.
	(struct output_block): Adjust members for new streaming format.
	(data_in::data_in): New function.
	(lto_data_in_create): Adjust prototype for new NEED_LOCATION_CACHE
	argument.
	(lto_register_linemap_for_output): Declare.
	(lto_copy_linemaps): Declare.
	* lto-wrapper.cc (run_gcc): Pass new argument -fltrans-linemap-file.
	* timevar.def (TV_IPA_LTO_LINEMAP_IN): New timevar.
	(TV_IPA_LTO_LINEMAP_OUT): New timevar.
	(TV_IPA_LTO_LINEMAP_COPY): New timevar.

2026-07-17  Lewis Hyatt  <lhyatt@gmail.com>

	* doc/sourcebuild.texi: Document ar-link and incr-link options to
	dg-lto-do directive.

2026-07-17  Lewis Hyatt  <lhyatt@gmail.com>

	* doc/sourcebuild.texi: Document dg-lto-additional-options
	directive.

2026-07-17  Lewis Hyatt  <lhyatt@gmail.com>

	* diagnostic.h (diagnostic_classify_diagnostic): Adapt for removal
	of return value in option_classifier::classify_diagnostic.
	* diagnostics/context.h: Likewise.
	* diagnostics/kinds.h (enum kind): Add trailing element to indicate
	the total number of kinds.
	* diagnostics/option-classifier.cc
	(option_classifier::classify_diagnostic): Remove the return value,
	which was not correct and which was not used anyway.
	* diagnostics/option-classifier.h (class option_classifier): Adjust
	prototype for classify_diagnostic.  Make the name of nested strruct
	classification_change_t publicly accessible.

2026-07-17  Lewis Hyatt  <lhyatt@gmail.com>

	* input.cc (test_accessing_ordinary_linemaps): Test new
	line_map_add_raw_map() functionality.

2026-07-17  Neal Patalay  <nealpatalay0@gmail.com>

	PR tree-optimization/126087
	* match.pd: Simplify MIN and BIT_IOR compared to 0 when
	one operand is non-negative.

2026-07-17  Uros Bizjak  <ubizjak@gmail.com>

	PR target/126283
	* config/i386/i386.md (bswaphi2): Add flags reg clobber.
	(*bswaphi2_movbe): Add flags reg clobber.  Add ROLW alternative
	and update instruction attributes.  Add preferred_for_size and
	preferred_for_speed attributes.
	(*bswaphi2): Ditto.
	(*bswaphisi2_lowpart): Ditto.
	(XCHGB -> ROLW peephole2 patterns): Remove.
	(ROLW reg,8 -> BSWAP splitter): Update for added flags reg clobber.
	Always split.
	* config/i386/i386-expand.cc (ix86_expand_gfni_bitreverse):
	Update for bswaphi2 change.

2026-07-17  Paul-Antoine Arras  <parras@baylibre.com>

	* omp-builtins.def (BUILT_IN_GOMP_HAS_MASKED_THREAD_NUM_WITH_END):
	New builtin.
	* omp-low.cc (lower_omp_master): Use it when -fopenmp-ompt.

2026-07-17  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* et-gather.awk, gen-et-static.awk: New scripts.
	* Makefile.in (testsuitedir): New.
	(native): Depend on testsuite/et-static.exp.
	(clean): Remove etlist.
	(distclean): Remove et-static.exp.
	(install-testsuite): New target.
	(install): Depend on it.
	(site.exp): Depend on testsuite/et-static.exp.
	(testsuite/et-static.exp): New target.
	* doc/sourcebuild.texi (Effective-Target Keywords): Document
	et-static.def.
	(Effective-Target Keywords, Other attributes): Document
	ld_at_file.

2026-07-17  H.J. Lu  <hjl.tools@gmail.com>

	PR target/126275
	* config/i386/i386-expand.cc (ix86_expand_set_or_cpymem): Don't
	use misaligned prologue if count <= epilogue size.

2026-07-17  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/126028
	* tree-vect-slp.cc (vect_slp_check_for_roots): Do not
	force the BB reduction root to have an even number of lanes.
	(vect_build_slp_instance): For failed discovery of a BB
	reduction attempt to re-try discovery on the matching or
	non-matching part.

2026-07-16  Paul-Antoine Arras  <parras@baylibre.com>

	* builtin-types.def (BT_FN_VOID_ULONGLONG_ULONGLONG_ULONGLONG_ULONGLONG_ULONGLONG): New.
	* omp-builtins.def (BUILT_IN_GOMP_LOOP_STATIC_WORKSHARING_DISPATCH): Use
	BT_FN_VOID_ULONGLONG_ULONGLONG_ULONGLONG_ULONGLONG_ULONGLONG.
	(BUILT_IN_GOMP_DISTRIBUTE_STATIC_WORKSHARING_DISPATCH): Likewise.
	* omp-expand.cc (expand_omp_for_static_nochunk): Pass niter, start,
	incr, chunk size, and istart to the dispatch call.
	(expand_omp_for_static_chunk): Likewise.

2026-07-16  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/125986
	* value-relation.cc (path_oracle::query): Query root oracle for
	relations.

2026-07-16  Jin Ma  <jinma@linux.alibaba.com>

	* config/riscv/riscv-protos.h
	(riscv_legitimize_call_address): Add a sibcall parameter.
	* config/riscv/riscv.cc
	(riscv_legitimize_call_address): Use a pseudo for sibcalls.
	* config/riscv/riscv.md (sibcall): Pass true for sibcalls.
	(sibcall_value): Likewise.
	(call): Pass false for ordinary calls.
	(call_value): Likewise.

2026-07-16  Jin Ma  <jinma@linux.alibaba.com>

	* config/riscv/riscv.cc (riscv_regno_to_class): Map t1 to
	JALR_REGS.
	* config/riscv/riscv.h (RISCV_PROLOGUE_TEMP_REGNUM): Document
	the SIBCALL_REGS restriction.
	(REG_CLASS_CONTENTS): Remove t1 from SIBCALL_REGS.

2026-07-16  Sebastian Huber  <sebastian.huber@embedded-brains.de>

	* tree-profile.cc (emit_assign): Append to a gimple_seq instead
	of inserting on an edge.  Make the functions static.
	(emit_bitwise_op): Likewise.
	(instrument_decisions): Build up a local gimple_seq per edge and
	insert it once instead of inserting each statement individually.

2026-07-16  Sebastian Huber  <sebastian.huber@embedded-brains.de>

	* tree-profile.cc (emit_bitwise_op): Build/fold the operation with
	gimple_build() instead of gimple_build_assign(), and return the
	folded result as-is instead of always materializing a new SSA
	name.
	(instrument_decisions): Do not emit bitwise-or operations with a
	zero constant operand.

2026-07-16  Pan Li  <pan2.li@intel.com>

	* config/riscv/vector.md: Leverage Wvr constraint.

2026-07-16  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	* config/riscv/riscv.cc (riscv_noce_conversion_profitable_p): Ignore
	reg->reg copies too.

2026-07-16  Richard Biener  <rguenther@suse.de>

	* tree-switch-conversion.cc (gen_log2): Use gimple_seq
	overload of gimple_build.
	(gen_pow2p): Likewise.

2026-07-16  Tobias Burnus  <tburnus@baylibre.com>

	* omp-offload.cc (omp_discover_declare_target_tgt_fn_r): Fix
	the condition for anchestor + nohost handling.

2026-07-16  Eric Botcazou  <ebotcazou@adacore.com>

	* expmed.cc (invert_mod2n): Fix typo in comment and add references.

2026-07-16  Tobias Burnus  <tburnus@baylibre.com>

	PR fortran/126279
	* omp-low.cc (lower_omp_target): Avoid creating a second static const
	variable for the trait array used by uses_allocators.

2026-07-16  Georg-Johann Lay  <avr@gjlay.de>

	* doc/invoke.texi (AVR Options): Fix a typo.

2026-07-16  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* config/netbsd-elf.h (NETBSD_LINK_LD_ELF_SO_SPEC): Remove.
	(NETBSD_SUBTARGET_EXTRA_SPECS): Remove netbsd_link_ld_elf_so.

2026-07-16  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/126262
	* gimple-lower-bitint.cc (build_bitint_stmt_ssa_conflicts): Treat
	IFN_MUL_OVERFLOW and IFN_UBSAN_CHECK_MUL like IFN_BSWAP, regardless
	of bitint_big_endian.

2026-07-16  Peter Bergner  <bergner@linux.ibm.com>
	    Kishan Parmar  <kishan@linux.ibm.com>

	* config/rs6000/rs6000-builtin.cc (rs6000_invalid_builtin): Add
	ENB_DM diagnostic.
	(rs6000_builtin_is_supported): Handle ENB_DM.
	* config/rs6000/rs6000-gen-builtins.cc: Update comments for new
	Dense Math builtin attributes.
	(bif_stanza): Add BSTZ_DM.
	(stanza_map): Add "dm" stanza.
	(enable_string): Add ENB_DM.
	(basetype): Add BT_DMR.
	(attrinfo): Add isdm, isdmint and isdmr fields.
	(type_map): Add dmr1024 and ptr_dmr1024 type mappings.
	(match_type): Recognize dmr1024 type.
	(parse_bif_attrs): Parse dm, dmint and dmr attributes.
	(complete_vector_type): Handle BT_DMR.
	(write_decls): Emit ENB_DM and Dense Math builtin attribute bits
	and predicates.
	(write_bif_static_init): Initialize Dense Math builtin attributes
	and associate dmint builtins with their internal variants.

2026-07-15  H.J. Lu  <hjl.tools@gmail.com>

	PR target/126231
	* config/i386/i386.md (*fix_trunc<mode>si_sse_2_zext): New.

2026-07-15  wangjue  <juewang@linux.alibaba.com>

	* config/riscv/riscv.cc (riscv_legitimize_address): Use
	riscv_add_offset for scaled indexed addresses.

2026-07-15  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/126110
	* gimple-range-cache.cc (ranger_cache::mark_stale): Default defs
	get a new timestamp to make them stale.
	* gimple-range-infer.cc (infer_range_manager::add_range): When
	an inferred range is added, mark the name as updated.

2026-07-15  Jim Lin  <jim@andestech.com>

	* config/riscv/riscv-target-attr.cc
	(riscv_target_attr_parser::parse_arch): Check m_loc instead of *m_loc
	before emitting the diagnostic.

2026-07-15  Jim Lin  <jim@andestech.com>

	* config/riscv/zicond.md: Emit any_ge instead of any_gt in the
	GE/GEU if-then-else splitter.

2026-07-15  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	Revert:
	2026-06-29  Matthew Fortune  <matthew.fortune@imgtec.com>

	* config/mips/mips.h (ASM_SPEC): Add placeholders for -mmxu and
	-mno-mxu.
	* config/mips/mips.opt: New undocumented target option.

2026-07-15  Nathan Sidwell  <nathan@acm.org>

	* gen-pass-instances.awk: Require only white-space before
	macro invocations.

2026-07-15  Tobias Burnus  <tburnus@baylibre.com>

	* omp-low.cc (lower_private_allocate): When called on 'target'
	and the allocator is a variable, obtain the device variable.
	(lower_omp_target): Move processing of OMP_CLAUSE_USES_ALLOCATORS
	on the device/receiver side in before the loop over clauses to
	ensure the VALUE_EXPR points to uses_allocators's inited var.

2026-07-15  Richard Biener  <rguenther@suse.de>

	* tree-vectorizer.h (vect_transform_stmt): Return void.
	* tree-vect-stmts.cc (vect_transform_stmt): Likewise.

2026-07-15  Richard Biener  <rguenther@suse.de>

	* tree-vect-slp.cc (vect_bb_slp_mark_live_stmts): Enhance
	dumping in the failure case.

2026-07-15  Roger Sayle  <roger@nextmovesoftware.com>

	PR rtl-optimization/123236
	* simplify-rtx.cc (simplify_context::simplify_truncation): Handle
	cases where a ZERO_EXTRACT or SIGN_EXTRACT has a different mode
	to (but at least as wide as) its first operand.

2026-07-15  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/126171
	* tree-scalar-evolution.cc (scev_dfs::add_to_evolution):
	Remove code argument.  Remove MINUS_EXPR handling here.
	(scev_dfs::follow_ssa_edge_binary): Likewise.
	(scev_dfs::follow_ssa_edge_expr): Handle MINUS_EXPR
	separately here, promoting the whole operation to unsigned
	instead of just the addend.

2026-07-15  Andrew Stubbs  <ams@baylibre.com>

	* regrename.cc (scan_rtx_address): Recurse for segment UNSPECs.

2026-07-15  Luke Zhuang  <luke.zhuang@linux.alibaba.com>

	* config/riscv/riscv.md (VXSAT_REGNUM): New constant.
	(@tlsdesc<mode>): update clobbering.

2026-07-15  H.J. Lu  <hjl.tools@gmail.com>

	PR target/126231
	* config/i386/i386.md (*fix_trunc<mode>si_sse_zext): New.
	* config/i386/sse.md (*avx512fp16_vcvtsh2<sseintconvertsignprefix>si<round_zext_name>):
	Likewise.
	(*avx512fp16_vcvtsh2<sseintconvertsignprefix>si_2_zext): Likewise.
	(*unspec_avx512fp16_fix<vcvtt_uns_suffix>_truncsi2<round_saeonly_zext_name>): Likewise.
	(*sse_cvtss2si<round_zext_name>): Likewise.
	(*sse_cvtss2si_2_zext): Likewise.
	(*unspec_sse_cvttss2si<round_saeonly_zext_name>): Likewise.
	(*sse_cvttss2si<round_saeonly_zext_name>): Likewise.
	(*avx512f_vcvtss2usi<round_zext_name>): Likewise.
	(*unspec_avx512f_vcvttss2usi<round_saeonly_zext_name>): Likewise.
	(*avx512f_vcvttss2usi<round_saeonly_zext_name>): Likewise.
	(*avx512f_vcvtsd2usi<round_zext_name>): Likewise.
	(*unspec_avx512f_vcvttsd2usi<round_saeonly_zext_name>):
	Likewise.
	(*avx512f_vcvttsd2usi<round_saeonly_zext_name>): Likewise.
	(*sse2_cvtsd2si<round_zext_name>): Likewise.
	(*sse2_cvtsd2si_2_zext): Likewise.
	(*unspec_sse2_cvttsd2si<round_saeonly_zext_name>): Likewise.
	(*sse2_cvttsd2si<round_saeonly_zext_name>): Likewise.
	(*avx10_2_vcvttsd2<sat_cvt_sign_prefix>sissi<round_saeonly_zext_name>):
	Likewise.
	(*avx10_2_vcvttss2<sat_cvt_sign_prefix>sissi<round_saeonly_zext_name>):
	Likewise.
	* config/i386/subst.md (round_zext_name): Likewise.
	(round_zext_constraint): Likewise.
	(round_zext_constraint2): Likewise.
	(round_zext_nimm_predicate): Likewise.
	(round_zext_nimm_scalar_predicate): Likewise.
	(round_zext_op2): Likewise.
	(round_zext): Likewise.
	(round_saeonly_zext_name): Likewise.
	(round_saeonly_zext_constraint): Likewise.
	(round_saeonly_zext_constraint2): Likewise.
	(round_saeonly_zext_nimm_scalar_predicate): Likewise.
	(round_saeonly_zext_op2): Likewise.
	(round_saeonly_zext): Likewise.

2026-07-15  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/126257
	* match.pd (x+x -> x*2): Only optimize if 2 is representable in the
	type.

2026-07-15  Jakub Jelinek  <jakub@redhat.com>

	PR c++/120635
	* doc/extend.texi: Document variant spelling of
	standard attributes and that alternate namespace
	spelling for clang namespace is _Clang rather
	than __clang__.  For no_specializations use
	_Clang:: rather than __clang__::.

2026-07-15  Tobias Burnus  <tburnus@baylibre.com>

	* omp-expand.cc (expand_omp_target): For 'device_type(host)',
	invoke with device(omp_initial_device)'.
	* omp-low.cc (create_omp_child_function): Take host_only
	argument to prevent generating offload code.
	(scan_omp_parallel, scan_omp_task, scan_omp_target, scan_omp_teams,
	lower_omp_target): Update call.
	* omp-offload.cc (omp_discover_declare_target_tgt_fn_r,
	omp_discover_declare_target_fn_r): Do not add implicit 'declare
	target' to target regions with 'device_type(host)'.

2026-07-15  Hu, Lin1  <lin1.hu@intel.com>

	PR middle-end/126203
	PR middle-end/126221
	PR middle-end/126232
	* optabs.cc (emit_cmp_and_jump_insns): Take the masked_op mode
	from TREE_TYPE (masked_op).

2026-07-14  Tobias Burnus  <tburnus@baylibre.com>

	* gimplify.cc (gimplify_omp_workshare): Handle 'device_type(nohost)'
	on 'target'.
	* omp-low.cc (lower_omp_target): Remove sorry for this case.

2026-07-14  Karl Meakin  <karl.meakin@arm.com>

	PR target/126064
	* config/aarch64/aarch64-neon-builtins-base.cc: Compare
	`arg_type` and `TREE_TYPE (b)` using `types_compatible_p` rather
	than comparing their pointer addresses.

2026-07-14  Torbjörn SVENSSON  <torbjorn.svensson@foss.st.com>

	* doc/sourcebuild.texi (arm_v8_1m_mve_link): Document.

2026-07-14  Cem Akgok  <cemakgok@gmail.com>

	PR tree-optimization/126225
	* tree-vect-loop.cc (vect_slp_induction_reuse_p): New function.
	(vectorizable_induction): Validate SLP induction IV reuse.  Reuse
	generated IVs cyclically when filling the SLP group.

2026-07-14  Iain Sandoe  <iain@sandoe.co.uk>

	* config/darwin.cc (darwin_globalize_label): Handle Protocol
	references.
	(darwin_label_is_anonymous_local_objc_name): Likewise.

2026-07-14  Naveen  <naveen.siddegowda@oss.qualcomm.com>

	PR tree-optimization/102202
	* gimple-fold.cc (gimple_fold_builtin_memset): Hoist
	tree_to_uhwi (len) before the INTEGER_CST guard.  Fold
	length-one memset calls through arbitrary pointer destinations.
	Build a ref-all MEM_REF at offset zero and preserve the call
	result when it is used.

2026-07-14  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/126084
	* gimple-lower-bitint.cc: Include "attribs.h" and "asan.h".
	(gimple_lower_bitint): Use asan_expand_poison_ifn to lower
	.ASAN_POISON calls with large/huge _BitInt lhs.
	* asan.cc (report_error_func): Set *nargs and use _n builtin
	even if size is not a power of two or larger than 16.
	(asan_expand_poison_ifn): Handle nargs == 2.

2026-07-14  Jakub Jelinek  <jakub@redhat.com>
	    H.J. Lu  <hjl.tools@gmail.com>

	PR tree-optimization/120201
	* cfgexpand.cc (expand_used_vars): Set data.asan_alignb to
	maximum of itself and crtl->stack_alignment_needed
	/ BITS_PER_UNIT.

2026-07-14  Kyrylo Tkachov  <ktkachov@nvidia.com>

	PR target/123625
	PR target/121957
	* tree-outof-ssa.cc (split_overlapping_partition_decls): New function.
	Use use_register_for_decl to identify memory partitions.
	(remove_ssa_form): Call split_overlapping_partition_decls.

2026-07-14  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/126194
	* gimple-ssa-pta-constraints.cc (find_func_aliases_for_call):
	Only ignore calls to delete if DECL_IS_REPLACEABLE_OPERATOR.

2026-07-14  Jakub Jelinek  <jakub@redhat.com>

	* asan.h (asan_var_and_redzone_size): Fix comment typo,
	occupis -> occupies.

2026-07-14  H.J. Lu  <hjl.tools@gmail.com>

	PR target/126202
	* alias.cc (static_reg_base_value): Revert commit e754b70fe54.
	(find_base_term): Likewise.
	* alias.h (find_base_term): Likewise.
	* function.cc (thread_prologue_and_epilogue_insns): Likewise.
	* rtl.h (static_reg_base_value): Likewise.
	* config/i386/i386.cc (stack_access_data): Likewise.
	(ix86_find_all_reg_uses_1): Likewise.
	(ix86_find_all_reg_uses): Likewise.
	(ix86_access_stack_p): Likewise.
	(ix86_need_alignment_p_2): Likewise.
	(ix86_need_alignment_p_1): Likewise.
	(ix86_need_alignment_p): Likewise.
	(ix86_update_stack_alignment): Likewise.
	(ix86_find_max_used_stack_alignment): Likewise.
	(ix86_update_stack_alignment_2): Removed.
	(ix86_update_stack_alignment_1): Likewise.

2026-07-14  Pan Li  <pan2.li@intel.com>

	* config/riscv/vector.md: Leverage Wvr constraint.

2026-07-13  Torbjörn SVENSSON  <torbjorn.svensson@foss.st.com>

	PR driver/124058
	* gcc-diagnostic-spec.cc (nowarn_spec_t::nowarn_spec_t):
	Remove leftover reference to OPT_Wuse_after_free.

2026-07-13  Torbjörn SVENSSON  <torbjorn.svensson@foss.st.com>

	PR driver/124058
	* common.opt (Wuse-after-free): Make an alias for
	-Wuse-after-free=1.
	* doc/invoke.texi: Document alias.
	* gimple-ssa-warn-access.cc (pass_waccess::warn_invalid_pointer):
	Use OPT_Wuse_after_free_.

2026-07-13  Vladimir N. Makarov  <vmakarov@redhat.com>

	PR target/120165
	* lra-constraints.cc (virtual_reg_p, contains_virtual_reg_p): New.
	(reg_has_incdec_p): Ditto.
	(lra_constraints): Use reg_has_incdec_p and contains_virtual_reg_p
	to switch off the equiv.

2026-07-13  Nathan Sidwell  <nathan@acm.org>

	* print-rtl.cc (rtx_writer::print_rtx_operand_code_i): Don't
	fallback to UNSPEC enums if there are any UNSPECV enums.
	(print_exp): Print unspec/unspecv name, when available.

2026-07-13  Jakub Jelinek  <jakub@redhat.com>

	PR c++/120635
	* doc/extend.texi (no_specializations): Document new
	attribute.
	* doc/invoke.texi (-Wno-invalid-specialization): Document new
	warning.

2026-07-13  Odysseas Georgoudis  <odygrd@hotmail.com>

	PR tree-optimization/113894
	* match.pd: Add simplifications for branchless conditional negate
	and sign-test absolute value idioms.

2026-07-13  Oleg Tolmatcev  <oleg.tolmatcev@gmail.com>

	PR target/78799
	* config/i386/i386.cc (function_value_ms_64): Do not treat
	integral 16-byte values as SSE returns.
	(ix86_return_in_memory): Likewise avoid treating integral 16-byte
	values as XMM returns.

2026-07-13  Jeevitha Palanisamy  <jeevitha@linux.ibm.com>

	* config/rs6000/rs6000-call.cc (rs6000_return_in_memory): Handle
	TDOmode and emit "Dense Math" diagnostics.
	(rs6000_function_arg): Reject TDOmode function parameters and
	emit "Dense Math" diagnostics.
	* config/rs6000/rs6000-modes.def: Add TDOmode.

2026-07-13  Dylan Rees  <dylan.rees@arm.com>

	* cse.cc (struct cse_vec_duplicate_match): New struct.
	(struct cse_basic_block_data): New member added.
	(cse_prescan_cache_vec_dup): New function to cache any vector
	duplications and check for potential matches.
	(cse_prescan_path): Extended pre_scan loop to cache vector
	duplication matches + New loop added to assign a list of
	matches to a block of data inside new struct member.
	(cse_main): New loop to emit wider vector duplication earlier
	and update narrower vector duplicate to SUBREG insn.

2026-07-13  Dylan Rees  <dylan.rees@arm.com>

	* config/aarch64/aarch64-builtins.cc (aarch64_fold_lo_call_to_hi):
	New branch to check for uniform vectors, extend and then add
	them to the new highpart builtin call.

2026-07-13  Josef Melcr  <josef.melcr@suse.com>

	PR ipa/125121
	* cgraph.cc (cgraph_edge::make_callback): Add missing call to
	duplication hooks.
	* ipa-prop.cc (init_callback_edge_summary): Remove function.
	(ipa_compute_jump_functions_for_edge): Remove call to
	init_callback_edge_summary, fix comment.
	(ipa_edge_args_sum_t::duplicate): Fix the initialization of jump
	functions vector for callback edges.

2026-07-13  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* config/t-sol2 (install-clearcap-map): Install as clearcap.map.

2026-07-13  Sandra Loosemore  <sloosemore@baylibre.com>

	* doc/extend.texi (Common Attributes): Delete instances of
	extra "the".
	* doc/invoke.texi (Visium Options): Likewise.
	* doc/tree-ssa.texi (SSA Operands): Likewise.

2026-07-13  Sandra Loosemore  <sloosemore@baylibre.com>

	* doc/invoke.texi (Options Summary) [C Language Options]:
	Group --ansi with -ansi since they are documented together.
	Correctly alphabetize -ffso-struct.
	(C Dialect Options): Likeise correctly alphabetize -ffso-struct.

2026-07-13  Sandra Loosemore  <sloosemore@baylibre.com>

	* doc/invoke.texi (Option Summary): Add -fdeps-file, -fdeps-format,
	and -fdeps-target.
	(C Dialect Options): Properly alphabetize entries for the above
	options, group them together, move the introductory paragraph
	into the discussion of this group of items, and make the docs
	more descriptive.

2026-07-12  Jin Ma  <jinma@linux.alibaba.com>

	* config/riscv/riscv.md (*<any_extract:optab><GPR:mode>3):
	Remove (clobber (match_scratch)) and use operand 0 as the
	intermediate destination for the shift-left half of the split.

2026-07-12  Kael Andrew Alonzo Franco  <kaelfandrew@gmail.com>

	PR tree-optimization/104280
	* match.pd: Remove redundant build_one_cst (type) [PR104280]

2026-07-12  Kael Andrew Alonzo Franco  <kaelfandrew@gmail.com>

	PR tree-optimization/114009
	* match.pd: Remove redundant build_zero_cst (type) [PR114009]

2026-07-12  Kael Andrew Alonzo Franco  <kaelfandrew@gmail.com>

	* match.pd: Remove one build_minus_one_cst (type) in r15-6257.

2026-07-12  Surya Kumari Jangala  <jskumari@linux.ibm.com>

	* config/rs6000/rs6000-cpus.def (FUTURE_MASKS_SERVER): Add OPTION_MASK_DMF.
	(POWERPC_MASKS): Likewise.
	* config/rs6000/rs6000.cc (rs6000_option_override_internal): Enable
	OPTION_MASK_DMF by default when TARGET_FUTURE is set and the
	flag was not explicitly given; emit an error and clear the flag
	when -mdense-math is requested on a non-future target.
	(rs6000_opt_masks): Add "dense-math" entry for OPTION_MASK_DMF.
	* config/rs6000/rs6000.opt (mdense-math): New option backed by Mask(DMF).
	* config/rs6000/rs6000.opt.urls: Regenerated.
	* doc/invoke.texi: Add -mdense-math.

2026-07-12  MITSUNARI Shigeo  <herumi@nifty.com>

	* config/i386/i386.md (*bmi2_umul<mode>3_highpart): New pattern.

2026-07-12  MITSUNARI Shigeo  <herumi@nifty.com>

	* expmed.cc (expand_wide_mulh_udiv): New function.
	(expand_divmod): Use it for unsigned constant division needing a
	wide multiplier on 64-bit targets, when no more expensive than the
	sub/shift/add sequence.

2026-07-11  Surya Kumari Jangala  <jskumari@linux.ibm.com>

	Revert:
	2026-07-11  Surya Kumari Jangala  <jskumari@linux.ibm.com>

	* config/rs6000/rs6000-cpus.def (FUTURE_MASKS_SERVER): Add OPTION_MASK_DMF.
	(POWERPC_MASKS): Likewise.
	* config/rs6000/rs6000.cc (rs6000_option_override_internal): Enable
	OPTION_MASK_DMF by default when TARGET_FUTURE is set and the
	flag was not explicitly given; emit an error and clear the flag
	when -mdense-math is requested on a non-future target.
	(rs6000_opt_masks): Add "dense-math" entry for OPTION_MASK_DMF.
	* config/rs6000/rs6000.opt (mdense-math): New option backed by Mask(DMF).
	* doc/invoke.texi: Add -mdense-math.

2026-07-11  Surya Kumari Jangala  <jskumari@linux.ibm.com>

	* config/rs6000/rs6000-cpus.def (FUTURE_MASKS_SERVER): Add OPTION_MASK_DMF.
	(POWERPC_MASKS): Likewise.
	* config/rs6000/rs6000.cc (rs6000_option_override_internal): Enable
	OPTION_MASK_DMF by default when TARGET_FUTURE is set and the
	flag was not explicitly given; emit an error and clear the flag
	when -mdense-math is requested on a non-future target.
	(rs6000_opt_masks): Add "dense-math" entry for OPTION_MASK_DMF.
	* config/rs6000/rs6000.opt (mdense-math): New option backed by Mask(DMF).
	* doc/invoke.texi: Add -mdense-math.

2026-07-10  Roger Sayle  <roger@nextmovesoftware.com>

	PR tree-optimization/57371
	* fold-const.cc (fold_cmp_float_cst_p): New helper function.
	* fold-const.h (fold_cmp_float_cst_p): Prototype here.
	* match.pd ((FTYPE) N CMP CST): Use the new helper
	fold_cmp_float_cst_p to check that transformation to an integer
	comparison is safe.

2026-07-10  Roger Sayle  <roger@nextmovesoftware.com>

	PR target/48609
	* expr.cc (emit_group_load_1): When passing a complex value in an
	integer mode of the same size, explicitly construct (hi<<N)+lo to
	avoid spilling to memory before reload.

2026-07-10  Roger Sayle  <roger@nextmovesoftware.com>
	    Richard Biener  <rguenther@suse.de>

	PR target/99668
	* expr.cc (try_expand_complex_as_vector): Try to use vec_init_optab
	to convert a complex number to a two-component vector with the same
	inner type.
	(expand_expr_real_1) <case VIEW_CONVERT_EXPR>: Check whether the
	above function can be used to implement this VIEW_CONVERT_EXPR.

2026-07-10  Jim Lin  <jim@andestech.com>

	* common/config/riscv/riscv-common.cc
	(riscv_multi_lib_info_t::parse): Remove early-out for multilibs
	matching only the default march/mabi.

2026-07-10  Pengfei Li  <Pengfei.Li2@arm.com>

	* match.pd: Simplify vector permute and insert patterns.

2026-07-10  Kael Andrew Franco  <kaelfandrew@gmail.com>

	PR tree-optimization/125738
	PR tree-optimization/64130
	* match.pd: Use tree_expr_nonnegative_p for (X / Y) (==,!=) 0 -> X (<,>=) Y.

2026-07-10  Léo Hardt  <leom.hardt@inf.ufrgs.br>

	* sel-sched-ir.cc (struct succs_info): Removed
	unused variable current_succs.

2026-07-10  Daniel Barboza  <daniel.barboza@oss.qualcomm.com>

	PR tree-optimization/124808
	* match.pd(`(A >> CST1) CMP CST2`): New pattern.

2026-07-10  Thomas Schwinge  <tschwinge@baylibre.com>

	* system.h [INCLUDE_ITERATOR]: '#include <iterator>'.

2026-07-10  Mark Wielaard  <mark@klomp.org>

	* config/i386/i386.opt.urls: Regenerate.

2026-07-10  Konstantinos Eleftheriou  <konstantinos.eleftheriou@vrull.eu>

	PR rtl-optimization/117922
	* fold-mem-offsets.cc (INCLUDE_ALGORITHM):  Added definition.
	(INCLUDE_FUNCTIONAL): Likewise.
	(class pass_fold_mem_offsets): Moved to bottom of file.
	(class change_info): New.
	(def_shadowed_by_cond_exec_p): New.
	(get_single_def_in_bb): Converted to RTL-SSA.
	(get_fold_mem_offset_root): Converted to RTL-SSA.
	(get_uses): Removed.
	(fold_offsets): Converted to RTL-SSA.
	(fold_offsets_value): New.
	(fold_offsets_1): Converted to RTL-SSA.
	(has_foldable_uses_p): Converted to RTL-SSA.
	(get_fold_mem_root): Removed.
	(insn_uses_not_in_bitmap): New.
	(drop_unsafe_candidates): New.
	(do_commit_offset): Converted to RTL-SSA.
	(do_analysis): Removed.
	(do_commit_insn): Converted to RTL-SSA.
	(do_fold_info_calculation): Removed.
	(sort_changes): New.
	(struct regno_changes): New.
	(sort_pairs): New.
	(do_check_validity): Removed.
	(get_last_def): New.
	(move_uses_to_prev_def): New.
	(compute_validity_closure): Removed.
	(change_in_vec_p): New.
	(cancel_changes_for_group): New.
	(find_keys_to_remove): New.
	(free_changes_info): New.
	(update_insns): New.
	(fold_mem_offsets_1): New.
	(pass_fold_mem_offsets::execute): Moved to bottom of file.
	(fold_mem_offsets): New.

2026-07-10  Thomas Schwinge  <tschwinge@baylibre.com>

	* config/nvptx/nvptx.cc (flexible_array_member_type_p): Rename to
	'nvptx_flexible_array_member_type_p'.

2026-07-10  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	* config/m68k/m68k.h (ASM_PREFERRED_EH_DATA_FORMAT): Adjust parens
	so they wrap the macro parameter.

2026-07-10  Pan Li  <pan2.li@intel.com>

	* config/riscv/riscv-protos.h (is_frac_vlmul_p): Add new func
	decl to predicate frac vlmul for a mode.
	* config/riscv/riscv-v.cc (is_frac_vlmul_p): Add new func impl
	for above.
	(riscv_v_widen_constraint_ok): Add Source and Dest lmul less
	and equal 1 handling.
	* config/riscv/vector.md: Leverage widen constraint Wvr.

2026-07-10  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/116860
	PR tree-optimization/114326
	* match.pd (`((a ^ b) & c) cmp d || a != b`): Expand
	to support bit_and and fix up the :c.

2026-07-09  Paul-Antoine Arras  <parras@baylibre.com>
	    Thomas Schwinge  <tschwinge@baylibre.com>

	* builtin-types.def (BT_FN_COMPLEX_INT): Remove.
	(BT_FN_COMPLEX_INT_ULONGLONG): New.
	* omp-builtins.def (BUILT_IN_GOMP_LOOP_STATIC_WORKSHARING): Use
	BT_FN_COMPLEX_INT_ULONGLONG.
	(BUILT_IN_GOMP_LOOP_STATIC_WORKSHARING_START): Likewise.
	(BUILT_IN_GOMP_DISTRIBUTE_STATIC_WORKSHARING): Likewise.
	(BUILT_IN_GOMP_DISTRIBUTE_STATIC_WORKSHARING_START): Likewise.
	* omp-expand.cc (expand_omp_for_static_nochunk): Move worksharing
	builtin call after iteration count computation; pass n as niter.
	(expand_omp_for_static_chunk): Likewise.

2026-07-09  Paul-Antoine Arras  <parras@baylibre.com>

	* common.opt (fopenmp-ompt): New option.
	(fopenmp-ompt-detailed): New option.
	* common.opt.urls: Regenerate.
	* doc/invoke.texi (Option Summary): Add -fopenmp-ompt and
	-fopenmp-ompt-detailed.
	(OpenMP and OpenACC Options): Document -fopenmp-ompt and
	-fopenmp-ompt-detailed.
	* omp-builtins.def (BUILT_IN_GOMP_SINGLE_START_WITH_END): New builtin.
	(BUILT_IN_GOMP_SINGLE_END): New builtin.
	(BUILT_IN_GOMP_MASKED_END): New builtin.
	(BUILT_IN_GOMP_LOOP_STATIC_WORKSHARING_START): New builtin.
	(BUILT_IN_GOMP_LOOP_STATIC_WORKSHARING_END): New builtin.
	(BUILT_IN_GOMP_LOOP_STATIC_WORKSHARING_DISPATCH): New builtin.
	(BUILT_IN_GOMP_DISTRIBUTE_STATIC_WORKSHARING_START): New builtin.
	(BUILT_IN_GOMP_DISTRIBUTE_STATIC_WORKSHARING_END): New builtin.
	(BUILT_IN_GOMP_DISTRIBUTE_STATIC_WORKSHARING_DISPATCH): New builtin.
	* omp-expand.cc (expand_omp_for_static_nochunk): With -fopenmp-ompt,
	emit _start and _end variants instead of the plain worksharing call;
	with -fopenmp-ompt-detailed, also emit _dispatch.
	(expand_omp_for_static_chunk): Likewise.
	* omp-low.cc (lower_omp_single_simple): With -fopenmp-ompt, use
	GOMP_single_start_with_end instead of GOMP_single_start.
	(lower_omp_single): With -fopenmp-ompt, emit GOMP_single_end.
	(lower_omp_master): With -fopenmp-ompt, emit GOMP_masked_end.
	* opts.cc (finish_options): Diagnose -fopenmp-ompt and
	-fopenmp-ompt-detailed used without -fopenmp.

2026-07-09  Richard Sandiford  <rdsandiford@googlemail.com>

	PR debug/126169
	* rtl.h (rtx_def::u2): Add value_uid to the union.
	(CSELIB_VAL_UID): New macro.
	* cselib.h (cselib_val::HASH_MASK): Delete.
	(cselib_val::hash): Restore to a full int.
	(cselib_val::uid): Delete.
	(canonical_cselib_val): Use CSELIB_VAL_UID instead of cselib_val::uid.
	* alias.cc (refs_newer_value_p): Likewise.
	* dse.cc (canon_address): Likewise.
	* print-rtl.cc (rtx_writer::print_rtx_operand_code_0): Likewise.
	* var-tracking.cc (dv_uid, canon_value_cmp): Likewise.
	(variable_post_merge_new_vals): Likewise.
	* cselib.cc (new_elt_loc_list, new_cselib_val): Likewise.
	(cselib_lookup): Likewise.
	(cselib_find_slot): Remove use of cselib_val::HASH_MASK.

2026-07-09  Andreas Schwab  <schwab@linux-m68k.org>

	PR target/126121
	* config/m68k/m68k.md (bsetmemqi, *bsetmemqi_ext, bclrmemqi)
	(*bclrmemqi_ext): Add AND with 7 around bit number.

2026-07-09  Karl Meakin  <karl.meakin@arm.com>

	* bitmap.h: Replace uses of `CONSTEXPR` with `constexpr`.
	* config/aarch64/aarch64-acle-builtins.cc: Likewise.
	* config/aarch64/aarch64-builtins.cc: Likewise.
	* config/aarch64/aarch64-protos.h: Likewise.
	* config/aarch64/aarch64-sve-builtins-base.cc: Likewise.
	* config/aarch64/aarch64-sve-builtins-functions.h: Likewise.
	* config/aarch64/aarch64-sve-builtins-shapes.cc: Likewise.
	* config/aarch64/aarch64-sve-builtins-sme.cc: Likewise.
	* config/aarch64/aarch64-sve-builtins-sve2.cc: Likewise.
	* config/aarch64/aarch64.cc: Likewise.
	* config/aarch64/driver-aarch64.cc: Likewise.
	* config/arm/arm-mve-builtins-base.cc: Likewise.
	* config/arm/arm-mve-builtins-functions.h: Likewise.
	* config/arm/arm-mve-builtins-shapes.cc: Likewise.
	* config/arm/arm-mve-builtins.cc: Likewise.
	* config/riscv/andes-vector-builtins-bases.cc: Likewise.
	* config/riscv/riscv-protos.h: Likewise.
	* config/riscv/riscv-vector-builtins-bases.cc: Likewise.
	* config/riscv/riscv-vector-builtins-shapes.cc: Likewise.
	* config/riscv/riscv-vector-builtins.cc: Likewise.
	* config/riscv/riscv-vector-builtins.h: Likewise.
	* config/riscv/sifive-vector-builtins-bases.cc: Likewise.
	* machmode.h: Likewise.

2026-07-09  Philipp Tomsich  <philipp.tomsich@vrull.eu>

	* doc/params.texi (widening-mul-defer-fma): Document.
	* params.opt (-param=widening-mul-defer-fma=): New param.
	* tree-ssa-math-opts.cc (math_opts_dom_walker::after_dom_children):
	Gate fma_deferring_state's enable predicate on
	param_widening_mul_defer_fma on top of param_avoid_fma_max_bits.
	* config/aarch64/aarch64-tuning-flags.def (AVOID_CROSS_LOOP_FMA):
	Update the comment for the widening-mul-defer-fma effect.
	* config/aarch64/aarch64.cc (aarch64_override_options_internal):
	Inside the AARCH64_EXTRA_TUNE_AVOID_CROSS_LOOP_FMA block, set
	param_widening_mul_defer_fma to 0.

2026-07-09  Nathan Sidwell  <nathan@acm.org>

	* Makefile.in (genprogrtl, genprogmd, genprogerr, genprog): Append,
	rather than set.
	* config/riscv/t-riscv: Delete genrvv-type-indexer workaround rule,
	it is no longer needed.

2026-07-09  Martin Jambor  <mjambor@suse.cz>

	PR ipa/125207
	* ipa-cp.cc (decide_about_value): Add detailed dumping about skipping
	a value when there are no edges for it.  Make dumping about skipping
	because of growth limit violation consistent with other cases.
	(decide_whether_version_node): Only create all-context nodes for local
	nodes, remove the logic doing it in other cases, allow cloning for
	single constant lattices for non-local nodes.  Adjust dumping.

2026-07-09  Jim Lin  <jim@andestech.com>

	* config/riscv/riscv-string.cc (riscv_vector_expand_block_move):
	Gate the memcpy path on riscv_memcpy_size_threshold instead of
	riscv_memmove_size_threshold.

2026-07-09  Jovan Dmitrovic  <jovan.dmitrovic@htecgroup.com>

	* tree-ssa-loop-ivopts.cc (ivopts_estimate_reg_pressure):
	Return zero if there are enough registers to store new
	invariants and induction variables.

2026-07-09  Eikansh Gupta  <eikansh.gupta@oss.qualcomm.com>

	PR tree-optimization/112472
	* match.pd ((trunc)copysign ((extend)x, CST) --> copysign (x, -1.0/1.0)):
	New pattern.

2026-07-09  Zhou Xuhang  <zhouxh2002@gmail.com>

	* match.pd: Canonicalize shifted high-half unsigned multiply
	overflow checks to widened comparisons.  Simplify widened unsigned
	multiply comparison against the narrow type maximum to IFN_MUL_OVERFLOW.

2026-07-09  Avinash Jayakar  <avinashd@linux.ibm.com>

	* config/rs6000/rs6000-builtins.def: Move AES builtins to future-vsx
	stanza.
	* doc/extend.texi: Add subheading for AES builtins.

2026-07-09  Stefan Schulze Frielinghaus  <stefansf@gcc.gnu.org>

	* config.gcc: Remove target s390-*. Don't accept
	--with-mode=esa anymore.
	* config.host: Remove target s390-*.
	* config/host-linux.cc (TRY_EMPTY_VM_SPACE): Remove definition
	for s390.
	* config/s390/2827.md: Remove scheduling information for
	mnemonics which are only used by -m31 but not by -m64.
	* config/s390/2964.md: Ditto.
	* config/s390/3906.md: Ditto.
	* config/s390/3931.md: Ditto.
	* config/s390/8561.md: Ditto.
	* config/s390/9175.md: Ditto.
	* config/s390/constraints.md (ZL): Remove TARGET_64BIT test.
	* config/s390/driver-native.cc (s390_host_detect_local_cpu):
	Remove handling for -mesa/-mzarch.
	* config/s390/htmxlintrin.h (__TM_failure_address): Remove
	-m31 part.
	* config/s390/linux.h: Remove -m31 parts.
	* config/s390/predicates.md: Ditto.
	* config/s390/s390-builtins.def: Rename RTL expander name for
	s390_vsce[fg].
	* config/s390/s390-c.cc (s390_cpu_cpp_builtins): Remove
	TARGET_{64BIT,ZARCH} tests.
	* config/s390/s390-d.cc (s390_d_target_versions): Remove
	TARGET_64BIT test.
	* config/s390/s390.cc: Remove -m31 parts.  In particular, there
	is no need to distinguish between 64-bit registers in ABI
	contexts anymore which is why UNITS_PER_WORD and UNITS_PER_LONG
	always equal, now.  Hence, replace UNITS_PER_LONG by
	UNITS_PER_WORD.
	* config/s390/s390.h: Ditto.
	* config/s390/s390.md: Ditto. Mode iterator GPR is replaced by
	DSI. Likewise, DGPR by new mode iterator TDSI.  Remove mode
	iterators P, DW, W because they are singletons, now.
	* config/s390/s390.opt: Keep -m64 and -mzarch for backwards
	compatibility.  Mark -m31 and -mesa as undocumented.
	* config/s390/s390.opt.urls: Regenerate.
	* config/s390/t-linux64: Remove -m31 parts.
	* config/s390/tpf.h (POINTERS_EXTEND_UNSIGNED): This is only
	required for TPF which is why it is moved from s390.h here.
	(TARGET_DEFAULT): Remove MASK_64BIT and MASK_ZARCH.
	* config/s390/vector.md: Remove -m31 parts.
	* config/s390/vx-builtins.md
	(vec_scatter_element<V_HW_2:mode>_SI): There is no need for
	multiplexing different address sizes for vec_scatter_element
	anymore.
	(vec_scatter_element<V_HW_32_64:mode>): Ditto.
	* configure: Regenerate.
	* configure.ac: Remove target s390-*.
	* doc/install.texi: Remove mentions of s390 without also
	referring to s390x.
	* doc/invoke.texi: Remove options -m31 and -mesa.  Document that
	-m64 and -mzarch are the defaults, now, and that they don't have
	any additional effect when explicitly specified.
	* config/s390/s390x.h: Removed.

2026-07-08  Jim Lin  <jim@andestech.com>

	* config/riscv/riscv.h (TARGET_SFB_ALU): Add andes_45_series.

2026-07-08  Uros Bizjak  <ubizjak@gmail.com>

	PR target/126148
	* config/i386/i386-expand.cc (ix86_gen_ccmp_first): Restrict
	floating-point modes accepted for ccmp according to the
	available floating-point instruction set.

2026-07-08  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	PR rtl-optimization/126136
	* ifcvt.cc (noce_try_store_flag_logical): Fix for STORE_FLAG_VALUE
	of -1.

2026-07-08  Jim Lin  <jim@andestech.com>

	* config/riscv/spacemit-x60.md (spacemit_x60_alu): Remove cpop
	from the type list.

2026-07-08  Richard Biener  <rguenther@suse.de>

	* tree-vect-slp.cc (vect_build_slp_tree_1): Remove group_size
	argument and adjust.
	(vect_build_slp_tree_2): Likewise.
	(vect_build_slp_tree): Likewise.
	(optimize_load_redistribution_1): Likewise.
	(vect_build_slp_instance): Likewise.
	(vect_analyze_slp_reduc_chain): Likewise.
	(vect_analyze_slp_reduction): Likewise.
	(vect_analyze_slp_reduction_group): Likewise.
	(vect_analyze_slp_instance): Likewise.
	(vect_lower_load_permutations): Likewise.

2026-07-08  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/126150
	* tree-cfg.cc (replace_uses_by): Delay purging of EH edges
	until after FOR_EACH_IMM_USE_STMT finished.

2026-07-08  Martin Uecker  <uecker@tugraz.at>

	* tree.h (flexible_array_member_type_p): New helper function.
	* tree.cc (flexible_array_member_type_p): New helper function.
	(flexible_array_type_p): Use new helper function.

2026-07-08  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/126159
	* tree-data-ref.cc (dr_analyze_indices): Handle non-aggregate
	union field accesses.
	(access_fn_component_p): Adjust.

2026-07-08  Pengfei Li  <Pengfei.Li2@arm.com>

	* match.pd: Simplify SAD(x, x, acc) into acc.

2026-07-08  Evgeny Karpov  <evgeny.karpov@arm.com>

	* config/i386/cygming.h (TARGET_ASM_FUNCTION_END_PROLOGUE):
	Rename.
	(TARGET_ASM_EMIT_EXCEPT_PERSONALITY): Likewise.
	(TARGET_ASM_INIT_SECTIONS): Likewise.
	(SUBTARGET_ASM_UNWIND_INIT): Likewise.
	(ASM_DECLARE_FUNCTION_SIZE): Likewise.
	(ASM_DECLARE_COLD_FUNCTION_SIZE): Likewise.
	* config/i386/i386-protos.h (i386_pe_end_function):
	Remove declarations.
	(i386_pe_end_cold_function): Likewise.
	(i386_pe_seh_init): Likewise.
	(i386_pe_seh_end_prologue): Likewise.
	(i386_pe_seh_cold_init): Likewise.
	(i386_pe_seh_emit_except_personality): Likewise.
	(i386_pe_seh_init_sections): Likewise.
	* config/mingw/winnt.cc (defined): Update.
	(struct seh_frame_state): Move to mingw/winnt.h.
	(i386_pe_seh_init): Rename into ...
	(mingw_pe_seh_init): ... this.
	(i386_pe_seh_end_prologue): Rename into ...
	(mingw_pe_seh_end_prologue): ... this.
	(i386_pe_seh_cold_init): Rename into ...
	(mingw_pe_seh_cold_init): ... this.
	(i386_pe_seh_fini): Rename into ...
	(mingw_pe_seh_fini): ... this.
	(seh_emit_stackalloc): Rename into ...
	(mingw_pe_seh_emit_stackalloc): ... this.
	(seh_cfa_adjust_cfa): Update.
	(seh_frame_related_expr): Update.
	(i386_pe_seh_emit_except_personality): Rename into ...
	(mingw_pe_seh_emit_except_personality): ... this.
	(i386_pe_seh_init_sections): Rename into ...
	(mingw_pe_seh_init_sections): ... this.
	(i386_pe_end_function): Rename into ...
	(mingw_pe_end_function): ... this.
	(i386_pe_end_cold_function): Rename into ...
	(mingw_pe_end_cold_function): ... this.
	* config/mingw/winnt.h (struct seh_frame_state):
	Move from mingw/winnt.cc.
	(mingw_pe_end_cold_function): Add declarations.
	(mingw_pe_end_function): Likewise.
	(mingw_pe_seh_init): Likewise.
	(mingw_pe_seh_init_sections): Likewise.
	(mingw_pe_seh_cold_init): Likewise.
	(mingw_pe_seh_emit_except_personality): Likewise.
	(mingw_pe_seh_end_prologue): Likewise.

2026-07-08  Tamar Christina  <tamar.christina@arm.com>

	* tree-vect-data-refs.cc (vect_create_addr_base_for_vector_ref):
	Restructure computations to force separate base.

2026-07-08  Tamar Christina  <tamar.christina@arm.com>

	* tree-vect-data-refs.cc (vect_slp_analyze_store_dependences,
	vect_slp_analyze_load_dependences,
	vect_slp_analyze_instance_dependence): Use for-each over for with len.
	* tree-vect-slp.cc (vect_mark_slp_stmts_relevant,
	,vect_find_last_scalar_stmt_in_slp, vect_find_first_scalar_stmt_in_slp,
	vect_build_slp_store_interleaving, vect_analyze_slp,
	vect_slp_prune_covered_roots, vect_bb_partition_graph_r,
	vect_remove_slp_scalar_calls): Likewise.

2026-07-08  Richard Biener  <rguenther@suse.de>

	* gimple-ssa-pta-constraints.cc (find_func_aliases_for_builtin_call):
	Correctly use SCALAR rhs from the variadic argument part of
	the function info or from NONLOCAL in case of intra-PTA.
	(find_func_aliases_for_call): Handle .VA_ARG.

2026-07-08  Philipp Tomsich  <philipp.tomsich@vrull.eu>

	* config/aarch64/tuning_models/ampere1.h (ampere1_scalar_issue_info)
	(ampere1_advsimd_issue_info, ampere1_vec_issue_info): New.
	(ampere1_vector_cost): Use ampere1_vec_issue_info for issue_info.
	* config/aarch64/tuning_models/ampere1b.h (ampere1b_scalar_issue_info)
	(ampere1b_advsimd_issue_info, ampere1b_vec_issue_info): New.
	(ampere1b_vector_cost): Use ampere1b_vec_issue_info for issue_info.

2026-07-08  H.J. Lu  <hjl.tools@gmail.com>
	    Richard Sandiford  <rdsandiford@googlemail.com>

	PR target/124798
	PR target/125436
	* config/i386/i386-expand.cc: Include "function-abi.h".
	(x86_64_ms_sysv_extra_clobbered_registers): Removed.
	(ix86_expand_call): Don't add explicit call and ABI-switch
	clobbers.
	* config/i386/i386-features.cc (ix86_emit_tls_call): Call
	ix86_tls_get_addr_abi to get GNU TLS ABI and use it, instead of
	default_function_abi, for registers clobbered by GNU TLS call.
	(ix86_place_single_tls_call): Set CALL_INSN_ABI_ID on TLS calls.
	* config/i386/i386-options.cc (ix86_set_current_function): Don't
	call reinit_regs.
	* config/i386/i386-protos.h
	(ix86_type_no_callee_saved_registers_p): Removed.
	(ix86_tls_get_addr_abi): New.
	* config/i386/i386.cc (ix86_alternate_abi): New prototype.
	(ix86_conditional_register_usage): Changed to describe the
	system ABI.
	(ix86_type_no_callee_saved_registers_p): Make it static.
	(ix86_function_value_regno_p): Replace ix86_cfun_abi () with
	ix86_abi.
	(ix86_save_reg): Only check TYPE_NO_CALLEE_SAVED_REGISTERS as
	a special case.
	(ix86_tls_get_addr_abi): New.
	(legitimize_tls_address): Set CALL_INSN_ABI_ID on TLS calls.
	Call ix86_alternate_abi to initialize the alternate function ABI.
	(ix86_initialize_abi): New function.
	(ix86_no_callee_saved_abi): Likewise.
	(ix86_no_caller_saved_abi): Likewise.
	(ix86_standard_abi): Likewise.
	(ix86_alternate_abi): Likewise.
	(ix86_function_abi_id): Likewise.
	(ix86_fntype_abi): Likewise.
	(ix86_hard_regno_call_part_clobbered): Handle newly added ABIs.
	(TARGET_FNTYPE_ABI): New.
	* config/i386/i386.md: Add ABI_ALTERNATE, ABI_NO_CALLEE_SAVED,
	ABI_NO_CALLER_SAVED_RETURN_VOID, ABI_NO_CALLER_SAVED_RETURN_AX,
	ABI_NO_CALLER_SAVED_RETURN_AX_DX,
	ABI_NO_CALLER_SAVED_RETURN_AX_XMM0,
	ABI_NO_CALLER_SAVED_RETURN_XMM0 and
	ABI_NO_CALLER_SAVED_RETURN_XMM0_XMM1.

2026-07-08  Richard Sandiford  <rdsandiford@googlemail.com>

	* config/i386/i386.cc (ix86_function_arg): Remove always-true
	condition.

2026-07-08  Richard Sandiford  <rdsandiford@googlemail.com>

	* config/i386/i386-features.cc: Include function-abi.h.
	(ix86_emit_tls_call): Use default_function_abi instead of
	call_used_regs.
	* config/i386/i386.cc (x86_order_regs_for_local_alloc): Likewise.
	(ix86_save_reg, x86_64_select_profile_regnum): Use crtl->abi
	instead of call_used_regs.

2026-07-08  Richard Sandiford  <rdsandiford@googlemail.com>

	* config/i386/i386-protos.h (ix86_fntype_call_saved_registers):
	Declare.
	* config/i386/i386-options.cc (ix86_fntype_call_saved_registers): New
	function, split out from...
	(ix86_set_func_type): ...here.  Avoid calling it if the result
	would be ignored.
	* config/i386/i386.cc (ix86_type_no_callee_saved_registers_p): Use
	ix86_fntype_call_saved_registers instead of querying attributes
	directly.

2026-07-08  Pan Li  <pan2.li@intel.com>

	* config/riscv/constraints.md (Wtt): Rename to Wvr to
	indicate widen vector register constraint.
	* config/riscv/riscv-protos.h (riscv_widen_overlap_ok): Rename
	from...
	(riscv_vector_mode_p): Add new decl for riscv-v.cc visibile.
	(riscv_hard_regno_nregs): Ditto.
	(riscv_v_widen_constraint_ok): Rename to...
	* config/riscv/riscv-v.cc (riscv_v_widen_constraint_ok): Rename
	to... and take care of Wvr constraint.
	* config/riscv/riscv.cc (riscv_vector_mode_p): Remove static.
	(riscv_hard_regno_nregs): Ditto.
	(riscv_widen_overlap_ok): Remove.
	* config/riscv/vector.md: Rename to Wvr.

2026-07-07  Richard Earnshaw  <rearnsha@arm.com>

	* config/aarch64/aarch64-option-extensions.def (AARCH64_OPT_EXTENSION):
	Remove +mpamv2.
	* config/aarch64/aarch64-sys-regs.def: Remove sysregs associated
	with MPAMv2_VID and adjust other related sysregs to use the
	base permitted architecture.
	* doc/invoke.texi (aarch64: +mpamv2): Remove option.

2026-07-07  Dhruv Chawla  <dhruvc@nvidia.com>

	* config/aarch64/aarch64-cores.def (rigel): New entry.
	* config/aarch64/aarch64-tune.md: Regenerate.
	* doc/invoke.texi (AArch64 Options): Document the above.

2026-07-07  wangjue  <juewang@linux.alibaba.com>

	* common/config/riscv/riscv-common.cc (riscv_option_optimization_table):
	Enable -funroll-loops and -munroll-only-small-loops at -O2 and above.
	* config/riscv/riscv.cc (struct riscv_tune_param): Add fields
	small_loop_unroll_ninsns and small_loop_unroll_factor.
	(xt_c9501_tune_info): Set them.
	(riscv_loop_unroll_adjust): New function.
	(riscv_option_override): Turn off -munroll-only-small-loops when
	-funroll-loops or -funroll-all-loops is explicitly given.
	(TARGET_LOOP_UNROLL_ADJUST): Define.
	* config/riscv/riscv.opt (munroll-only-small-loops): New option.
	* config/riscv/riscv.opt.urls: Regenerate.
	* doc/invoke.texi (RISC-V Options): Document -munroll-only-small-loops.

2026-07-07  Alfie Richards  <alfie.richards@arm.com>

	* config/aarch64/aarch64-simd.md (*aarch64_abs_plus<mode>): New
	define_insn_and_split.

2026-07-07  Kyrylo Tkachov  <ktkachov@nvidia.com>

	PR target/124146
	* config/aarch64/aarch64.cc (aarch64_function_arg_alignment):
	Ignore user alignment left on a type's main variant; use the
	mode's natural alignment instead.

2026-07-07  Kishan Parmar  <kishan@linux.ibm.com>

	* config/rs6000/altivec.md (UNSPEC_VUCMPRHN): New unspec entry.
	(UNSPEC_VUCMPRLN): Likewise.
	(UNSPEC_VUCMPRHB): Likewise.
	(UNSPEC_VUCMPRLB): Likewise.
	(UNSPEC_VUCMPRHH): Likewise.
	(UNSPEC_VUCMPRLH): Likewise.
	(UNSPEC_VUPKHSNTOB): Likewise.
	(UNSPEC_VUPKLSNTOB): Likewise.
	(UNSPEC_VUPKINT4TOBF16): Likewise.
	(UNSPEC_VUPKINT8TOBF16): Likewise.
	(UNSPEC_VUPKINT4TOFP32): Likewise.
	(UNSPEC_VUPKINT8TOFP32): Likewise.
	(vu_hl): New attribute.
	(vu_lh): Likewise.
	(VUPKNTOB): New int iterator.
	(altivec_vupkhsntob): New define_insn.
	(altivec_vupklsntob): Likewise.
	(altivec_vupkint4tobf16): Likewise.
	(altivec_vupkint8tobf16): Likewise.
	(altivec_vupkint4tofp32): Likewise.
	(altivec_vupkint8tofp32): Likewise.
	(vucmpr_splat): New attribute.
	(vucmpr_pcv): Likewise.
	(vucmpr_uim): Likewise.
	(VUCMPR_N): New int iterator.
	(VUCMPR_B): Likewise.
	(VUCMPR_H): Likewise.
	(altivec_vucmpr<vu_hl>n): New define_expand.
	(altivec_vucmpr<vu_hl>n_direct): New define_insn for vucmpr<vu_hl>n.
	(altivec_vucmpr<vu_hl>b): New define_expand.
	(altivec_vucmpr<vu_hl>b_direct): New define_insn for vucmpr<vu_hl>b.
	(altivec_vucmpr<vu_hl>h): New define_expand.
	(altivec_vucmpr<vu_hl>h_direct): New define_insn for vucmpr<vu_hl>h.
	* config/rs6000/rs6000-builtins.def: Add vector uncompress and unpack
	builtins under [future].
	* config/rs6000/rs6000-overload.def: Add vec_uncompress* and vec_unpack*
	interfaces.

2026-07-07  Stafford Horne  <shorne@gmail.com>

	PR target/126081
	* config/or1k/or1k.cc (or1k_hard_regno_mode_ok): Stop allowing
	SImode for FLAG_REGS.
	(or1k_can_change_mode_class): Stop allowing SImode for
	FLAG_REGS.
	(or1k_noce_conversion_profitable_p): Always check
	or1k_is_cmov_insn.

2026-07-07  Naveen  <naveen.siddegowda@oss.qualcomm.com>

	PR tree-optimization/102202
	* tree-call-cdce.cc: Include "value-query.h" and "value-range.h".
	(len_has_boolean_range_p): Remove.
	(get_len_nonzero_value): New function. Return the nonzero member of
	LEN's value range when it is a boolean range [0, 1] or an exact
	two-value set {0, N}.
	(can_shrink_wrap_len_p): Replace len_has_boolean_range_p call with
	get_len_nonzero_value. Add NONZERO_LEN output parameter and set it
	to the returned nonzero value on success.
	(shrink_wrap_len_call): Use it to pin the length argument on the
	guarded call path instead of build_one_cst.
	(shrink_wrap_conditional_dead_built_in_calls): Declare local
	nonzero_len and pass it to can_shrink_wrap_len_p and forward it to
	shrink_wrap_len_call.
	(pass_call_cdce::execute): Pass nullptr as NONZERO_LEN to
	can_shrink_wrap_len_p.

2026-07-07  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/125758
	* gimple-range.cc (gimple_ranger::gimple_ranger): Create prefill stack.
	(gimple_ranger::gimple_ranger): Dispose of prefill stack.
	(gimple_ranger::prefill_name): Maybe push name on prefill stack.
	(gimple_ranger::prefill_stmt_dependencies): Implement a DFS
	stack for dependency satisfaction.
	* gimple-range.h (struct prefill_frame): New.
	(m_prefill_stack): New.
	(prefill_name): Sadjust parameters.
	(m_active_prefill): New.

2026-07-07  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/125758
	* gimple-range-cache.cc (struct time_stamp): New.
	(set_timestamp): Deleted.
	(set_timestamp_stored): New.
	(set_timestamp_calc): New.
	(set_always_current): Remove a parameter.
	(temporal_value): Remove.
	(temporal_value_stored): New.,
	(temporal_value_calc): New.
	(m_timestamp): Change to vector of struct time_stamp.
	(temporal_cache::temporal_cache): Adjust.
	(temporal_cache::current_p): Use both timestamps.
	(temporal_cache::set_always_current): 0 means always current.
	(temporal_cache::always_current_p): Check for 0.
	(ranger_cache::get_global_range): adjust params.
	(ranger_cache::update_consumers): Set stored timestamp.
	(ranger_cache::set_global_range): Use new timestamps.

2026-07-06  Mark Zhuang  <zhuangqiubin@linux.spacemit.com>

	* config/riscv/riscv-cores.def (spacemit-x60): Use rva22u64
	profile shorthand, add missing entries.

2026-07-06  Richard Biener  <rguenther@suse.de>

	* tree-vect-slp.cc (vect_build_slp_instance): For BB reductions
	note the first root stmt.

2026-07-06  Andrew Stubbs  <ams@baylibre.com>

	* config/gcn/gcn-valu.md (*vec_set<mode>): Ad TImode instruction.

2026-07-06  Eric Botcazou  <ebotcazou@adacore.com>

	* config/vms/vms.h (ADA_LONG_TYPE_SIZE): Delete.
	* doc/tm.texi.in (ADA_LONG_TYPE_SIZE): Likewise.
	* doc/tm.texi: Regenerate.
	* system.h (ADA_LONG_TYPE_SIZE): Poison.

2026-07-06  Eric Botcazou  <ebotcazou@adacore.com>

	* config/aarch64/aarch64.h (WIDEST_HARDWARE_FP_SIZE): Delete.
	* config/alpha/alpha.h (WIDEST_HARDWARE_FP_SIZE): Likewise.
	* config/i386/i386.h (WIDEST_HARDWARE_FP_SIZE): Likewise.
	* config/ia64/vms.h (WIDEST_HARDWARE_FP_SIZE): Likewise.
	* config/pa/pa.h (WIDEST_HARDWARE_FP_SIZE): Likewise.
	* config/rs6000/rs6000.h (WIDEST_HARDWARE_FP_SIZE): Likewise.
	* config/s390/s390.h (WIDEST_HARDWARE_FP_SIZE): Likewise.
	* config/sparc/sparc.h (WIDEST_HARDWARE_FP_SIZE): Likewise.
	* config/visium/visium.h (WIDEST_HARDWARE_FP_SIZE): Likewise.
	* doc/tm.texi.in (WIDEST_HARDWARE_FP_SIZE): Likewise.
	* doc/tm.texi: Regenerate.
	* system.h (WIDEST_HARDWARE_FP_SIZE): Poison.

2026-07-06  Kyrylo Tkachov  <ktkachov@nvidia.com>

	PR tree-optimization/120892
	* gimple-ssa-split-paths.cc: Remove.
	* passes.def (pass_split_paths): Remove.
	* tree-pass.h (make_pass_split_paths): Remove.
	* Makefile.in (OBJS): Remove gimple-ssa-split-paths.o.
	* timevar.def (TV_SPLIT_PATHS): Remove.
	* opts.cc (default_options_table): Remove the OPT_LEVELS_3_PLUS entry
	for OPT_fsplit_paths.
	* common.opt (fsplit-paths): Make it a deprecated no-op using Ignore.
	* doc/invoke.texi (-fsplit-paths): Document as deprecated and remove it
	from the option summary and the -O3 list.

2026-07-06  H.J. Lu  <hjl.tools@gmail.com>
	    Richard Biener  <rguenther@suse.de>

	PR target/109780
	PR target/109093
	PR target/123210
	PR target/124098
	PR target/124165
	PR target/124684
	PR target/124759
	PR target/124789
	* alias.cc (static_reg_base_value): Moved to rtl.h.
	(find_base_term): Remove static.
	* alias.h (find_base_term): New prototype.
	* function.cc (thread_prologue_and_epilogue_insns): Call
	init_alias_analysis and end_alias_analysis.
	* rtl.h (static_reg_base_value): Moved from alias.cc.
	* config/i386/i386.cc (stack_access_data): Removed.
	(ix86_find_all_reg_uses_1): Likewise.
	(ix86_find_all_reg_uses): Likewise.
	(ix86_access_stack_p): Likewise.
	(ix86_need_alignment_p_2): Likewise.
	(ix86_need_alignment_p_1): Likewise.
	(ix86_need_alignment_p): Likewise.
	(ix86_update_stack_alignment_2): New function.
	(ix86_update_stack_alignment_1): Likewise.
	(ix86_update_stack_alignment): Rewrite.
	(ix86_find_max_used_stack_alignment): If check_stack_slot is
	true, call ix86_update_stack_alignment on each INSN.

2026-07-06  liuhongt  <hongtao.liu@intel.com>

	PR target/126098
	* config/i386/sse.md (VI1_AVX512VNNIBW): Remove.
	(sdot_prod<ssedvecmodelower><mode>): Use VI1_AVX512 instead of
	VI1_AVX512VNNIBW so V64QI is enabled only under AVX512BW.
	(udot_prod<ssedvecmodelower><mode>): Likewise.

2026-07-05  Roger Sayle  <roger@nextmovesoftware.com>

	PR target/126094
	* config/aarch64/aarch64-simd.md (aarch64_cmtst<mode><vczle><vczbe>):
	Update pattern to match recent RTL simplification.
	(*aarch64_cmtst<mode><vczle><vczbe>): Preserve the original.
	(*aarch64_cmtst_same_<mode><vczle><vczbe>): Additional variant.

2026-07-05  Kael Andrew Alonzo Franco  <kaelfandrew@gmail.com>

	PR tree-optimization/125641
	* match.pd: Fix #ifdef GIMPLE typo.

2026-07-05  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* configure.ac (gcc_cv_ld_clearcap): Remove.
	Link clearcap.map to config/sol2-clearcap.map with Solaris ld.
	* configure: Regenerate.
	* config.in: Likewise.
	* config/sol2-clearcap.map: Remove.
	* config/sol2-clearcapv2.map: Rename to sol2-clearcap.map.
	* config/t-sol2 (install-clearcap-map): Install source file
	directly.
	* config/sol2.h (LINK_CLEARCAP_SPEC): Guard with HAVE_SOLARIS_LD.

2026-07-05  Oleg Endo  <olegendo@gcc.gnu.org>

	PR target/67643
	PR target/126117
	* config/sh/sh.cc (fpscr_set_from_mem): Add missing argument to
	get_free_reg invocation.

2026-07-05  Oleg Endo  <olegendo@gcc.gnu.org>

	PR target/67643
	* config/sh/sh.cc (fpscr_set_from_mem): Specify a post-inc memory
	operand for lds_fpscr after RA.

2026-07-05  Oleg Endo  <olegendo@gcc.gnu.org>

	PR target/55212
	* config/sh/sh-protos.h (sh_lra_p): Remove.
	(sh_legitimize_reload_address): Remove.
	* config/sh/sh.h (LEGITIMIZE_RELOAD_ADDRESS): Remove.
	* config/sh/sh.cc (sh_legitimize_reload_address): Remove.
	(prepare_move_operands, broken_move): Remove sh_lra_p uses.
	* config/sh/constraints.md (Rab, Rai, Ssd): Likewise.
	* config/sh/sh.md: Likewise.  Remove reload-only *addsi3 patterns.

2026-07-05  Oleg Endo  <olegendo@gcc.gnu.org>

	* config/sh/sh.cc (emit_fpu_switch): Delete and merge into...
	(fpscr_set_from_mem): ...this.

2026-07-05  Oleg Endo  <olegendo@gcc.gnu.org>

	PR target/116709
	* config/sh/sh.md (movsf_ie): Mark constant-pool load FPUL
	alternative with '*'.

2026-07-05  Oleg Endo  <olegendo@gcc.gnu.org>

	PR target/67459
	PR target/122948
	* config/sh/sh.md (addc): Fix T bit set expression.
	(subc): Likewise.

2026-07-05  Oleg Endo  <olegendo@gcc.gnu.org>

	PR target/124778
	* config/sh/sh.md (extend<mode>si2_short_mem_disp_z): Move after
	'*extend<mode>si2_compact_mem_disp' patterns.

2026-07-04  Filip Kastl  <fkastl@suse.cz>

	* config/i386/i386.cc: Add override specifier for
	better_epilogue_loop_than_p.

2026-07-03  Philipp Tomsich  <philipp.tomsich@vrull.eu>

	PR tree-optimization/122569
	* match.pd (clz_msb_iso_table_index): New match pattern.
	* tree-ssa-forwprop.cc (gimple_clz_msb_iso_table_index): Declare.
	(simplify_count_zeroes): Recognize the new pattern; route its
	table validation through the CTZ checkfn.  Relax the element
	type check to accept integer types up to 64 bits.

2026-07-03  Philipp Tomsich  <philipp.tomsich@vrull.eu>

	* match.pd (msb_or_cascade_32, msb_or_cascade_64): New match
	helpers.
	(clz_table_index): Rewrite the 32-bit and 64-bit forms to use
	the cascade helpers.

2026-07-03  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/106164
	PR tree-optimization/126042
	PR tree-optimization/94589
	* fold-const.cc (combine_comparisons): Split into
	2 versions. Also handle BIT_AND_EXPR and BIT_IOR_EXPR.
	* fold-const.h (combine_comparisons): New declaration.
	* match.pd (`(a CMP1 b) BITOP (a CMP2 b)`): New pattern.

2026-07-03  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr.cc (avr_out_plus_1): Handle +/-1 on the
	lower regs without needing a scratch.
	* config/avr/avr.md (add<mode>3_clobber, *add<mode>3_clobber)
	(add<mode>3, *add<mode>3, addpsi3, *addpsi3): Add constraint
	alternative "Y01 Ym1" for +/-1 without scratch.

2026-07-03  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	* config/riscv/riscv.cc (synthesize_add): Utilize shNadd.uw when
	appropriate.

2026-07-03  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	* config/riscv/riscv.cc (and_synthesis): Use riscv_integer_cost rather
	than riscv_const_insns.  Use rotate+clear_bits+rotate when useful.

2026-07-03  Richard Biener  <rguenther@suse.de>

	* tree-vect-slp.cc (vect_bb_vectorization_profitable_p): Make
	profitabilty decision easier to debug.

2026-07-03  Naveen  <naveen.siddegowda@oss.qualcomm.com>

	PR tree-optimization/102202
	* tree-call-cdce.cc: Include "tree-ssanames.h", "gimple-fold.h".
	(len_has_boolean_range_p): New function.
	(can_shrink_wrap_len_p): New function.
	(gen_zero_len_conditions): New function.
	(shrink_wrap_len_call): New function.
	(shrink_wrap_conditional_dead_built_in_calls): Dispatch to
	shrink_wrap_one_memset_call for memset calls eligible for the [0, 1]
	length transform, ahead of the generic LHS and range-test paths.
	(pass_call_cdce::execute): Collect memset calls satisfying
	can_shrink_wrap_memset_p as shrink-wrap candidates.

2026-07-03  Kyrylo Tkachov  <ktkachov@nvidia.com>

	PR target/120027
	* config/aarch64/aarch64-sve-builtins-base.cc (svext_bhw_impl::fold):
	New member function.  Fold the unsigned svextb/svexth/svextw
	intrinsics to a bitwise AND when the merging form has an all-true
	predicate.

2026-07-03  Tamar Christina  <tamar.christina@arm.com>
	    Chris Bazley  <Chris.Bazley@arm.com>

	* expr.cc (store_constructor): Handle VLA vec_init support and generic
	fall through piecewise copy.
	* doc/md.texi: Document change

2026-07-03  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	* config/riscv/riscv.cc (synthesize_ior_xor): Use riscv_integer_cost
	rather than riscv_const_insns.

2026-07-03  Oleg Endo  <olegendo@gcc.gnu.org>

	* config/sh/sh.opt.urls: Renegerate.
	* config/vax/vax.opt.urls: Renegerate.

2026-07-03  Oleg Endo  <olegendo@gcc.gnu.org>

	PR target/55212
	* config/sh/sh.opt (mlra): Ignore option but keep it around
	for compatibility.
	* config/sh/sh.cc (TARGET_LRA_P): Remove.
	(sh_lra_p): Move definition ...
	* config/sh/sh-protos.h (sh_lra_p): ... here.  Always return true.
	* doc/invoke.texi: Remove mention of -mlra for SH.

2026-07-03  Oleg Endo  <olegendo@gcc.gnu.org>

	PR target/55212
	* config/sh/sh.md (movv2sf, movv2sf_i, unnamed splits): New patterns.
	* config/sh/sh.cc (sh_hard_regno_mode_ok): Allow V2SF only in fp-regs.
	(sh_max_mov_insn_displacement): Return 0 for any float mode.

2026-07-03  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	PR target/55212
	* config/sh/sh.md (extend<mode>si2_short_mem_disp_z): New
	insn_and_split.
	(extend<mode>si2): Use it for LRA.
	(mov<mode>_store_mem_index, *mov<mode>_store_mem_index): New patterns.
	(mov<mode>): Use it for LRA.
	(movsf_ie_store_mem_index, movsf_ie_load_mem_index,
	*movsf_ie_store_mem_inde, *movsf_ie_load_mem_index): New patterns.
	(movsf): Use it for LRA.

2026-07-03  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	PR target/55212
	* config/sh/predicates.md (pc_relative_load_operand): New predicate.
	* config/sh/sh-protos.h (sh_movsf_ie_ra_split_p): Remove.
	(sh_movsf_ie_y_split_p): New proto.
	(sh_movsf_ie_subreg_multiword_p): New proto.
	* config/sh/sh.cc: (sh_movsf_ie_ra_split_p): Remove.
	(sh_movsf_ie_y_split_p): New function.
	(sh_movsf_ie_subreg_multiword_p): New function.
	(broken_move): Take movsf_ie_ra into account for fldi cases.
	* config/sh/sh.md (movdf_i4_F_z): New insn.
	(movdf): Use it when expanding.
	(movsf_ie_ra): Use define_insn instead of define_insn_and_split.
	Adjust alternatives.
	(movsf_ie_rffr): New insn_and_split.
	(movsf_ie_F_z, movsf_ie_Q_z, movsf_ie_y): New insns.
	(movsf): Use new patterns when expanding.

2026-07-02  Pengfei Li  <Pengfei.Li2@arm.com>

	* config/aarch64/aarch64.cc
	(aarch64_vector_costs::determine_suggested_unroll_factor): Add a
	loop_vec_info parameter.
	(determine_suggested_unroll_factor): Cap the suggested unroll for
	small-niters loops.
	(aarch64_vector_costs::finish_cost): Pass loop_vinfo to
	determine_suggested_unroll_factor.

2026-07-02  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	* config/riscv/bitmanip.md (xor_for_plus_minint): New pattern.
	* config/riscv/riscv.cc (synthesize_add): Handle INT_MIN as
	bit inversion.  Add support for add.uw.  Use riscv_integer_cost
	rather than riscv_const_insns.
	(synthesize_add_extended): Use riscv_integer_cost rather than
	riscv_const_insns.

2026-07-02  Sivan Shani  <sivan.shani@arm.com>

	* config/aarch64/aarch64-c.cc (aarch64_update_cpp_builtins):
	Check for SVE2 and SVE_AES directly.
	* config/aarch64/aarch64-sve-builtins-sve2.def (REQUIRED_EXTENSIONS):
	Make AES builtins streaming-compatible with SSVE AES.
	* config/aarch64/aarch64-sve2.md: Use TARGET_SVE_AES instead of
	TARGET_SVE2_AES.
	* config/aarch64/aarch64.h (TARGET_SVE2_AES): Rename to...
	(TARGET_SVE_AES): Add support for SSVE AES.
	* config/aarch64/iterators.md: Use TARGET_SVE2 for VNx2DI
	PMULL pair mode.

2026-07-02  Srinath Parvathaneni  <srinath.parvathaneni@arm.com>

	PR target/97344
	* config.in: Re-generate.
	* config/aarch64/aarch64.cc (aarch64_output_dwarf_dtprel): Define
	function.
	(TARGET_ASM_OUTPUT_DWARF_DTPREL): Define macro.
	* configure: Re-generate.
	* configure.ac: Add assemler check for dtprel relocation.

2026-07-02  Richard Earnshaw  <rearnsha@arm.com>

	* config/arm/arm-mve-builtins-shapes.cc (SHAPE): Add a
	trailing statement that lacks a semicolon.  Add that to all
	existing uses.

2026-07-02  Richard Earnshaw  <rearnsha@arm.com>

	* config/aarch64/aarch64-sve-builtins-shapes.cc (SHAPE): Add a
	trailing statement that lacks a semicolon.  Add that to all
	existing uses.

2026-07-02  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* configure.ac (gcc_fn_gld_min_version): New function.
	(gcc_fn_gld_elf_min_version): Likewise.
	Use them.
	* configure: Regenerate.

2026-07-02  Philipp Tomsich  <philipp.tomsich@vrull.eu>

	PR tree-optimization/124545
	* match.pd: Add (T)A +- CST -> (T)(A +- CST') for widening
	conversions from a signed inner type with undefined overflow.

2026-07-02  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	PR target/117182
	PR target/55212
	* target.def (cannot_substitute_const_equiv_p): New target hook.
	* doc/tm.texi.in: Add it.
	* lra-constraints.cc (get_equiv): Use it.
	* config/sh/sh.cc (sh_cannot_substitute_const_equiv_p): Override it.
	* doc/tm.texi: Re-generate.

2026-07-02  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	PR target/55212
	* config/sh/predicates.md (hard_reg_r0..r7): New predicates.
	* config/sh/sh.md (udivsi3_i4, udivsi3_i4_single,
	udivsi3_i1): Rewrite with match_operand and match_dup.
	(block_lump_real, block_lump_real_i4): Ditto.
	(udivsi3): Adjust for it.
	* config/sh/sh-mem.cc (expand_block_move): Ditto.

2026-07-01  Iain Sandoe  <iain@sandoe.co.uk>

	PR objc/124260
	* config/darwin.cc (darwin_objc2_section): Also allow meta data
	in const_data.
	(darwin_label_is_anonymous_local_objc_name): Make ClassList linker-
	visible.
	(darwin_file_end): Update comments on the ImageInfo flags.  Do not
	claim we have signed pointers.

2026-07-01  Stefan Schulze Frielinghaus  <stefansf@gcc.gnu.org>

	* config/s390/s390.md: Annotate mnemonic for
	extzv_<mode>_{srl,sll}<clobbercc_or_nocc>.

2026-07-01  Icenowy Zheng  <zhengxingda@iscas.ac.cn>

	PR target/126049
	* config/riscv/autovec.md: Change fmin/fmax reduction initial
	value from inf/-inf to NaN for proper semantics of corresponding
	C funtion.

2026-07-01  Robin Dapp  <robin.dapp@oss.qualcomm.com>

	* doc/md.texi: Document new behavior.
	* lra-constraints.cc (get_dependent_filter): Call filter with
	INVALID_REGNUM ref op instead of allowing everything.

2026-07-01  Thomas Schwinge  <tschwinge@baylibre.com>

	* config/gcn/gcn.h (ASM_V_SPEC): Define.

2026-07-01  Alfie Richards  <alfie.richards@arm.com>

	* tree-vect-loop-manip.cc (vect_set_loop_condition_normal):
	Check if loop_vinfo is null before dereference.

2026-07-01  Roger Sayle  <roger@nextmovesoftware.com>

	* config/i386/i386-features.cc (compute_convert_gain) <ZERO_EXTEND>:
	Provide costs for the new transformation.
	(convert_insn): Implement *zero_extendsidi2 using the backend's
	vec_setv2di_0_zero_extendsi_1 pattern (i.e. movq mem, %xmm).
	(general_scalar_to_vector_candidate_p): Consider the pattern
	(zero_extend:DI (mem:SI ...)) to be a candidate for DImode STV.

2026-07-01  Roger Sayle  <roger@nextmovesoftware.com>

	* simplify-rtx.cc (simplify_context::simplify_ternary_operation)
	<case VEC_MERGE>: Simplify a vec_merge of a vec_merge with a
	repeated operand.

2026-07-01  Stefan Schulze Frielinghaus  <stefansf@gcc.gnu.org>

	PR target/126054
	* config/s390/s390.md: Fix
	extzv_<mode>_{srl,sll}<clobbercc_or_nocc> by adjusting the
	bitmasks in the output templates.

2026-07-01  Jakub Jelinek  <jakub@redhat.com>

	* config/aarch64/tuning_models/neoversev2.h
	(neoversev2_dispatch_constraint_callback): Remove spurious semicolon.
	* config/aarch64/aarch64-elf-metadata.cc
	(gnu_property_features_to_string): Likewise.
	* config/aarch64/aarch64-sve-builtins-shapes.cc (SHAPE (write_zt),
	SHAPE (write_lane_zt)): Likewise.

2026-07-01  Jakub Jelinek  <jakub@redhat.com>

	* config/aarch64/aarch64-neon-builtins-base.h: Use
	namespace aarch64_acle { namespace functions { ... } } instead of
	C++17 namespace aarch64_acle::functions { ... }.
	* config/aarch64/aarch64-neon-builtins-shapes.h: Use
	namespace aarch64_acle { namespace shapes { ... } } instead of
	C++17 namespace aarch64_acle::shapes { ... }.
	* config/aarch64/aarch64-neon-builtins-shapes.cc: Likewise.

2026-07-01  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/125040
	* tree-ssa-pre.cc (clean): Iterate processing.

2026-07-01  Alfie Richards  <alfie.richards@arm.com>

	* tree-ssa-loop-manip.h: Add argument to create_iv.
	* tree-ssa-loop-manip.cc (create_iv): Change step to not
	necessarily be loop invariant.
	* tree-vect-data-refs.cc (bump_vector_ptr): Remove logic for
	updating use-def chain.
	* tree-vect-loop-manip.cc (vect_set_loop_controls_directly):
	Change to use LOOP_VINFO_IV_INCREMENT instead of VF.
	(vect_set_loop_condition_partial_vectors_avx512):
	Change to use LOOP_VINFO_IV_INCREMENT instead of VF.
	(vect_gen_vector_loop_niters): Update to handle
	LOOP_VINFO_IV_INCREMENT.
	(vect_get_loop_iv_increment): New function.
	* tree-vect-loop.cc (vectorizable_induction): Update to use
	LOOP_VINFO_IV_INCREMENT instead of VF, and remove SELECT_VL
	logic.
	(vect_update_ivs_after_vectorizer_for_early_breaks):
	Update to use LOOP_VINFO_IV_INCREMENT over VF and move IV
	update to vect_iv_increment_position.
	(vect_transform_loop): Add initialization of
	LOOP_VINFO_IV_INCREMENT.
	* tree-vect-stmts.cc (vect_get_strided_load_store_ops):
	Update to use dr_increment and dr_bump, remove SELECT_VL logic.
	(vect_get_data_ptr_increment): Change to return the increment
	needed to advance the pointer to the next iteration.
	(vect_get_data_ptr_bump): New function.
	(vectorizable_scan_store): Update to use vect_get_data_ptr_bump
	and to remove SELECT_VL logic.
	(vectorizable_store): Update to use vect_get_data_ptr_bump and
	vect_get_data_ptr_increment.
	(vectorizable_load): Update to use vect_get_data_ptr_bump and
	vect_get_data_ptr_increment.
	* tree-vectorizer.h (loop_vec_info): Add iv_increment field.
	(LOOP_VINFO_IV_INCREMENT): New macro.
	(LOOP_VINFO_IV_INCREMENT_INVARIANT_P): New macro.
	(bump_vector_ptr): Remove incr_ptr argument.
	(vect_get_loop_iv_increment): New function.

2026-07-01  Alfie Richards  <alfie.richards@arm.com>

	* tree-vect-data-refs.cc (vect_create_data_ref_ptr): Check for null
	pntr_incr.

2026-07-01  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/125040
	* tree-ssa-pre.cc (sorted_array_from_bitmap_set): Compute
	the set of entries to the value graph before building the
	final sorted expression set.

2026-07-01  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* configure.ac: Remove --with-gnu-ld, gnu_ld_flag.
	* configure: Regenerate.
	* config.gcc: Remove gnu_ld_flag.
	* doc/install.texi (Configuration, --with-gnu-ld): Remove.
	(Specific, all ELF targets): Remove GNU ld link.
	* doc/invoke.texi (IA-64 Options, -mgnu-ld): Remove comment.

2026-07-01  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* config.gcc: Remove gnu_ld.
	<*-*-vms*>: Check ld_flavor instead of gnu_ld.
	<ia64*-*-elf*> (target_cpu_default): Always add MASK_GNU_LD.
	<mips*-*-*> (target_cpu_default2): Always add
	MASK_SPLIT_ADDRESSES.
	<hppa*64*-*-hpux11*> (target_cpu_default): Check ld_flavor instead
	of gnu_ld.  Move ...
	* configure.ac: ... here.
	Remove gnu_ld.
	Check ld_flavor instead of gnu_ld.
	(gcc_cv_ld_static_dynamic) <*-*-hpux*>: Don't check gnu_ld.
	(gcc_cv_ld_version_script): Check ld --help for --version-script.
	(gcc_cv_ld_soname): Check ld --help for -soname.
	<*-*-darwin*>: Always use Darwin version.
	<*-*-solaris2*>: Always use Solaris version with Solaris ld.
	(gcc_cv_ld_demangle): Don't check gnu_ld.
	* configure: Regenerate.

2026-07-01  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* configure.ac (HAVE_GNU_LD): Remove.
	(gcc_cv_ld_at_file): New test.
	* configure: Regenerate.
	* config.in: Regenerate.
	* collect2.cc: Check HAVE_LD_AT_FILE instead of HAVE_GNU_LD.

2026-07-01  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* configure.ac: Remove --with-gnu-as, gas_flag.
	* configure: Regenerate.
	* config.gcc: Remove gas_flag.
	* doc/install.texi (Configuration, --with-gnu-as): Remove.
	(Specific, hppa64-hp-hpux11*): Remove --with-gnu-as reference.
	(Specific, ia64-*-hpux*): Likewise.  Recomment --with-as instead.
	* doc/invoke.texi (IA-64 Options, -mgnu-as): Remove comment.

2026-07-01  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* acinclude.m4 (gcc_GAS_FLAGS): Check as_flavor instead of gas.
	* config.gcc: Remove gas.
	<ia64*-*-elf*> (target_cpu_defaults): Always add MASK_GNU_AS.
	<ia64-hp-*vms*>: Likewise.
	<hppa*-*-*> (target_cpu_default2): Always add MASK_GAS.
	* configure.ac: Remove gas.
	* configure: Regenerate.

2026-07-01  Eric Botcazou  <ebotcazou@adacore.com>

	* tree-ssa-structalias.cc (set_uids_in_ptset): If ANYTHING is
	present in the ESCAPED_RETURN solution, record that the global
	solution has an escaped heap if FROM contains a heap variable.

2026-07-01  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* gcc.cc (asm_options) [HAVE_GNU_AS]: Move to ...
	(ASM_V_SPEC) ... this.
	* config/nvptx/nvptx.h (ASM_SPEC): Rename to ASM_V_SPEC.
	Adjust comment.
	* config/rs6000/aix.h [HAVE_AIX_AS] (ASM_V_SPEC): Define.
	* config/sol2.h (ASM_SPEC_BASE): Move -v handling to ...
	[HAVE_SOLARIS_AS] (ASM_V_SPEC): ... this.  Also handle -w.
	* doc/tm.texi.in (Driver, ASM_V_SPEC): Document.
	* doc/tm.texi: Regenerate.
	* config/darwin.h (ASM_OPTIONS): Remove.
	* config/i386/darwin.h (ASM_SPEC): Remove ASM_OPTIONS.
	* config/ia64/hpux.h (AS_NEEDS_DASH_FOR_PIPED_INPUT): Remove.
	* configure.ac (HAVE_GNU_AS): Remove.
	* configure: Regenerate.
	* config.in: Regenerate.

2026-07-01  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* acinclude.m4: Check as_flavor, ld_flavor instead of solaris_as,
	solaris_ld.
	* configure.ac: Likewise.
	(as_flavor, ld_flavor): New variables.
	Adapt messages.
	Set based on as, ld version output.
	(HAVE_AIX_AS): Define.
	* configure: Regenerate.
	* config.in: Regenerate.

2026-07-01  Haochen Jiang  <haochen.jiang@intel.com>

	* common/config/i386/cpuinfo.h
	(get_available_features): Remove AMX-TF32.
	* common/config/i386/i386-common.cc
	(OPTION_MASK_ISA2_AMX_TF32_SET): Removed.
	(OPTION_MASK_ISA2_AMX_TF32_UNSET): Ditto.
	(OPTION_MASK_ISA2_AMX_TILE_UNSET): Remove AMX_TF32.
	(ix86_handle_option): Ditto.
	* common/config/i386/i386-cpuinfo.h
	(enum processor_features): Remove FEATURE_AMX_TF32.
	* common/config/i386/i386-isas.h: Remove AMX-TF32.
	* config.gcc: Do not include amxtf32intrin.h.
	* config/i386/amxtf32intrin.h: Remove AMX-TF32 intrins.
	* config/i386/cpuid.h (bit_AMX_TF32): Removed.
	* config/i386/i386-c.cc
	(ix86_target_macros_internal): Remove AMX_TF32.
	* config/i386/i386-isa.def (AMX_TF32): Removed.
	* config/i386/i386-options.cc
	(ix86_valid_target_attribute_inner_p): Remove AMX-TF32.
	* config/i386/i386.opt: Ditto.
	* config/i386/i386.opt.urls: Ditto.
	* config/i386/immintrin.h: Do not include amxtf32intrin.h.
	* doc/extend.texi: Remove amx-tf32.
	* doc/invoke.texi: Ditto.
	* doc/sourcebuild.texi: Ditto.

2026-07-01  Haochen Jiang  <haochen.jiang@intel.com>

	* config/i386/i386.h (PTA_DIAMONDRAPIDS): Remove PTA_AMX_TF32.
	* doc/invoke.texi: Correct documentation.

2026-06-30  Oleg Endo  <olegendo@gcc.gnu.org>

	PR target/55212
	* config/sh/predicates.md (simple_mem_operand):
	Use 'satisfies_constraint_Sra'.
	(post_inc_mem, pre_dec_mem): Use 'satisfies_constraint_Rab'.
	* config/sh/constraints.md (Rab, Rai, Sgb): New constraints.
	(Sua, Sdd, Snd, Ssd, Sbv, Sra, Ara, Add): Use Rab and Rai constraints.
	* config/sh/sync.md (atomic_mem_operand_0, atomic_mem_operand_1): Reject
	GBR addresses when hard-llcs atomic mode is enabled.

2026-06-30  Abhishek Kaushik  <abhishek.kaushik@arm.com>

	* config/aarch64/aarch64.cc: Include gimple-fold.h.
	(aarch64_try_widen_mult_by_pow2): New function.
	(aarch64_instruction_selection): Call it for conversion assignments.

2026-06-30  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/125961
	* tree-ssa-phiopt.cc (factor_out_conditional_operation): Use
	remove_phi_node instead of gsi_remove for the phi node.
	(factor_out_conditional_load): Likewise.

2026-06-30  Karl Meakin  <karl.meakin@arm.com>

	* config/aarch64/aarch64-acle-builtins.h
	(TYPES_neon_reinterpret1, TYPES_neon_reinterpret,
	TYPES_neon_reinterpretq1, TYPES_neon_reinterpretq,
	neon_reinterpret, neon_reinterpretq): New type lists.
	* config/aarch64/aarch64-builtins.cc (VREINTERPRET_BUILTIN2,
	VREINTERPRET_BUILTINS1, VREINTERPRET_BUILTINS,
	VREINTERPRETQ_BUILTIN2, VREINTERPRETQ_BUILTINS1,
	VREINTERPRETQ_BUILTINS, VREINTERPRET_BUILTIN): Delete macros.
	(AARCH64_SIMD_VREINTERPRET_BUILTINS): Delete enum member.
	(aarch64_init_simd_intrinsics): Delete function.
	(init_arm_neon_builtins): Delete call to
	`aarch64_init_simd_intrinsics`.
	(aarch64_general_fold_builtin): Delete case for
	`AARCH64_SIMD_VREINTERPRET_BUILTINS`.
	* config/aarch64/aarch64-neon-builtins-base.cc (struct
	gimple_reinterpret): New struct.
	(vreinterpret, vreinterpretq): New function bases.
	* config/aarch64/aarch64-neon-builtins-base.def (vreinterpret,
	vreinterpretq): New function groups.

2026-06-30  Karl Meakin  <karl.meakin@arm.com>

	* config/aarch64/aarch64-simd-pragma-builtins.def (vext_mf8,
	vextq_mf8, vrev64_mf8, vrev64q_mf8, vrev32_mf8, vrev32q_mf8,
	vrev16_mf8, vrev16q_mf8, vtrn1_mf8, vtrn1q_mf8, vtrn2_mf8,
	vtrn2q_mf8, vtrn_mf8, vtrnq_mf8, vuzp1_mf8, vuzp1q_mf8,
	vuzp2_mf8, vuzp2q_mf8, vuzp_mf8, vuzpq_mf8, vzip1_mf8,
	vzip1q_mf8, vzip2_mf8, vzip2q_mf8, vzip_mf8, vzipq_mf8):
	Delete functions.
	* config/aarch64/aarch64-sve-builtins-shapes.cc (parse_type):
	Handle `D` or `Q` followed by `x1,x2,x3,x4` to mean tuple
	types.
	* config/aarch64/aarch64-acle-builtins.h (TYPES_bh_poly,
	TYPES_bhs_neon, TYPES_neon_rev16, TYPES_neon_rev32,
	TYPES_neon_rev64): New type lists.
	(bh_poly, bhs_neon, neon_rev16, neon_rev32, neon_rev64):
	Likewise.
	* config/aarch64/aarch64-builtins.cc (aarch64_simd_tuple_types):
	Remove `static` qualifier.
	* config/aarch64/aarch64-builtins.h (aarch64_simd_tuple_types):
	New declaration.
	* config/aarch64/aarch64-neon-builtins-base.cc (build_tuple_get,
	build_tuple_set): New functions.
	(class gimple_permute, class gimple_permute_pair): New classes.
	(ext_mask, rev_mask, trn_mask, uzp_mask, zip_mask): New
	functions.
	(vext, vextq, vrev16, vrev16q, vrev32, vrev32q, vtrn1, vtrn1q,
	btrn2, vtrn2q, vtrn, vtrnq, vuzp1, vuzp1q, vuzp2, vuzp2q, vuzp,
	vuzpq, vzip1, vzip1q, vzip2, vzip2q, vzip, vzipq): New function
	bases.
	* config/aarch64/aarch64-neon-builtins-base.def (vext, vextq,
	vrev16, vrev16q, vrev32, vrev32q, vrev64, vrev64q, vtrn,
	vtrn1, vtrn1q, vtrn2, vtrn2q, vtrnq, vuzp, vuzp1, vuzp1q,
	vuzp2, vuzp2q, vuzpq, vzip, vzip1, vzip1q, vzip2, vzip2q,
	vzipq): New function groups.
	* config/aarch64/aarch64-simd-builtins.def (zip1, zip2, uzp1,
	uzp2, trn1, trn2): Delete builtin functions.
	* config/aarch64/arm_neon.h (vext_f16, vext_f32, vext_f64,
	vext_p8, vext_p16, vext_p64, vext_s8, vext_s16, vext_s32,
	vext_s64, vext_u8, vext_u16, vext_u32, vext_u64, vextq_f16,
	vextq_f32, vextq_f64, vextq_p8, vextq_p16, vextq_p64,
	vextq_s8, vextq_s16, vextq_s32, vextq_s64, vextq_u8,
	vextq_u16, vextq_u32, vextq_u64, vrev16_p8, vrev16_s8,
	vrev16_u8, vrev16q_p8, vrev16q_s8, vrev16q_u8, vrev32_p8,
	vrev32_p16, vrev32_s8, vrev32_s16, vrev32_u8, vrev32_u16,
	vrev32q_p8, vrev32q_p16, vrev32q_s8, vrev32q_s16, vrev32q_u8,
	vrev32q_u16, vrev64_f16, vrev64_f32, vrev64_p8, vrev64_p16,
	vrev64_s8, vrev64_s16, vrev64_s32, vrev64_u8, vrev64_u16,
	vrev64_u32, vrev64q_f16, vrev64q_f32, vrev64q_p8, vrev64q_p16,
	vrev64q_s8, vrev64q_s16, vrev64q_s32, vrev64q_u8, vrev64q_u16,
	vrev64q_u32, vtrn1_f16, vtrn1_f32, vtrn1_p8, vtrn1_p16,
	vtrn1_s8, vtrn1_s16, vtrn1_s32, vtrn1_u8, vtrn1_u16,
	vtrn1_u32, vtrn1q_f16, vtrn1q_f32, vtrn1q_f64, vtrn1q_p8,
	vtrn1q_p16, vtrn1q_s8, vtrn1q_s16, vtrn1q_s32, vtrn1q_s64,
	vtrn1q_u8, vtrn1q_u16, vtrn1q_u32, vtrn1q_p64, vtrn1q_u64,
	vtrn2_f16, vtrn2_f32, vtrn2_p8, vtrn2_p16, vtrn2_s8,
	vtrn2_s16, vtrn2_s32, vtrn2_u8, vtrn2_u16, vtrn2_u32,
	vtrn2q_f16, vtrn2q_f32, vtrn2q_f64, vtrn2q_p8, vtrn2q_p16,
	vtrn2q_s8, vtrn2q_s16, vtrn2q_s32, vtrn2q_s64, vtrn2q_u8,
	vtrn2q_u16, vtrn2q_u32, vtrn2q_u64, vtrn2q_p64, vtrn_f16,
	vtrn_f32, vtrn_p8, vtrn_p16, vtrn_s8, vtrn_s16, vtrn_s32,
	vtrn_u8, vtrn_u16, vtrn_u32, vtrnq_f16, vtrnq_f32, vtrnq_p8,
	vtrnq_p16, vtrnq_s8, vtrnq_s16, vtrnq_s32, vtrnq_u8,
	vtrnq_u16, vtrnq_u32, vuzp1_f16, vuzp1_f32, vuzp1_p8,
	vuzp1_p16, vuzp1_s8, vuzp1_s16, vuzp1_s32, vuzp1_u8,
	vuzp1_u16, vuzp1_u32, vuzp1q_f16, vuzp1q_f32, vuzp1q_f64,
	vuzp1q_p8, vuzp1q_p16, vuzp1q_s8, vuzp1q_s16, vuzp1q_s32,
	vuzp1q_s64, vuzp1q_u8, vuzp1q_u16, vuzp1q_u32, vuzp1q_u64,
	vuzp1q_p64, vuzp2_f16, vuzp2_f32, vuzp2_p8, vuzp2_p16,
	vuzp2_s8, vuzp2_s16, vuzp2_s32, vuzp2_u8, vuzp2_u16,
	vuzp2_u32, vuzp2q_f16, vuzp2q_f32, vuzp2q_f64, vuzp2q_p8,
	vuzp2q_p16, vuzp2q_s8, vuzp2q_s16, vuzp2q_s32, vuzp2q_s64,
	vuzp2q_u8, vuzp2q_u16, vuzp2q_u32, vuzp2q_u64, vuzp2q_p64,
	vzip1_f16, vzip1_f32, vzip1_p8, vzip1_p16, vzip1_s8,
	vzip1_s16, vzip1_s32, vzip1_u8, vzip1_u16, vzip1_u32,
	vzip1q_f16, vzip1q_f32, vzip1q_f64, vzip1q_p8, vzip1q_p16,
	vzip1q_s8, vzip1q_s16, vzip1q_s32, vzip1q_s64, vzip1q_u8,
	vzip1q_u16, vzip1q_u32, vzip1q_u64, vzip1q_p64, vzip2_f16,
	vzip2_f32, vzip2_p8, vzip2_p16, vzip2_s8, vzip2_s16,
	vzip2_s32, vzip2_u8, vzip2_u16, vzip2_u32, vzip2q_f16,
	vzip2q_f32, vzip2q_f64, vzip2q_p8, vzip2q_p16, vzip2q_s8,
	vzip2q_s16, vzip2q_s32, vzip2q_s64, vzip2q_u8, vzip2q_u16,
	vzip2q_u32, vzip2q_u64, vzip2q_p64): Delete functions.

2026-06-30  Karl Meakin  <karl.meakin@arm.com>

	* config/aarch64/aarch64.md (UNSPEC_BSL): Delete unspec.
	* config/aarch64/aarch64-simd-pragma-builtins.def (vbsl_mf8,
	vbslq_mf8): Delete functions.
	* config/aarch64/aarch64-neon-builtins-base.cc (build_cast): New
	function.
	(class gimple_not_rhs, class gimple_bsl, class gimple_rbit,
	class gimple_eor3, class gimple_bcax, class gimple_rax1, class
	gimple_xar, class gimple_ifn): New classes.
	(vand, vandq, vbic, vbicq, vbsl, vbslq, veor, veorq, vmvn,
	vmvnq, vorn, vornq, vorr, vorrq, vrbit, vrbitq, vbcaxq, veor3q,
	vrax1q, vxarq, vcls, vclsq, vclz, vclzq, vcnt, vcntq): New
	function bases.
	* config/aarch64/aarch64-neon-builtins-shapes.cc (shift): New function.
	* config/aarch64/aarch64-builtins.cc
	(aarch64_types_bsl_p_qualifiers,
	aarch64_types_bsl_s_qualifiers,
	aarch64_types_bsl_u_qualifiers): Delete unused qualifiers.
	* config/aarch64/aarch64-simd.md
	(@aarch64_rbit<mode><vczle><vczbe>): Add `@` modifier so that
	it is callable from `aarch64-neon-builtins-base.cc`.
	* config/aarch64/aarch64-acle-builtins.h (TYPES_b_neon,
	TYPES_b_poly): New type lists.
	* config/aarch64/aarch64-neon-builtins-base.def (vand, vandq,
	vbic, vbicq, vbsl, vbslq, veor, veorq, vmvn, vmvnq, vorn,
	vornq, vorr, vorrq, vrbit, vrbitq, vbcaxq, veor3q, vrax1q,
	vxarq, vcls, vclsq, vclz, vclzq, vcnt, vcntq): New function
	groups.
	* config/aarch64/aarch64-simd-builtins.def (clrsb, clz, ctz,
	popcount, rbit, simd_bsl): Delete builtin functions.
	* config/aarch64/arm_neon.h (vbsl_f16, vbsl_f32, vbsl_f64,
	vbsl_p8, vbsl_p16, vbsl_p64, vbsl_s8, vbsl_s16, vbsl_s32,
	vbsl_s64, vbsl_u8, vbsl_u16, vbsl_u32, vbsl_u64, vbslq_f16,
	vbslq_f32, vbslq_f64, vbslq_p8, vbslq_p16, vbslq_s8,
	vbslq_s16, vbslq_p64, vbslq_s32, vbslq_s64, vbslq_u8,
	vbslq_u16, vbslq_u32, vbslq_u64, vcls_s8, vcls_s16, vcls_s32,
	vclsq_s8, vclsq_s16, vclsq_s32, vcls_u8, vcls_u16, vcls_u32,
	vclsq_u8, vclsq_u16, vclsq_u32, vclz_s8, vclz_s16, vclz_s32,
	vclz_u8, vclz_u16, vclz_u32, vclzq_s8, vclzq_s16, vclzq_s32,
	vclzq_u8, vclzq_u16, vclzq_u32, vcnt_p8, vcnt_s8, vcnt_u8,
	vcntq_p8, vcntq_s8, vcntq_u8, vrbit_p8, vrbit_s8, vrbit_u8,
	vrbitq_p8, vrbitq_s8, vrbitq_u8, veor3q_u8, veor3q_u16,
	veor3q_u32, veor3q_u64, veor3q_s8, veor3q_s16, veor3q_s32,
	veor3q_s64, vrax1q_u64, vxarq_u64, vbcaxq_u8, vbcaxq_u16,
	vbcaxq_u32, vbcaxq_u64, vbcaxq_s8, vbcaxq_s16, vbcaxq_s32,
	vbcaxq_s64): Delete functions.

2026-06-30  Karl Meakin  <karlwfmeakin@gmail.com>

	* config/aarch64/aarch64-simd-pragma-builtins.def (
	vcopy_lane_mf8, vcopyq_lane_mf8, vcopy_laneq_mf8,
	vcopyq_laneq_mf8, vdup_lane_mf8, vdupq_lane_mf8,
	vdup_laneq_mf8, vdupq_laneq_mf8, vset_lane_mf8,
	vsetq_lane_mf8): Delete entries.
	* config/aarch64/aarch64-builtins.cc
	(AARCH64_SIMD_VGET_LOW_BUILTINS,
	AARCH64_SIMD_VGET_HIGH_BUILTINS, VGET_LOW_BUILTIN,
	VGET_HIGH_BUILTIN): Delete macros.
	(enum aarch64_builtins): Delete
	`AARCH64_SIMD_BUILTIN_LANE_CHECK`.
	(aarch64_init_simd_builtin_functions): Delete code that
	registers `__builtin_aarch64_im_lane_boundsi`.
	(aarch64_pragma_builtins_checker::check): Delete cases for
	`UNSPEC_DUP_LANE`, `UNSPEC_GET_LANE` and `UNSPEC_VEC_COPY`.
	(aarch64_simd_expand_builtin): Delete case for
	`AARCH64_SIMD_BUILTIN_LANE_CHECK`.
	(aarch64_expand_pragma_builtin): Delete cases for
	`UNSPEC_DUP_LANE` and `UNSPEC_VEC_COPY`.
	(aarch64_general_fold_builtin): Delete cases for
	`AARCH64_SIMD_VGET_LOW_BUILTINS`,
	`AARCH64_SIMD_VGET_HIGH_BUILTINS` and
	`AARCH64_SIMD_BUILTIN_LANE_CHECK`.
	(aarch64_gimple_fold_pragma_builtin): Delete cases for
	`UNSPEC_DUP_LANE` and `UNSPEC_VEC_COPY`.
	(aarch64_general_gimple_fold_builtin): Delete cases for
	`AARCH64_SIMD_BUILTIN_LANE_CHECK`.
	* config/aarch64/aarch64.md (UNSPEC_DUP_LANE): Delete unspec.
	* config/aarch64/aarch64-neon-builtins-shapes.cc (range, lane):
	New functions.
	(struct neon_shape): Add new fields for additional checks, and
	call them in `check()`.
	* config/aarch64/aarch64-acle-builtins.cc
	(gimple_folder::force_val, gimple_folder::assign): New
	functions.
	* config/aarch64/aarch64-acle-builtins.h (TYPES_all_neon,
	TYPES_bhsd_neon, TYPES_neon_copy_lane): New type lists.
	* config/aarch64/iterators.md (VALL_F16_NO_V2Q): Add `V4BF` and `V8BF`.
	* config/aarch64/aarch64-neon-builtins-base.def (vget_lane,
	vgetq_lane, vget_high, vget_low, vset_lane, vsetq_lane,
	vdup_lane, vdupq_lane, vdup_laneq, vdupq_laneq, vcopy_lane,
	vcopy_laneq, vcopyq_lane, vcopyq_laneq): New function groups.
	* config/aarch64/aarch64-neon-builtins-base.cc (build_lane_get,
	build_lane_set, build_vec_dup): New functions.
	(struct gimple_get_lane, struct gimple_get_half, struct
	gimple_set_lane, struct gimple_copy_lane, struct gimple_dup,
	struct gimple_dup_lane): New structs.
	(vget_lane, vgetq_lane, vset_lane, vsetq_lane, vcopy_lane,
	vcopyq_lane, vcopy_laneq, vcopyq_laneq, vdup_lane, vdupq_lane,
	vdupq_lane, vdupq_laneq): New function bases.
	* config/aarch64/arm_neon.h (__aarch64_vdup_lane_p8,
	__aarch64_vdup_lane_p16, __aarch64_vdup_lane_p64,
	__aarch64_vdup_lane_s8, __aarch64_vdup_lane_s16,
	__aarch64_vdup_lane_s32, __aarch64_vdup_lane_s64,
	__aarch64_vdup_lane_u8, __aarch64_vdup_lane_u16,
	__aarch64_vdup_lane_u32, __aarch64_vdup_lane_u64,
	__aarch64_vdup_laneq_p8, __aarch64_vdup_laneq_p16,
	__aarch64_vdup_laneq_p64, __aarch64_vdup_laneq_s8,
	__aarch64_vdup_laneq_s16, __aarch64_vdup_laneq_s32,
	__aarch64_vdup_laneq_s64, __aarch64_vdup_laneq_u8,
	__aarch64_vdup_laneq_u16, __aarch64_vdup_laneq_u32,
	__aarch64_vdup_laneq_u64, __aarch64_vdupq_lane_p8,
	__aarch64_vdupq_lane_p16, __aarch64_vdupq_lane_p64,
	__aarch64_vdupq_lane_s8, __aarch64_vdupq_lane_s16,
	__aarch64_vdupq_lane_s32, __aarch64_vdupq_lane_s64,
	__aarch64_vdupq_lane_u8, __aarch64_vdupq_lane_u16,
	__aarch64_vdupq_lane_u32, __aarch64_vdupq_lane_u64,
	__aarch64_vdupq_laneq_p8, __aarch64_vdupq_laneq_p16,
	__aarch64_vdupq_laneq_p64, __aarch64_vdupq_laneq_s8,
	__aarch64_vdupq_laneq_s16, __aarch64_vdupq_laneq_s32,
	__aarch64_vdupq_laneq_s64, __aarch64_vdupq_laneq_u8,
	__aarch64_vdupq_laneq_u16, __aarch64_vdupq_laneq_u32,
	__aarch64_vdupq_laneq_u64, __AARCH64_LANE_CHECK,
	__aarch64_vget_lane_any, __aarch64_vset_lane_any): Delete
	macros.
	(vget_lane_f16, vget_lane_f32, vget_lane_f64, vget_lane_p8,
	vget_lane_p16, vget_lane_p64, vget_lane_s8, vget_lane_s16,
	vget_lane_s32, vget_lane_s64, vget_lane_u8, vget_lane_u16,
	vget_lane_u32, vget_lane_u64, vgetq_lane_f16, vgetq_lane_f32,
	vgetq_lane_f64, vgetq_lane_p8, vgetq_lane_p16, vgetq_lane_p64,
	vgetq_lane_s8, vgetq_lane_s16, vgetq_lane_s32, vgetq_lane_s64,
	vgetq_lane_u8, vgetq_lane_u16, vgetq_lane_u32, vgetq_lane_u64,
	vset_lane_f16, vset_lane_f32, vset_lane_f64, vset_lane_p8,
	vset_lane_p16, vset_lane_p64, vset_lane_s8, vset_lane_s16,
	vset_lane_s32, vset_lane_s64, vset_lane_u8, vset_lane_u16,
	vset_lane_u32, vset_lane_u64, vsetq_lane_f16, vsetq_lane_f32,
	vsetq_lane_f64, vsetq_lane_p8, vsetq_lane_p16, vsetq_lane_p64,
	vsetq_lane_s8, vsetq_lane_s16, vsetq_lane_s32, vsetq_lane_s64,
	vsetq_lane_u8, vsetq_lane_u16, vsetq_lane_u32, vsetq_lane_u64,
	vcopy_lane_f32, vcopy_lane_f64, vcopy_lane_p8, vcopy_lane_p16,
	vcopy_lane_p64, vcopy_lane_s8, vcopy_lane_s16, vcopy_lane_s32,
	vcopy_lane_s64, vcopy_lane_u8, vcopy_lane_u16, vcopy_lane_u32,
	vcopy_lane_u64, vcopy_laneq_f32, vcopy_laneq_f64,
	vcopy_laneq_p8, vcopy_laneq_p16, vcopy_laneq_p64,
	vcopy_laneq_s8, vcopy_laneq_s16, vcopy_laneq_s32,
	vcopy_laneq_s64, vcopy_laneq_u8, vcopy_laneq_u16,
	vcopy_laneq_u32, vcopy_laneq_u64, vcopyq_lane_f32,
	vcopyq_lane_f64, vcopyq_lane_p8, vcopyq_lane_p16,
	vcopyq_lane_p64, vcopyq_lane_s8, vcopyq_lane_s16,
	vcopyq_lane_s32, vcopyq_lane_s64, vcopyq_lane_u8,
	vcopyq_lane_u16, vcopyq_lane_u32, vcopyq_lane_u64,
	vcopyq_laneq_f32, vcopyq_laneq_f64, vcopyq_laneq_p8,
	vcopyq_laneq_p16, vcopyq_laneq_p64, vcopyq_laneq_s8,
	vcopyq_laneq_s16, vcopyq_laneq_s32, vcopyq_laneq_s64,
	vcopyq_laneq_u8, vcopyq_laneq_u16, vcopyq_laneq_u32,
	vcopyq_laneq_u64, vdup_lane_f16, vdup_lane_f32, vdup_lane_f64,
	vdup_lane_p8, vdup_lane_p16, vdup_lane_p64, vdup_lane_s8,
	vdup_lane_s16, vdup_lane_s32, vdup_lane_s64, vdup_lane_u8,
	vdup_lane_u16, vdup_lane_u32, vdup_lane_u64, vdup_laneq_f16,
	vdup_laneq_f32, vdup_laneq_f64, vdup_laneq_p8, vdup_laneq_p16,
	vdup_laneq_p64, vdup_laneq_s8, vdup_laneq_s16, vdup_laneq_s32,
	vdup_laneq_s64, vdup_laneq_u8, vdup_laneq_u16, vdup_laneq_u32,
	vdup_laneq_u64, vdupq_lane_f16, vdupq_lane_f32,
	vdupq_lane_f64, vdupq_lane_p8, vdupq_lane_p16, vdupq_lane_p64,
	vdupq_lane_s8, vdupq_lane_s16, vdupq_lane_s32, vdupq_lane_s64,
	vdupq_lane_u8, vdupq_lane_u16, vdupq_lane_u32, vdupq_lane_u64,
	vdupq_laneq_f16, vdupq_laneq_f32, vdupq_laneq_f64,
	vdupq_laneq_p8, vdupq_laneq_p16, vdupq_laneq_p64,
	vdupq_laneq_s8, vdupq_laneq_s16, vdupq_laneq_s32,
	vdupq_laneq_s64, vdupq_laneq_u8, vdupq_laneq_u16,
	vdupq_laneq_u32, vdupq_laneq_u64, vmulq_lane_f64,
	vset_lane_bf16, vsetq_lane_bf16, vget_lane_bf16,
	vgetq_lane_bf16, vdup_lane_bf16, vdup_laneq_bf16,
	vdupq_lane_bf16, vdupq_laneq_bf16, vcopy_lane_bf16,
	vcopyq_lane_bf16, vcopy_laneq_bf16, vcopyq_laneq_bf16): Delete
	functions.

2026-06-30  Karl Meakin  <karlwfmeakin@gmail.com>

	* config/aarch64/aarch64-simd-builtins.def (combine): Delete
	function declarations.
	* config/aarch64/aarch64-simd-pragma-builtins.def (vcombine_mf8,
	vcreate_mf8, vdup_n_mf8, vdupq_n_mf8, vmov_n_mf8,
	vmovq_n_mf8,): Delete entries.
	(aarch64_expand_pragma_builtin): Delete cases for
	`UNSPEC_COMBINE` and `UNSPEC_VCREATE`.
	(aarch64_fold_combine): Delete function.
	(aarch64_gimple_fold_pragma_builtin): Delete cases for
	`UNSPEC_COMBINE` and `UNSPEC_VCREATE`.
	(aarch64_general_gimple_fold_builtin): Delete cases for
	`vcombine`.
	* config/aarch64/aarch64.md (UNSPEC_COMBINE): Delete unspec.
	* config/aarch64/aarch64-builtins.cc
	(aarch64_expand_pragma_builtin): Delete cases for
	`UNSPEC_COMBINE` and `UNSPEC_VCREATE`.
	(aarch64_fold_combine): Delete function.
	(aarch64_gimple_fold_pragma_builtin): Delete cases for
	`UNSPEC_COMBINE` and `UNSPEC_VCREATE`.
	(aarch64_general_gimple_fold_builtin): Delete cases for
	`combine`.
	* config/aarch64/aarch64-acle-builtins.cc
	(gimple_folder::force_val, gimple_folder::assign): New
	functions.
	* config/aarch64/aarch64-acle-builtins.h (TYPES_all_neon,
	TYPES_bhsd_neon): New type lists.
	* config/aarch64/aarch64-neon-builtins-base.def (vcreate,
	vcombine, vdup_n, vdupq_n, vmov_n, vmovq_n): New function groups.
	* config/aarch64/aarch64-neon-builtins-base.cc (build_vec_dup): New function.
	(struct gimple_create, struct gimple_combine, struct struct
	gimple_dup): New structs.
	(vcreate, vcombine, vdup_n, vdupq_n, vmov_n, vmovq_n): New
	function bases.
	* config/aarch64/arm_neon.h (vcreate_s8, vcreate_s16,
	vcreate_s32, vcreate_s64, vcreate_f16, vcreate_f32,
	vcreate_u8, vcreate_u16, vcreate_u32, vcreate_u64,
	vcreate_f64, vcreate_p8, vcreate_p16, vcreate_p64,
	vcombine_s8, vcombine_s16, vcombine_s32, vcombine_s64,
	vcombine_f16, vcombine_f32, vcombine_u8, vcombine_u16,
	vcombine_u32, vcombine_u64, vcombine_f64, vcombine_p8,
	vcombine_p16, vcombine_p64, vdup_n_f16, vdup_n_f32,
	vdup_n_f64, vdup_n_p8, vdup_n_p16, vdup_n_p64, vdup_n_s8,
	vdup_n_s16, vdup_n_s32, vdup_n_s64, vdup_n_u8, vdup_n_u16,
	vdup_n_u32, vdup_n_u64, vdupq_n_f16, vdupq_n_f32, vdupq_n_f64,
	vdupq_n_p8, vdupq_n_p16, vdupq_n_p64, vdupq_n_s8, vdupq_n_s16,
	vdupq_n_s32, vdupq_n_s64, vdupq_n_u8, vdupq_n_u16,
	vdupq_n_u32, vdupq_n_u64, vmov_n_f16, vmov_n_f32, vmov_n_f64,
	vmov_n_p8, vmov_n_p16, vmov_n_p64, vmov_n_s8, vmov_n_s16,
	vmov_n_s32, vmov_n_s64, vmov_n_u8, vmov_n_u16, vmov_n_u32,
	vmov_n_u64, vmovq_n_f16, vmovq_n_f32, vmovq_n_f64, vmovq_n_p8,
	vmovq_n_p16, vmovq_n_p64, vmovq_n_s8, vmovq_n_s16,
	vmovq_n_s32, vmovq_n_s64, vmovq_n_u8, vmovq_n_u16,
	vmovq_n_u32, vmovq_n_u64, vcreate_bf16, vcombine_bf16,
	vdup_n_bf16, vdupq_n_bf16): Delete functions.

2026-06-30  Karl Meakin  <karl.meakin@arm.com>

	* config/aarch64/aarch64-neon-builtins-base.cc: New file.
	* config/aarch64/aarch64-neon-builtins-base.def: New file.
	* config/aarch64/aarch64-neon-builtins-base.h: New file.
	* config/aarch64/aarch64-neon-builtins-functions.h: New file.
	* config/aarch64/aarch64-neon-builtins-shapes.cc: New file.
	* config/aarch64/aarch64-neon-builtins-shapes.h: New file.
	* config/aarch64/aarch64-neon-builtins.def: New file.
	* config.gcc (extra_headers, extra_objs): Add new files and
	reformat for readability.
	* config/aarch64/t-aarch64: Add recipes for new files.
	* config/aarch64/aarch64-protos.h (handle_arm_neon_h): Rename to
	`init_arm_neon_builtins`.
	* config/aarch64/aarch64-builtins.cc (handle_arm_neon_h): Likewise.
	* config/aarch64/aarch64-c.cc (aarch64_pragma_aarch64): Call
	`aarch64_acle::handle_arm_neon_h`.
	* config/aarch64/aarch64-acle-builtins.cc (TYPES_*): Move to
	aarch64-acle-builtins.h
	(NONSTREAMING_SVE, SVE_AND_SME, SSVE): Likewise.
	(neon_function_groups): New variable.
	(arm_neon_h_handled): Likewise.
	(handle_arm_neon_h): New function.
	* config/aarch64/aarch64-sve-builtins-shapes.cc:
	(gimple_folder::fold): Allow folding if `TARGET_SVE` is
	false but `TARGET_SIMD` is true.
	* config/aarch64/aarch64-sve-builtins.def (p8, p16, p64, 128):
	New type suffixes.
	* config/aarch64/aarch64-acle-builtins.h (enum
	handle_pragma_index): New enum member `arm_neon_handle`.
	(enum type_class_index): New enum member `TYPE_poly`.
	(TYPES_*): Moved from `aarch64-acle-builtins.cc`.
	(NONSTREAMING_SVE, SVE_AND_SME, SSVE): Likewise.
	* config/aarch64/arm_neon.h (vadd_s8, vadd_s16, vadd_s32,
	vadd_f32, vadd_f64, vadd_u8, vadd_u16, vadd_u32, vadd_s64,
	vadd_u64, vaddq_s8, vaddq_s16, vaddq_s32, vaddq_s64,
	vaddq_f32, vaddq_f64, vaddq_u8, vaddq_u16, vaddq_u32,
	vaddq_u64, vadd_f16, vaddq_f16, vadd_p8, vadd_p16, vadd_p64,
	vaddq_p8, vaddq_p16, vaddq_p64, vaddq_p128, vaddd_u64,
	vaddd_s64): Delete function definitions.

2026-06-30  Karl Meakin  <karl.meakin@arm.com>

	* config.gcc (target_gtfiles): Rename
	`aarch64-sve-builtins.{h,cc}` to
	`aarch64-acle-builtins.{h,cc}`.
	* config/aarch64/t-aarch64: Likewise.
	* config/aarch64/aarch64-sve-builtins.h: Move to...
	* config/aarch64/aarch64-acle-builtins.h: ...here.
	* config/aarch64/aarch64-sve-builtins.cc: Move to...
	* config/aarch64/aarch64-acle-builtins.cc: ...here.
	* config/aarch64/aarch64-c.cc (aarch64_pragma_aarch64): Rename
	namespace `aarch64_sve` to `aarch64_acle`.
	(aarch64_resolve_overloaded_builtin): Likewise.
	(aarch64_check_builtin_call): Likewise.
	* config/aarch64/aarch64-protos.h: Likewise.
	* config/aarch64/aarch64-sve-builtins-base.cc: Likewise.
	* config/aarch64/aarch64-sve-builtins-base.h: Likewise.
	* config/aarch64/aarch64-sve-builtins-functions.h: Likewise.
	* config/aarch64/aarch64-sve-builtins-shapes.cc: Likewise.
	* config/aarch64/aarch64-sve-builtins-shapes.h: Likewise.
	* config/aarch64/aarch64-sve-builtins-sme.cc: Likewise.
	* config/aarch64/aarch64-sve-builtins-sme.h: Likewise.
	* config/aarch64/aarch64-sve-builtins-sve2.cc: Likewise.
	* config/aarch64/aarch64-sve-builtins-sve2.h: Likewise.
	* config/aarch64/aarch64.cc: Likewise.

2026-06-30  Karl Meakin  <karl.meakin@arm.com>

	* config.gcc: Reformat lists over several lines.

2026-06-30  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	* config/riscv/riscv.cc (synthesize_ior_xor): If we must synthesize a
	constant and Zbb is enabled, try both C and ~C to see which is cheaper.
	(synthesize_and): Likewise.

2026-06-30  Jim Lin  <jim@andestech.com>

	PR target/125853
	* common/config/riscv/riscv-common.cc (riscv_multi_lib_info_t::parse):
	Remove the path parameter and compare multi_lib_info->path against
	"." instead.
	(riscv_compute_multilib): Update caller.

2026-06-30  Jim Tsung-Chun Lin  <jim@andestech.com>

	Backported from master:
	2026-06-15  Jim Tsung-Chun Lin  <jim@andestech.com>

	* common/config/riscv/riscv-common.cc (riscv_select_multilib):
	Don't set riscv_no_matched_multi_lib here; let the caller own
	the flag.
	(riscv_compute_multilib): Drop the early return that accepted
	the generic-matched multilib_dir; always run the smart matcher
	and set riscv_no_matched_multi_lib when it finds no candidate.

2026-06-30  Mark Zhuang  <zhuangqiubin@linux.spacemit.com>

	* config/riscv/riscv-ext-spacemit.def (xsmtvdotii): New extension.
	* config/riscv/riscv-ext.opt: Regenerate.
	* config/riscv/riscv-cores.def (RISCV_TUNE): Add spacemit-a100.
	(RISCV_CORE): Add spacemit-a100.
	* doc/riscv-ext.texi: Regenerate.
	* doc/riscv-mcpu.texi: Regenerate.
	* doc/riscv-mtune.texi: Regenerate.

2026-06-30  Richard Biener  <rguenther@suse.de>

	* tree-ssa-alias.h (pt_solution::vars_contains_auto): New.
	(ptr_deref_may_alias_auto_p): Declare.
	(pt_solution_includes_auto): Likewise.
	* tree-ssa-structalias.cc (set_uids_in_ptset): Record auto
	variables.
	(pt_solution_includes_auto): New function.
	(ipa_escaped_pt): Adjust.
	* tree-ssa-alias.cc (ptr_deref_may_alias_auto_p): New function.

2026-06-30  Christopher Bazley  <chris.bazley@arm.com>
	    Richard Sandiford  <rdsandiford@googlemail.com>

	* tree.cc (build_vector_from_ctor): Rename variables and
	refactor assignments.

2026-06-30  Richard Biener  <rguenther@suse.de>

	* tree-ssa-loop-ivopts.cc (rewrite_use_address): Always
	avoid TARGET_MEM_REF with a base of zero.
	* tree-ssa-sccvn.cc (vn_reference_maybe_forwprop_address): Do
	not forward TARGET_MEM_REF addresses.

2026-06-30  Alfie Richards  <alfie.richards@arm.com>

	PR target/125838
	* config/aarch64/aarch64.cc (aarch64_fntype_abi): Fall back to
	AAPCS for preserve_none variadic calls.

2026-06-30  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/126032
	* gimple-ssa-warn-access.cc (maybe_warn_for_bound): Fixup
	diagnostic string.

2026-06-30  Chung-Lin Tang  <cltang@baylibre.com>

	* gimplify.cc (enum gimplify_omp_var_data):
	Add GOVD_USES_ALLOCATORS_ALLOCATOR.
	(gimplify_bind_expr): Diagnose missing uses_allocators clause.
	(omp_get_attachment): Add GOMP_MAP_USES_ALLOCATORS cases.
	(omp_group_base): Likewise.
	(gimplify_scan_omp_clauses): Handle uses_allocators.
	(gimplify_adjust_omp_clauses_1): Handle GOVD_USES_ALLOCATORS_ALLOCATOR.
	* omp-low.cc (scan_sharing_clauses): Check if ALLOCATE clause in target
	region has containing USES_ALLOCATORS clause.
	Add OMP_CLAUSE_USES_ALLOCATORS cases.
	(lower_omp_target): Add OMP_CLAUSE_USES_ALLOCATORS cases.
	* tree-pretty-print.cc (dump_omp_clause): Handle GOMP_MAP_USES_ALLOCATORS.

2026-06-30  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/126008
	* tree-ssa-loop-ivopts.cc (alloc_iv): Revert last change.
	* tree-ssa-address.cc (add_to_parts): Use unsigned arithmetic
	to accumulate to base.

2026-06-30  Christopher Bazley  <chris.bazley@arm.com>
	    Richard Sandiford  <rdsandiford@googlemail.com>

	* poly-int.h (can_div_away_from_zero_p):
	Exit early if |a| <= |b| instead of calling
	can_div_trunc_p and returning false if it
	returned false.

2026-06-30  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/126034
	* tree-vect-stmts.cc (vectorizable_load): Elide dead else if.

2026-06-30  Jakub Jelinek  <jakub@redhat.com>

	PR target/126030
	* config/i386/sse.md (avx512vl_<code><mode>v4hi2_mask_store_1):
	Use a single output pattern instead of conditionally returning
	the same string based on a condition.

2026-06-30  Jakub Jelinek  <jakub@redhat.com>

	PR c++/125837
	* doc/invoke.texi (Wc++29-extensions): Document.

2026-06-30  Avinash Jayakar  <avinashd@linux.ibm.com>
	    Surya Kumari Jangala  <jskumari@linux.ibm.com>

	* config/rs6000/rs6000-builtin.cc (rs6000_expand_builtin): Add logic to
	handle __builtin_ppc_atomic_cas_local.
	* config/rs6000/rs6000-builtins.def: New builtins for
	__builtin_ppc_atomic_cas_local with types.
	* config/rs6000/rs6000-c.cc (altivec_build_resolved_builtin): Handle
	builtins with up to 6 arguments.
	* config/rs6000/rs6000-overload.def: Overload builtin for signed/unsiged
	char, short, int, long, __int128.
	* config/rs6000/rs6000-protos.h (rs6000_expand_atomic_compare_and_swap): Add
	additional parameter 'local' to the prototype.
	* config/rs6000/rs6000.cc (emit_load_locked): Add new parameter. Pass new
	parameter to generate load-locked instruction.
	(rs6000_expand_atomic_compare_and_swap): Add new parameter. Call
	emit_load_locked() with additional parameter value of EH bit.
	(rs6000_expand_atomic_exchange): Pass EH value 0 to emit_load_locked().
	(rs6000_expand_atomic_op): Likewise.
	* config/rs6000/sync.md (load_locked<mode>): Add new operand in RTL template.
	Specify EH bit in the larx instruction.
	(load_locked<QHI:mode>_si): Likewise.
	(load_lockedpti): Likewise.
	(load_lockedti): Add new operand in RTL template. Pass EH bit to
	gen_load_lockedpti().
	(atomic_compare_and_swap<mode>): Pass new parameter 'false' to
	rs6000_expand_atomic_compare_and_swap.
	(atomic_compare_and_swap_local<mode>): New define_expand.
	* doc/extend.texi: Add documentation for new builtin.

2026-06-30  Avinash Jayakar  <avinashd@linux.ibm.com>

	Revert:
	2026-06-30  Avinash Jayakar  <avinashd@linux.ibm.com>
		    Surya Kumari Jangala  <jskumari@linux.ibm.com>

	* config/rs6000/rs6000-builtin.cc (rs6000_expand_builtin): Add logic to
	handle __builtin_ppc_atomic_cas_local.
	* config/rs6000/rs6000-builtins.def: New builtins for
	__builtin_ppc_atomic_cas_local with types.
	* config/rs6000/rs6000-c.cc (altivec_build_resolved_builtin): Handle
	builtins with up to 6 arguments.
	* config/rs6000/rs6000-overload.def: Overload builtin for signed/unsiged
	char, short, int, long, __int128.
	* config/rs6000/rs6000-protos.h (rs6000_expand_atomic_compare_and_swap): Add
	additional parameter 'local' to the prototype.
	* config/rs6000/rs6000.cc (emit_load_locked): Add new parameter. Pass new
	parameter to generate load-locked instruction.
	(rs6000_expand_atomic_compare_and_swap): Add new parameter. Call
	emit_load_locked() with additional parameter value of EH bit.
	(rs6000_expand_atomic_exchange): Pass EH value 0 to emit_load_locked().
	(rs6000_expand_atomic_op): Likewise.
	* config/rs6000/sync.md (load_locked<mode>): Add new operand in RTL template.
	Specify EH bit in the larx instruction.
	(load_locked<QHI:mode>_si): Likewise.
	(load_lockedpti): Likewise.
	(load_lockedti): Add new operand in RTL template. Pass EH bit to
	gen_load_lockedpti().
	(atomic_compare_and_swap<mode>): Pass new parameter 'false' to
	rs6000_expand_atomic_compare_and_swap.
	(atomic_compare_and_swap_local<mode>): New define_expand.
	* doc/extend.texi: Add documentation for new builtin.

2026-06-30  Avinash Jayakar  <avinashd@linux.ibm.com>
	    Surya Kumari Jangala  <jskumari@linux.ibm.com>

	* config/rs6000/rs6000-builtin.cc (rs6000_expand_builtin): Add logic to
	handle __builtin_ppc_atomic_cas_local.
	* config/rs6000/rs6000-builtins.def: New builtins for
	__builtin_ppc_atomic_cas_local with types.
	* config/rs6000/rs6000-c.cc (altivec_build_resolved_builtin): Handle
	builtins with up to 6 arguments.
	* config/rs6000/rs6000-overload.def: Overload builtin for signed/unsiged
	char, short, int, long, __int128.
	* config/rs6000/rs6000-protos.h (rs6000_expand_atomic_compare_and_swap): Add
	additional parameter 'local' to the prototype.
	* config/rs6000/rs6000.cc (emit_load_locked): Add new parameter. Pass new
	parameter to generate load-locked instruction.
	(rs6000_expand_atomic_compare_and_swap): Add new parameter. Call
	emit_load_locked() with additional parameter value of EH bit.
	(rs6000_expand_atomic_exchange): Pass EH value 0 to emit_load_locked().
	(rs6000_expand_atomic_op): Likewise.
	* config/rs6000/sync.md (load_locked<mode>): Add new operand in RTL template.
	Specify EH bit in the larx instruction.
	(load_locked<QHI:mode>_si): Likewise.
	(load_lockedpti): Likewise.
	(load_lockedti): Add new operand in RTL template. Pass EH bit to
	gen_load_lockedpti().
	(atomic_compare_and_swap<mode>): Pass new parameter 'false' to
	rs6000_expand_atomic_compare_and_swap.
	(atomic_compare_and_swap_local<mode>): New define_expand.
	* doc/extend.texi: Add documentation for new builtin.

2026-06-30  Xi Ruoyao  <xry111@xry111.site>

	* config/loongarch/loongarch.md
	(@stack_protect_combined_set_normal_<mode>): Replace `st.d'
	with `st.<d>', reject stptr.d on LA32 with enabled attribute.
	(@stack_protect_combined_test_internal_<mode>): Replace `ld.d'
	with `ld.<d>', reject ldptr.d on LA32 with enabled attribute.
	(@stack_protect_combined_set_extreme_<mode>): Rename to ...
	(stack_protect_combined_set_extreme): ... here.  Force DImode.
	Add TARGET_ABI_LP64 as the condition.
	(stack_protect_combined_set): Adapt for the change of
	stack_protect_combined_set_extreme.

2026-06-30  Robin Dapp  <robin.dapp@oss.qualcomm.com>

	PR target/125994
	* config/riscv/riscv.cc (riscv_support_vector_misalignment):
	Handle scalar modes.

2026-06-29  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	* config/riscv/riscv.cc (synthesize_and): Use srliw to handle
	clearing both upper and lower bits in some cases.
	* config/riscv/bitmanip.md (ZBA splitter using sext.w): Do not
	use in cases where we can use srliw to clear those upper bits.

2026-06-29  Mark Zhuang  <zhuangqiubin@linux.spacemit.com>

	* config/riscv/riscv-cores.def (RISCV_TUNE): Add spacemit-x100.
	(RISCV_CORE): Add spacemit-x100.
	* config/riscv/riscv.cc (spacemit_x100_tune_info): New.
	* doc/riscv-mcpu.texi: Regenerate.
	* doc/riscv-mtune.texi: Regenerate.

2026-06-29  Matthew Fortune  <matthew.fortune@imgtec.com>

	* config/mips/mips.h (ASM_SPEC): Add placeholders for -mmxu and
	-mno-mxu.
	* config/mips/mips.opt: New undocumented target option.

2026-06-29  Matthew Fortune  <matthew.fortune@imgtec.com>

	* config/mips/mips.cc (mips_frame_barrier): Upgrade to a full
	blockage.

2026-06-29  Roger Sayle  <roger@nextmovesoftware.com>

	PR target/94871
	* simplify-rtx.cc (simplify_unary_operation_1) <case NOT>:
	Update (not (eq X Y)) -> (ne X Y) to support vector comparions
	using VECTOR_STORE_FLAG_VALUE, and check SCALAR_INT_MODE_P
	when checking STORE_FLAG_VALUE.  Add equivalent optimization
	(not (neg (eq X Y))) -> (neg (ne X Y)) for targets with
	STORE_FLAG_VALUE == 1 or VECTOR_STORE_FLAG_VALUE is const1_rtx.
	* config/i386/sse.md (*<sse>_imaskcmp<mode>3_comm): Clone
	of *<sse>_maskcmp<mode>3_comm pattern with integer vector
	result.

2026-06-29  Abhishek Kaushik  <abhishek.kaushik@arm.com>

	* config/aarch64/aarch64-sve2.md: Add unpredicated high-part
	multiplication section.
	(@aarch64_sve2_<optab><mode>): New insn.
	* config/aarch64/aarch64-sve.md (@aarch64_pred_<optab><mode>):
	Change to define_insn_and_split and split SVE2 highpart
	multiplication into unpredicated MUL_HIGHPART.

2026-06-29  Jakub Jelinek  <jakub@redhat.com>

	PR target/125469
	* config/i386/i386.md (*add<mode>_1<nf_name>): Revert 2026-05-28
	changes.
	(define_split from *add<mode>_1_nf to *lea<mode>): Set INSN_CODE
	to -1 if <LEAMODE> and <MODE> are the same.

2026-06-29  Kyrylo Tkachov  <ktkachov@nvidia.com>

	PR target/105116
	* lra-constraints.cc (simplify_operand_subreg): Reload a
	non-representable narrowing subreg of a hard register through
	memory instead of resolving it lossily.

2026-06-29  Kael Andrew Alonzo Franco  <kaelfandrew@gmail.com>

	PR tree-optimization/125737
	* match.pd: Optimize X % Y < Y -> Y >= 0 and X % Y >= Y -> Y < 0

2026-06-29  H.J. Lu  <hjl.tools@gmail.com>

	PR target/125968
	* config/i386/i386-expand.cc (ix86_expand_movmem): Don't call
	ix86_expand_n_overlapping_move_movmem when max size == 1.

2026-06-29  Naveen  <naveen.siddegowda@oss.qualcomm.com>

	PR tree-optimization/112390
	* match.pd: Add simplifications for combined sign-bit and
	magnitude checks:
	((signed)A >= 0) &/&& ((A & INT_MAX) != 0) -> (signed)A > 0
	((signed)A <  0) |/|| ((A & INT_MAX) == 0) -> (signed)A <= 0

2026-06-29  liuhongt  <hongtao.liu@intel.com>

	PR target/125907
	* config/i386/i386.md (*cmov_bt<SWI248:mode>): New
	define_insn_and_split handling a const_int false arm, forced into
	a register by the splitter.  Leave the existing define_split for
	the nonimmediate case unchanged.

2026-06-29  Xi Ruoyao  <xry111@xry111.site>

	PR target/125474
	* config/loongarch/simd.md (usdot_prod<wvec_half><mode>): New
	define_expand.
	(usdot_prod<wvec_quarter><mode>): New define_expand.

2026-06-29  Pan Li  <pan2.li@intel.com>

	* match-sat-alu.pd: Add pattern for unsigned scalar
	SAT_MUL form 14.

2026-06-29  Pietro Monteiro  <pietro@sociotechnical.xyz>

	PR bootstrap/103459
	* acinclude.m4: Replace AC_FOREACH with m4_foreach_w.  Replace
	AC_TRY_LINK with AC_LINK_IFELSE.
	* configure: Regenerate.
	* configure.ac: Replace AC_HELP_STRING with AS_HELP_STRING.  Replace
	AC_PROG_LIBTOOL with LT_INIT.

2026-06-28  Kevin Stefanov  <kevinstefanov15@gmail.com>

	PR middle-end/125274
	* ctfc.h (ctf_dtdef): Likewise.
	* dwarf2out.cc (die_struct): Likewise.
	* dwarf2out.h (dw_cfa_location): Likewise.
	* gengtype-lex.l (IWORD): Remove BOOL_BITFIELD.
	* gimple-walk.h (walk_stmt_info): Replace BOOL_BITFIELD with bool.
	* opts.h (cl_option): Likewise.
	* config/i386/i386.h (machine_frame_state): Likewise.
	(machine_function): Likewise.
	* sched-int.h (deps_desc): Likewise.
	* sel-sched-ir.h (_expr): Likewise.
	(_fence): Likewise.
	(transformed_insns): Likewise.
	(_sel_insn_data): Likewise.
	* sel-sched.cc (cmpd_local_params): Likewise.
	* system.h: Remove #define for BOOL_BITFIELD.

2026-06-28  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/115571
	* match.pd (`(float)(a CMP b)`): New pattern.

2026-06-28  Kael Andrew Alonzo Franco  <kaelfandrew@gmail.com>

	PR tree-optimization/125749
	PR tree-optimization/125749
	* match.pd: Use tree_expr_nonnegative_p for MAX (A, B) (==,!=) 0 ->
	(A|B) (==,!=) 0.

2026-06-27  Jakub Jelinek  <jakub@redhat.com>

	PR target/125992
	* config/s390/s390.md (*brx_stage1_<GPR:mode>): Add CC_REGNUM clobber.

2026-06-27  Eikansh Gupta  <eikansh.gupta@oss.qualcomm.com>

	PR tree-optimization/125385
	* match.pd ((FTYPE) N CMP (FTYPE) M): Use range information
	to decide whether integer operands are exactly representable.
	((FTYPE) N CMP CST): Likewise.
	* real.cc: Include backend.h and vr-values.h.
	(format_helper::can_represent_range_value_p): New function.
	* real.h (format_helper::can_represent_range_value_p): Declare.
	* tree-core.h (class irange): Forward declare.

2026-06-26  H.J. Lu  <hjl.tools@gmail.com>

	PR middle-end/125977
	* expr.cc (emit_block_move_via_pattern): Replace ops[6].value
	in assert with GEN_INT (min_size).

2026-06-26  H.J. Lu  <hjl.tools@gmail.com>
	    Hongtao Liu  <hongtao.liu@intel.com>

	PR target/125856
	PR target/125865
	* config/i386/i386-expand.cc (ix86_expand_set_or_cpymem):
	Call ix86_expand_set_or_movmem for
	TARGET_MISALIGNED_MOVE_STRING_PRO_EPILOGUES.
	(ix86_expand_memset_val): New.
	(ix86_expand_n_move_movmem): Renamed to ...
	(ix86_expand_n_move_set_or_movmem): This.  Add a pointer to rtx
	argument for memset.  Also expand memset.
	(ix86_expand_n_overlapping_move_movmem): Renamed to ...
	(ix86_expand_n_overlapping_move_set_or_movmem): This.  Add a
	pointer to rtx argument for memset.  Also expand memset.
	(ix86_expand_less_move_movmem): Renamed to ...
	(ix86_expand_less_move_set_or_movmem): This.  Add a pointer to
	rtx argument for memset.  Also expand memset.
	(ix86_expand_movmem): Renamed to ...
	(ix86_expand_set_or_movmem): This.  Add bool arguments for memcpy
	and memset.  Also expand memcpy and memset.
	* config/i386/i386-protos.h (ix86_expand_movmem): Renamed to ...
	(ix86_expand_set_or_movmem): This.  Add bool arguments for memcpy
	and memset.
	* config/i386/i386.md (movmem<mode>): Replace ix86_expand_movmem
	with ix86_expand_set_or_movmem.

2026-06-26  Roger Sayle  <roger@nextmovesoftware.com>
	    Hongtao Liu  <hongtao.liu@intel.com>

	PR target/123238
	* config/i386/i386-expand.cc: Delay calling force_reg on
	op_true and op_false.  Generate an AND then XOR sequence
	if op_true and op_false are both CONST_VECTOR_P.
	* config/i386/mmx.md (vcond_mask_<mode>v4hi): Allow operands
	1 and 2 to be vector_or_const_vector_operand.
	(vcond_mask_<mode>v2hi): Likewise.
	(vcond_mask_<mode><mmxintvecmodelower>): Likewise.
	(vcond_mask_<mode><mode>): Likewise.
	* config/i386/sse.md (vcond_mask_<mode><sseintvecmodelower>):
	Likewise.
	(vcond_mask_<mode><sseintvecmodelower>): Likewise.
	(vcond_mask_v1tiv1ti): Likewise.
	(vcond_mask_<mode><sseintvecmodelower>): Likewise.
	(vcond_mask_<mode><sseintvecmodelower>): Likewise.
	* config/i386/predicates.md (vector_or_0_or_1s_operand): Delete
	predicate with no remaining uses.

2026-06-26  vekumar  <Venkataramanan.Kumar@amd.com>

	PR target/125949
	* config/i386/i386.md ("isa"): Add avxvnniint8.
	("enabled"): Adjust for avxvnniint8.
	* config/i386/sse.md (vpdp<vpdotprodtype>_<mode>): Adjust for
	AVXVNNIINT8.

2026-06-26  Stefan Schulze Frielinghaus  <stefansf@gcc.gnu.org>

	PR target/125972
	* config/s390/s390.cc (s390_rtx_costs): Deal with non-compare
	conditions during costing.  Also fix some indentation.

2026-06-26  Richard Biener  <rguenther@suse.de>

	PR middle-end/125875
	* match.pd: When checking for !can_vec_perm_const_p also
	allow variable permutes and use the vec_perm_indices CTOR
	with the original tree operands.

2026-06-26  Richard Biener  <rguenther@suse.de>

	* vec-perm-indices.h (vec_perm_indices::new_vector): New overload.
	(vec_perm_indices::input_bitwise_zero_p): New method.
	(vec_perm_indices::m_input0_bitwise_zero_p,
	vec_perm_indices::m_input1_bitwise_zero_p): New members.
	(vec_perm_indices::vec_perm_indices): Adjust.
	(tree_to_vec_perm_indices): Declare.
	* vec-perm-indices.cc (vec_perm_indices::new_vector): New overload.
	(vec_perm_indices::new_expanded_vector): Adjust.
	(tree_to_vec_perm_indices): New function.
	* optabs-query.cc (can_vec_perm_const_p): Handle permute
	patterns mapping to vec_shl/vec_shr.
	* tree-vect-generic.cc (lower_vec_perm): Move vec_shl/vec_shr
	detection to can_vec_perm_const_p and simplify.

2026-06-26  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/125979
	* dbgcnt.def: Add ranger_cnt.
	* gimple-range.cc (gimple_ranger::range_of_expr): Add debug_cnt.
	(gimple_ranger::range_on_entry): Likewise.
	(gimple_ranger::range_on_exit): Likewise.
	(gimple_ranger::range_on_edge); Likewise.
	(gimple_ranger::range_of_stmt): Likewise
	(dom_ranger::range_of_expr): Likewise.
	(dom_ranger::range_on_edge): Likewise.
	(dom_ranger::range_of_stmt): Likewise.

2026-06-26  H.J. Lu  <hjl.tools@gmail.com>

	PR middle-end/125977
	* builtins.cc (determine_block_size): Change len_rtx to reference
	and set it to min size if min size == max size.
	* expr.cc (emit_block_move_via_pattern): Assert count == min_size
	if min_size == max_size.
	(set_storage_via_setmem): Likewise.

2026-06-26  Pengfei Li  <Pengfei.Li2@arm.com>

	* config/aarch64/aarch64.cc
	(aarch64_sched_first_cycle_multipass_dfa_lookahead): Return 0
	when dispatch scheduling is enabled.

2026-06-26  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* configure.ac (gcc_cv_as_ix86_quad): Remove.
	* configure: Regenerate.
	* config.in: Likewise.
	* config/i386/sol2.h [!HAVE_AS_IX86_QUAD] (ASM_QUAD): Don't undefine.

2026-06-26  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* configure.ac (gcc_cv_as_ix86_diff_sect_delta): Remove.
	* configure: Regenerate.
	* config.in: Likewise.
	* config/i386/sol2.h [!HAVE_AS_IX86_DIFF_SECT_DELTA]
	(ASM_PREFERRED_EH_DATA_FORMAT): Remove.
	(JUMP_TABLES_IN_TEXT_SECTION): Likewise.
	(ASM_OUTPUT_DWARF_PCREL): Likewise.

2026-06-26  Jiahao Xu  <xujiahao@loongson.cn>

	* config/loongarch/loongarch.cc (loongarch_sched_reassociation_width):
	Get a tree_code instead of unsigned int.

2026-06-25  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	* config/riscv/riscv.md (seq_sne_qi): Mark name for debugging purposes
	only.

2026-06-25  Peter Bergner  <bergner@tenstorrent.com>

	PR target/87466
	* config/riscv/riscv.cc (TARGET_SETJMP_PRESERVES_NONVOLATILE_REGS_P):
	Define.

2026-06-25  Manjunath Matti  <mmatti@linux.ibm.com>

	* config/rs6000/predicates.md (const_0_to_6_operand): New predicate.
	* config/rs6000/rs6000-builtins.def (__builtin_vsx_xxmulmul): Add new
	builtin definitions under [future] stanza.
	(__builtin_vsx_xxmulmulhiadd): Likewise.
	(__builtin_vsx_xxmulmulloadd): Likewise.
	(__builtin_vsx_xxssumudm): Likewise.
	(__builtin_vsx_xxssumudmc): Likewise.
	(__builtin_vsx_xxssumudmcext): Likewise.
	(__builtin_vsx_xsaddadduqm): Likewise.
	(__builtin_vsx_xsaddaddsuqm): Likewise.
	(__builtin_vsx_xsaddsubuqm): Likewise.
	(__builtin_vsx_xsaddsubsuqm): Likewise.
	(__builtin_vsx_xsmerge2t1uqm): Likewise.
	(__builtin_vsx_xsmerge2t2uqm): Likewise.
	(__builtin_vsx_xsmerge2t3uqm): Likewise.
	(__builtin_vsx_xsmerge3t1uqm): Likewise.
	(__builtin_vsx_xsrebase2t1uqm): Likewise.
	(__builtin_vsx_xsrebase2t2uqm): Likewise.
	(__builtin_vsx_xsrebase2t3uqm): Likewise.
	(__builtin_vsx_xsrebase2t4uqm): Likewise.
	(__builtin_vsx_xsrebase3t1uqm): Likewise.
	(__builtin_vsx_xsrebase3t2uqm): Likewise.
	(__builtin_vsx_xsrebase3t3uqm): Likewise.
	* config/rs6000/vsx.md (UNSPEC_XXMULMUL): Add UNSPEC entry.
	(UNSPEC_XXMULMULHIADD): Likewise.
	(UNSPEC_XXMULMULLOADD): Likewise.
	(UNSPEC_XXSSUMUDM): Likewise.
	(UNSPEC_XXSSUMUDMC): Likewise.
	(UNSPEC_XXSSUMUDMCEXT): Likewise.
	(UNSPEC_XSADDADDUQM): Likewise.
	(UNSPEC_XSADDADDSUQM): Likewise.
	(UNSPEC_XSADDSUBUQM): Likewise.
	(UNSPEC_XSADDSUBSUQM): Likewise.
	(UNSPEC_XSMERGE2T1UQM): Likewise.
	(UNSPEC_XSMERGE2T2UQM): Likewise.
	(UNSPEC_XSMERGE2T3UQM): Likewise.
	(UNSPEC_XSMERGE3T1UQM): Likewise.
	(UNSPEC_XSREBASE2T1UQM): Likewise.
	(UNSPEC_XSREBASE2T2UQM): Likewise.
	(UNSPEC_XSREBASE2T3UQM): Likewise.
	(UNSPEC_XSREBASE2T4UQM): Likewise.
	(UNSPEC_XSREBASE3T1UQM): Likewise.
	(UNSPEC_XSREBASE3T2UQM): Likewise.
	(UNSPEC_XSREBASE3T3UQM): Likewise.
	(vsx_xxmulmul): New define_insn.
	(vsx_xxmulmulhiadd): Likewise.
	(vsx_xxmulmulloadd): Likewise.
	(vsx_xxssumudm): Likewise.
	(vsx_xxssumudmc): Likewise.
	(vsx_xxssumudmcext): Likewise.
	(vsx_xsaddadduqm): Likewise.
	(vsx_xsaddaddsuqm): Likewise.
	(vsx_xsaddsubuqm): Likewise.
	(vsx_xsaddsubsuqm): Likewise.
	(vsx_xsmerge2t1uqm): Likewise.
	(vsx_xsmerge2t2uqm): Likewise.
	(vsx_xsmerge2t3uqm): Likewise.
	(vsx_xsmerge3t1uqm): Likewise.
	(vsx_xsrebase2t1uqm): Likewise.
	(vsx_xsrebase2t2uqm): Likewise.
	(vsx_xsrebase2t3uqm): Likewise.
	(vsx_xsrebase2t4uqm): Likewise.
	(vsx_xsrebase3t1uqm): Likewise.
	(vsx_xsrebase3t2uqm): Likewise.
	(vsx_xsrebase3t3uqm): Likewise.
	* doc/extend.texi (PowerPC AltiVec/VSX Built-in Functions): Add
	documentation for ECC cryptography builtins available on
	future ISA.

2026-06-25  Milan Tripkovic  <Milan.Tripkovic@rt-rk.com>
	    Jeff Law   <jeffrey.law@oss.qualcomm.com>

	PR target/123884
	PR target/106585
	* config/riscv/bitmanip.md: Add new splits for single bit manipulation
	cases followed by a sign extension.

2026-06-25  Jeff Law  <jeffrey.law@oss.qualcomm.com>
	     Daniel Barboza  <daniel.barboza@oss.qualcomm.com>

	PR target/124019
	* config/riscv/riscv.md (seq_sne_qi): New define_insn_and_split.

2026-06-25  Konstantinos Eleftheriou  <konstantinos.eleftheriou@vrull.eu>

	PR tree-optimization/102793
	* tree-ssa-ifcombine.cc (bb_guards_loop_p): New function.
	(ifcombine_ifandif): Use it to avoid combining the conditions
	guarding a loop.
	* tree-ssa-tail-merge.cc: Include tree-ssa-ifcombine.h and
	tree-ssa.h.
	(ifcombine_candidate_bbs): New static bitmap.
	(apply_clusters): Collect the merged block's predecessors as
	ifcombine candidates.
	(tail_merge_optimize): Run tree_ssa_ifcombine_bb on the candidates;
	return TODO_cleanup_cfg when it changed the CFG.

2026-06-25  Konstantinos Eleftheriou  <konstantinos.eleftheriou@vrull.eu>

	* gimple-predicate-analysis.cc (get_pred_info_from_cond_edge):
	New function.
	(predicate::init_from_control_deps): Use it.
	(predicate::drop_conjuncts_implied_by): New method.
	(uninit_analysis::is_use_guarded): Retry the superset test
	after relaxing the definition predicate by the maybe-undef
	edge conditions.
	* gimple-predicate-analysis.h (class predicate): Declare
	drop_conjuncts_implied_by.

2026-06-25  Konstantinos Eleftheriou  <konstantinos.eleftheriou@vrull.eu>

	* tree-ssa-ifcombine.cc: Include tree-ssa-ifcombine.h.
	(recognize_if_then_else): Removed 'static'.
	(tree_ssa_ifcombine_bb): Removed 'static'.
	* tree-ssa-ifcombine.h: New file.

2026-06-25  Richard Biener  <rguenther@suse.de>

	PR middle-end/125977
	* cfgexpand.cc (pass_expand::execute): Guard ranger use
	on optimize.

2026-06-25  Artemiy Volkov  <artemiy.volkov@arm.com>

	PR target/125716
	* config/aarch64/aarch64-simd.md (*aarch64_simd_mov<mode>): Add
	(?w,r) alternative for VSUB64 types.

2026-06-25  Xi Ruoyao  <xry111@xry111.site>

	Revert:
	2026-06-25  Xi Ruoyao  <xry111@xry111.site>

	PR target/125077
	* config/mips/predicates.md (ssp_gp_operand): New
	define_predicate.
	(ssp_operand): New define_predicate.
	(ssp_normal_operand): New define_predicate.
	* config/mips/constraints.md (ZA): New define_constraint.
	(ZB): New define_constraint.
	* config/mips/mips.md (UNSPEC_SSP): New unspec.
	(UNSPEC_SSP_GP): New unspec.
	(cbranch<mode>4): Add '@' to generate the helper function taking
	mode as a parameter.
	(@stack_protect_combined_set_normal_<mode>): New define_insn.
	(stack_protect_combined_set_abs64): New define_insn.
	(@stack_protect_combined_test_internal_<mode>): New define_insn.
	(stack_protect_combined_set): New define_expand.
	(stack_protect_combined_test): New define_expand.
	* config/mips/mips-protos.h (mips_canary_expose_gp_use):
	Declare.
	(mips_output_asm_load_canary): Declare.
	* config/mips/mips.cc (mips_small_data_pattern_1): Don't rewrite
	GP-relative symbol wrapped in UNSPEC_SSP_GP.
	(mips_canary_expose_gp_use): Implement.
	(mips_output_asm_load_canary): Implement.
	(mips_print_operand): Allow 'w' to print d/w for DImode/SImode.

2026-06-25  Xi Ruoyao  <xry111@xry111.site>

	PR target/125628
	* config/mips/sync.md (sync_old_<optab><mode>): Fix
	uninitialized operand use.
	(sync_new_<optab><mode>): Fix uninitialized operand use, use the
	same expression for the set source of operand 0 and 1.

2026-06-25  Xi Ruoyao  <xry111@xry111.site>

	PR target/125077
	* config/mips/predicates.md (ssp_gp_operand): New
	define_predicate.
	(ssp_operand): New define_predicate.
	(ssp_normal_operand): New define_predicate.
	* config/mips/constraints.md (ZA): New define_constraint.
	(ZB): New define_constraint.
	* config/mips/mips.md (UNSPEC_SSP): New unspec.
	(UNSPEC_SSP_GP): New unspec.
	(cbranch<mode>4): Add '@' to generate the helper function taking
	mode as a parameter.
	(@stack_protect_combined_set_normal_<mode>): New define_insn.
	(stack_protect_combined_set_abs64): New define_insn.
	(@stack_protect_combined_test_internal_<mode>): New define_insn.
	(stack_protect_combined_set): New define_expand.
	(stack_protect_combined_test): New define_expand.
	* config/mips/mips-protos.h (mips_canary_expose_gp_use):
	Declare.
	(mips_output_asm_load_canary): Declare.
	* config/mips/mips.cc (mips_small_data_pattern_1): Don't rewrite
	GP-relative symbol wrapped in UNSPEC_SSP_GP.
	(mips_canary_expose_gp_use): Implement.
	(mips_output_asm_load_canary): Implement.
	(mips_print_operand): Allow 'w' to print d/w for DImode/SImode.

2026-06-25  Richard Biener  <rguenther@suse.de>

	* target.def (reassociation_width): Use default_reassociation_width.
	* targhooks.h (default_reassociation_width): Declare.
	* targhooks.cc (default_reassociation_width): Define.

2026-06-25  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/125953
	* gimple-range.cc (gimple_ranger::range_of_expr): Document.
	Fall back to global ranges if 'stmt' is not in the IL.

2026-06-25  Richard Biener  <rguenther@suse.de>

	* tree-vect-patterns.cc (vect_recog_divmod_pattern): Pass
	the division stmt as context for the range query on op0.
	Use the active ranger.

2026-06-25  Richard Biener  <rguenther@suse.de>

	* coretypes.h (enum tree_code): Declare.
	* tree-core.h (enum tree_code): Adjust.
	* target.def (reassociation_width): Get a tree_code instead
	of unsigned int.
	* doc/tm.texi: Regenerate.
	* genmatch.cc (enum tree_code): Adjust.
	* gimple-loop-versioning.cc (address_info_hasher::hash): Likewise.
	* config/aarch64/aarch64.cc (aarch64_reassociation_width):
	Likewise.
	* config/loongarch/loongarch.cc
	(loongarch_cpu_sched_reassociation_width): Likewise.
	* config/mips/mips.cc (mips_sched_reassociation_width): Likewise.
	* config/rs6000/rs6000.cc (rs6000_reassociation_width): Likewise.
	* config/i386/i386.cc (ix86_reassociation_width): Likewise
	and fix bogus compares.

2026-06-25  Martin Uecker  <uecker@tugraz.at>

	* doc/extend.texi (Constructing Calls): Document
	__builtin_call_static_chain and __builtin_call_code_address
	and update __builtin_call_with_static_chain.
	(Nested Functions): Update.

2026-06-25  Martin Uecker  <uecker@tugraz.at>

	* builtins.def (BUILT_IN_CALL_CODE_ADDRESS,
	BUILT_IN_CALL_STATIC_CHAIN): New.
	* builtins.cc (expand_builtin): Emit errors for invalid uses.
	(is_simple_builtin): Add new built-in functions.
	* gimple-fold.cc (gimple_fold_builtin_call_info): New function.
	(gimple_fold_builtin): Expand new built-ins for non-nested functions.
	* tree-nested.cc (convert_tramp_reference_stmt): Ingore new built-ins.
	(convert_gimple_call): Expand built-ins for nested functions.
	* tree-inline.cc (initialize_inlined_parameters): Set a missing
	static chain to NULL.

2026-06-25  Jan Beulich  <jbeulich@suse.com>

	* config/riscv/arch-canonicalize: Avoid f"..." strings.

2026-06-24  Oleg Tolmatcev  <oleg.tolmatcev@gmail.com>

	* config/i386/prfchwintrin.h (_m_prefetchw): Take
	volatile const void * instead of void *.

2026-06-24  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/125910
	* value-range.cc (prange::set_pt): Do not set PT when zero.
	(prange::intersect): If the result is zero_p, clear PT.
	(prange::verify_range): Verify points-to range is valid.
	* value-range.h (zero_p): Do not assert, move to verify range.
	(prange::set_pt): Only set PT when the range valid.

2026-06-24  Vineet Gupta  <vineet.gupta@linux.dev>

	PR debug/125421
	* dwarf2out.cc (modified_type_die): Handle qualified_type being
	a variant of dtype as if they were identical to avoid peeling a
	typdef.
	For named types, use dentry unconditionally as that is valid for
	both cases of qualified_type == and  != dentry.

2026-06-24  Paul-Antoine Arras  <parras@baylibre.com>

	* omp-builtins.def (BUILT_IN_GOMP_REDUCTION_START): New builtin.
	(BUILT_IN_GOMP_REDUCTION_END): New builtin.
	* omp-low.cc (lower_reduction_clauses): Replace
	BUILT_IN_GOMP_ATOMIC_START / BUILT_IN_GOMP_ATOMIC_END with
	BUILT_IN_GOMP_REDUCTION_START / BUILT_IN_GOMP_REDUCTION_END.
	(lower_omp_sections): Likewise.
	(lower_omp_scope): Likewise.
	(lower_omp_for): Likewise.
	* tree-ssa-alias.cc (check_fnspec): Handle
	BUILT_IN_GOMP_REDUCTION_START and BUILT_IN_GOMP_REDUCTION_END as
	memory barriers.

2026-06-24  Paul-Antoine Arras  <parras@baylibre.com>

	* omp-builtins.def (BUILT_IN_GOMP_BARRIER): Change function to
	GOMP_barrier_ext and type to BT_FN_VOID_INT.
	(BUILT_IN_GOMP_BARRIER_CANCEL): Change function to
	GOMP_barrier_cancel_ext and type to BT_FN_VOID_INT.
	* omp-expand.cc (expand_omp_for_static_nochunk): Pass
	GOMP_BARRIER_IMPLICIT_WORKSHARE to omp_build_barrier.
	(expand_omp_for_static_chunk): Likewise.
	(expand_omp_single): Likewise.
	* omp-general.cc (omp_build_barrier): Add kind parameter; pass it
	to GOMP_barrier_ext or GOMP_barrier_cancel_ext.
	* omp-general.h (omp_build_barrier): Update declaration to add
	kind parameter.
	* omp-low.cc (lower_rec_input_clauses): Determine barrier kind from
	the enclosing gimple statement code and pass it to omp_build_barrier.
	(lower_omp_for_scan): Pass GOMP_BARRIER_IMPLICIT_WORKSHARE to
	omp_build_barrier.

2026-06-24  Paul-Antoine Arras  <parras@baylibre.com>

	* builtin-types.def (BT_COMPLEX_INT, BT_FN_COMPLEX_INT): New types.
	* omp-builtins.def (BUILT_IN_GOMP_LOOP_STATIC_WORKSHARING): New
	builtin.
	(BUILT_IN_GOMP_DISTRIBUTE_STATIC_WORKSHARING): Likewise.
	* omp-expand.cc (expand_omp_for_static_nochunk): Replace separate calls
	to public API functions with a single call to
	GOMP_loop_static_worksharing or GOMP_distribute_static_worksharing, then
	unpack id and count.
	(expand_omp_for_static_chunk): Likewise.

2026-06-24  Paul-Antoine Arras  <parras@baylibre.com>

	* omp-builtins.def (BUILT_IN_GOMP_HAS_MASKED_THREAD_NUM): New builtin.
	* omp-low.cc (lower_omp_master): Call it.

2026-06-24  Filip Kastl  <fkastl@suse.cz>

	* gimple-ssa-pta-constraints.cc (handle_call_arg): Mention in
	comment that the function can get called in IPA mode.

2026-06-24  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/110743
	* tree-ssa-uninit.cc (maybe_warn_operand): Also cover
	VIEW_CONVERT_EXPR uses for RMW bit clear/set pattern
	detection.

2026-06-24  Jeevitha Palanisamy  <jeevitha@linux.ibm.com>

	* config/rs6000/altivec.md (V16QI_V2DI): New mode iterator.
	(add<mode>3): Split into two patterns to support future ISA
	alternatives.
	(sub<mode>3): Likewise.
	* config/rs6000/vsx.md (VIArith): New mode iterator.
	(vsx_mul<mode>3): New insn pattern.
	(smul<mode>3_highpart): Split into mode-specific patterns.
	(umul<mode>3_highpart): Likewise.
	(smulv8hi3_highpart): New insn pattern.
	(smulv4si3_highpart): Likewise.
	(smulv2di3_highpart): Likewise.
	(umulv8hi3_highpart): Likewise.
	(umulv4si3_highpart): Likewise.
	(umulv2di3_highpart): Likewise.
	* config/rs6000/rs6000-builtins.def (__builtin_vsx_xvmulhuh): New
	builtin.
	(__builtin_vsx_xvmulhsh): Likewise.
	* config/rs6000/rs6000-overload.def (__builtin_vec_mulh): Add
	overloads for vector multiply-high signed/unsigned halfword.
	* config/rs6000/rs6000-gen-builtins.cc (enum bif_stanza): Add entry for
	BSTZ_FUTURE_VSX.
	(stanza_map): Add future-vsx stanza mapping.
	(enable_string): Add ENB_FUTURE_VSX.
	(write_decls): Add ENB_FUTURE_VSX to the bif_enable enum in the
	generated header file.
	* config/rs6000/rs6000.md (define_attr "isa"): Add future to the list
	of ISA values.
	(define_attr "enabled"): Add check for future ISA.
	* config/rs6000/rs6000-builtin.cc (rs6000_invalid_builtin): Handle
	ENB_FUTURE_VSX and issue a diagnostic requiring -mcpu=future and -mvsx.
	(rs6000_builtin_is_supported): Return TARGET_FUTURE && TARGET_VSX
	for ENB_FUTURE_VSX built-ins.
	* doc/extend.texi (PowerPC AltiVec/VSX Built-in Functions Available
	on Future ISA): Document new functions.

2026-06-24  Christopher Bazley  <chris.bazley@arm.com>

	* config/aarch64/aarch64-sve.md: Update
	vec_init<mode><Vel> and vec_shl_insert_<mode> to
	accept all SVE vector modes.

2026-06-24  H.J. Lu  <hjl.tools@gmail.com>

	PR target/125958
	* config/i386/i386-expand.cc (ix86_expand_lcp_stall_peephole):
	Replace !REG_P (dest) with !GENERAL_REG_P (dest).

2026-06-24  Lili Cui  <lili.cui@intel.com>

	* config/i386/x86-tune-costs.h (generic_cost): Increase branch
	mispredict scale from COSTS_N_INSNS (2) to COSTS_N_INSNS (2) + 3.

2026-06-24  Jan Beulich  <jbeulich@suse.com>

	* doc/ifn.texi: Drop blanks after @code.

2026-06-23  Kwok Cheung Yeung  <kcyeung@baylibre.com>
	    Sandra Loosemore  <sloosemore@baylibre.com>

	* gimplify.cc (gimplify_omp_affinity): Use macros for accessing
	iterator elements.
	(compute_omp_iterator_count): Likewise.
	(build_omp_iterator_loop): Likewise.
	(copy_omp_iterator): Use a boolean to force creation of an
	expanded iterator vector, instead of specifying the length explicitly.
	(remove_unused_omp_iterator_vars): Use accessor macros.
	(build_omp_iterators_loops): Likewise.
	(enter_omp_iterator_loop_context_1): Likewise.
	(extract_base_bit_offset): Likewise.
	* omp-low.cc (lower_omp_map_iterator_expr): Likewise.
	(lower_omp_map_iterator_size): Likewise.
	* tree-inline.cc (copy_tree_body_r): Likewise.
	* tree-pretty-print.cc (dump_omp_iterators): Likewise.
	* tree.h (OMP_ITERATOR_VAR, OMP_ITERATOR_BEGIN, OMP_ITERATOR_END,
	OMP_ITERATOR_STEP, OMP_ITERATOR_ORIG_STEP, OMP_ITERATOR_BLOCK,
	OMP_ITERATOR_LABEL, OMP_ITERATOR_INDEX, OMP_ITERATOR_ELEMS,
	OMP_ITERATOR_COUNT, OMP_ITERATOR_EXPANDED_P): New macros.
	(make_omp_iterator, make_expanded_omp_iterator): New constructor
	functions.

2026-06-23  Robin Dapp  <robin.dapp@oss.qualcomm.com>

	* ira-build.cc (ira_create_allocno): Initialize dependent
	filters.
	(copy_dependent_filters): New function to copy filters.
	(create_cap_allocno): Use new function.
	(propagate_allocno_info): Ditto.
	(propagate_some_info_from_allocno): Ditto.
	* ira-color.cc (ira_dependent_filter): New function that
	calls lra_get_dependent_filter.
	(assign_hard_reg): Use new function.
	(improve_allocation): Ditto.
	(fast_allocation): Ditto.
	* ira-conflicts.cc (dependent_filter_same_reg_ok_p): New
	function to check if a dependent filter allows the same reg.
	(can_use_same_reg_p): Use new function.
	* ira-int.h (struct ira_dependent_filter): New struct holding
	allocno-specific dependent-filter properties.
	(ALLOCNO_DEPENDENT_FILTERS): New accessor.
	(ira_add_dependent_filter): Declare.
	* ira-lives.cc (ira_add_dependent_filter): New function.
	(process_dependent_filters): New function.
	(process_bb_node_lives): Call new function.
	* ira.cc (ira): Reset filters.

2026-06-23  Robin Dapp  <robin.dapp@oss.qualcomm.com>

	* config/riscv/constraints.md (TARGET_VECTOR ? V_REGS : NO_REGS):
	Add widen overlap dependent constraint.
	* config/riscv/riscv-protos.h (riscv_widen_overlap_ok): Declare.
	* config/riscv/riscv.cc (riscv_widen_operand_ok): New function.
	* config/riscv/vector.md: Use new constraint.

2026-06-23  Robin Dapp  <robin.dapp@oss.qualcomm.com>

	* lra-assigns.cc (find_hard_regno_for_1): Query dependent
	filter of current pseudo.
	* lra-constraints.cc (struct dependent_filter_cache_hasher): New
	hasher.
	(lra_init_dependent_filter_cache): New function.
	(lra_finish_dependent_filter_cache): Ditto.
	(lra_reset_dependent_filters): Ditto.
	(lra_get_dependent_filter): New function to query (and add)
	a dependent filter from/to the cache.
	(lra_add_dependent_filter): New function to add a dependent
	filter to an lra_reg.
	(get_dependent_filter): New function to get a dependent filter
	from a constraint.
	(process_dependent_filters): New function to get all dependent
	filters from the current insn's constraints.
	(process_alt_operands): Initialize dependent-filter regset.
	(curr_insn_transform): Fill lra_reg dependent filters.
	* lra-int.h (struct dependent_filter): Declare.
	(struct dependent_filter_entry): Ditto.
	(lra_init_dependent_filter_cache): Ditto.
	(lra_finish_dependent_filter_cache): Ditto.
	* lra.cc (initialize_lra_reg_info_element): New function.
	(finish_reg_info): Release dependent-filter vector.
	(lra_init_once): Init hash table.
	(lra_finish_once): Clear hash table.
	* lra.h (lra_reset_dependent_filters): Declare.

2026-06-23  Robin Dapp  <robin.dapp@oss.qualcomm.com>

	* recog.cc (preprocess_constraints): Initialize dependent
	filter.
	(test_dependent_filter): New function wrapping
	eval_dependent_filter.
	(constrain_operands): Test dependent filter in strict mode.
	* recog.h (struct operand_alternative): Declare
	dependent_filters.
	(alternative_dependent_filters): New function.

2026-06-23  Robin Dapp  <robin.dapp@oss.qualcomm.com>

	* doc/md.texi: Document dependent filters.
	* doc/tm.texi: Ditto.
	* doc/tm.texi.in: Ditto.
	* genconfig.cc (main): Add number of dependent filters.
	* genpreds.cc (add_constraint): Add dependent-filter reference
	operand.
	(process_define_register_constraint): Handle dependent filter.
	(write_get_register_filter): Ditto.
	(write_get_register_filter_id): Ditto.
	(write_dependent_filter_helpers_h): Ditto.
	(write_dependent_filter_functions_c): Ditto.
	(write_tm_preds_h): Ditto.
	(write_insn_preds_c): Ditto.
	(main): Ditto.
	* gensupport.cc (process_define_register_constraint): Ditto.
	* gensupport.h (get_register_filter_id): Declare.
	* rtl.def (DEFINE_REGISTER_CONSTRAINT): Adjust for dependent
	filter.

2026-06-23  Robin Dapp  <robin.dapp@oss.qualcomm.com>

	* tree-vect-stmts.cc (vect_use_grouped_gather): Only use when
	there are at least two pieces.

2026-06-23  Xi Ruoyao  <xry111@xry111.site>

	Revert:
	2026-06-08  Xi Ruoyao  <xry111@xry111.site>

	* config/mips/sync.md (sync_old_<optab><mode>): Fix
	uninitialized operand use.
	(sync_new_<optab><mode>): Fix uninitialized operand use, use the
	same expression for the set source of operand 0 and 1.

2026-06-23  Zhongyao Chen  <chen.zhongyao@zte.com.cn>
	    Yuke Tang  <tang.yuke@zte.com.cn>

	* config/riscv/autovec.md: Add auto-vectorization patterns for
	Zvabd instructions.
	* config/riscv/autovec-opt.md: Add widening absolute-difference
	accumulate combine patterns.
	* config/riscv/riscv-ext.def: Add Zvabd extension entry.
	* config/riscv/riscv-ext.opt: Add Zvabd option.
	* config/riscv/vector-iterators.md: Update for Zvabd.
	* config/riscv/vector.md: Add Zvabd patterns.
	* doc/riscv-ext.texi: Document zvabd extension.

2026-06-23  Alex Coplan  <alex.coplan@arm.com>

	PR target/125818
	* config/aarch64/aarch64-sve-builtins-base.cc (svset_impl::fold): Fix
	unsharing to ensure the returned stmt has the exact same lhs as the
	original.

2026-06-23  Sarvesh Chandra  <Sarvesh.Chandra@amd.com>
	    Ashwin Godbole  <Ashwin.Godbole@amd.com>

	PR target/107057
	* config/i386/sse.md (avx512f_movddup512<mask_name>): Add a
	register source alternative that emits vunpcklpd.
	(avx_movddup256<mask_name>): Likewise.

2026-06-23  H.J. Lu  <hjl.tools@gmail.com>

	PR target/125893
	* config/i386/i386-expand.cc (ix86_expand_lcp_stall_peephole): New.
	* config/i386/i386-protos.h (ix86_expand_lcp_stall_peephole):
	Likewise.
	* config/i386/i386.md (TARGET_LCP_STALL peepholes): Call
	ix86_expand_lcp_stall_peephole.

2026-06-23  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/110743
	* tree-ssa-uninit.cc (maybe_warn_operand): Suppress diagnostics
	on RMW cycles setting/clearing bits.

2026-06-23  Hu, Lin1  <lin1.hu@intel.com>

	* config/i386/sse.md (V_ANY_CBRANCH): New mode iterator.
	(cond_vec_cbranch_any<mode>): New define_expand.
	(cond_vec_cbranch_all<mode>): Ditto.

2026-06-23  Hu, Lin1  <lin1.hu@intel.com>

	* dojump.cc (do_compare_rtx_and_jump): Use simplify_expand_binop
	instead of expand_binop.

2026-06-23  Hu, Lin1  <lin1.hu@intel.com>

	* doc/md.texi (vec_cbranch_all<mode>): Clarify how the
	middle-end invoke the pattern.
	(cond_vec_cbranch_all<mode>): Ditto.
	(cond_len_vec_cbranch_all<mode>): Ditto.

2026-06-23  Kishan Parmar  <kishan@linux.ibm.com>

	* config/rs6000/rs6000-builtin.cc (rs6000_invalid_builtin): Handle
	ENB_FUTURE_ALTIVEC and issue a diagnostic requiring -mcpu=future
	and -maltivec.
	(rs6000_builtin_is_supported): Check TARGET_FUTURE && TARGET_ALTIVEC
	for ENB_FUTURE_ALTIVEC built-ins.
	* config/rs6000/rs6000-gen-builtins.cc (enum bif_stanza): Add
	BSTZ_FUTURE_ALTIVEC entry.
	(stanza_map): Add future-altivec stanza mapping.
	(enable_string): Add ENB_FUTURE_ALTIVEC.
	(write_decls): Add ENB_FUTURE_ALTIVEC to the bif_enable enum in the
	generated header file.

2026-06-23  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	* tree-ssa-phiopt.cc (pass_cselim::execute): Don't
	return TODO_TODO_update_ssa_only_virtuals.

2026-06-23  Xin Liu  <liulxx@hygon.cn>

	* common/config/i386/cpuinfo.h (get_hygon_cpu): Detect HYGON
	Family 18h model 8 as c86-4g-m8.
	* common/config/i386/i386-common.cc (processor_names): Add
	c86-4g-m8.
	(processor_alias_table): Likewise.
	* common/config/i386/i386-cpuinfo.h (enum processor_subtypes): Add
	HYGONFAM18H_C86_4G_M8.
	* config.gcc: Add c86-4g-m8 to supported x86 CPUs and handle
	c86_4g_m8 target triples.
	* config/i386/c86-4g-m7.md: Rename to ...
	* config/i386/c86-4g-m7m8.md: ... this and extend shared c86-4g-m7
	scheduling reservations to c86-4g-m8.
	(c86_4g_m8_imovx_cwde): New reservation.
	(c86_4g_m7_imov_xchg): Add c86_4g_m8 to CPU attribute.
	(c86_4g_m7_imov_xchg_load): Ditto.
	(c86_4g_m7_imov): Ditto.
	(c86_4g_m7_imov_load): Ditto.
	(c86_4g_m7_imov_store): Ditto.
	(c86_4g_m7_push): Ditto.
	(c86_4g_m7_push_mem): Ditto.
	(c86_4g_m7_pop): Ditto.
	(c86_4g_m7_pop_mem): Ditto.
	(c86_4g_m7_imul): Ditto.
	(c86_4g_m7_imul_load): Ditto.
	(c86_4g_m7_idiv): Ditto.
	(c86_4g_m7_idiv_QI): Ditto.
	(c86_4g_m7_idiv_load): Ditto.
	(c86_4g_m7_idiv_QI_load): Ditto.
	(c86_4g_m7_insn): Ditto.
	(c86_4g_m7_insn_load): Ditto.
	(c86_4g_m7_insn_store): Ditto.
	(c86_4g_m7_insn2_store): Ditto.
	(c86_4g_m7_insn_both): Ditto.
	(c86_4g_m7_setcc): Ditto.
	(c86_4g_m7_setcc_load): Ditto.
	(c86_4g_m7_setcc_store): Ditto.
	(c86_4g_m7_alu1_double): Ditto.
	(c86_4g_m7_alu1_double_load): Ditto.
	(c86_4g_m7_alu1_vector): Ditto.
	(c86_4g_m7_alu1_vector_load): Ditto.
	(c86_4g_m7_alu1_direct): Ditto.
	(c86_4g_m7_alu1_direct_load): Ditto.
	(c86_4g_m7_call): Ditto.
	(c86_4g_m7_branch): Ditto.
	(c86_4g_m7_branch_load): Ditto.
	(c86_4g_m7_lea): Ditto.
	(c86_4g_m7_leave): Ditto.
	(c86_4g_m7_str): Ditto.
	(c86_4g_m7_str_load): Ditto.
	(c86_4g_m7_ieu_vector): Ditto.
	(c86_4g_m7_ieu_vector_load): Ditto.
	(c86_4g_m7_sse_insertimm): Ditto.
	(c86_4g_m7_sse_insert): Ditto.
	(c86_4g_m7_fp_cmov): Ditto.
	(c86_4g_m7_fp_mov_direct_load): Ditto.
	(c86_4g_m7_fp_mov_direct_store): Ditto.
	(c86_4g_m7_fp_mov_double_load): Ditto.
	(c86_4g_m7_fp_mov_double_store): Ditto.
	(c86_4g_m7_fp_mov_direct): Ditto.
	(c86_4g_m7_fp_sqrt): Ditto.
	(c86_4g_m7_fp_spc_direct): Ditto.
	(c86_4g_m7_fp_spc): Ditto.
	(c86_4g_m7_fp_op_mul): Ditto.
	(c86_4g_m7_fp_op_mul_load): Ditto.
	(c86_4g_m7_fp_op_imul_load): Ditto.
	(c86_4g_m7_fp_div): Ditto.
	(c86_4g_m7_fp_div_load): Ditto.
	(c86_4g_m7_fp_idiv_load): Ditto.
	(c86_4g_m7_fp_fsgn): Ditto.
	(c86_4g_m7_fp_fcmp): Ditto.
	(c86_4g_m7_fp_fcmp_load): Ditto.
	(c86_4g_m7_fp_mmx): Ditto.
	(c86_4g_m7_mmx_add_cmp): Ditto.
	(c86_4g_m7_mmx_add_cmp_load): Ditto.
	(c86_4g_m7_mmx_cvt): Ditto.
	(c86_4g_m7_mmx_cvt_load): Ditto.
	(c86_4g_m7_mmx_shift): Ditto.
	(c86_4g_m7_mmx_shift_load): Ditto.
	(c86_4g_m7_mmx_shift_avg): Ditto.
	(c86_4g_m7_mmx_shift_avg_load): Ditto.
	(c86_4g_m7_mmx_shift_sadbw): Ditto.
	(c86_4g_m7_mmx_shift_sadbw_load): Ditto.
	(c86_4g_m7_mmx_mov): Ditto.
	(c86_4g_m7_mmx_mov_store): Ditto.
	(c86_4g_m7_mmx_mov_load): Ditto.
	(c86_4g_m7_mmx_mul): Ditto.
	(c86_4g_m7_mmx_mul_load): Ditto.
	(c86_4g_m7_sse_pinsr_reg): Ditto.
	(c86_4g_m7_sse_pinsr_reg_load): Ditto.
	(c86_4g_m7_avx_vpinsr_reg): Ditto.
	(c86_4g_m7_avx_vpinsr_reg_load): Ditto.
	(c86_4g_m7_avx512_perm_xmm): Ditto.
	(c86_4g_m7_avx512_perm_xmm_opload): Ditto.
	(c86_4g_m7_avx512_permi2_ymm): Ditto.
	(c86_4g_m7_avx512_permi2_zmm): Ditto.
	(c86_4g_m7_avx512_permi2_ymm_load): Ditto.
	(c86_4g_m7_avx512_permi2_zmm_load): Ditto.
	(c86_4g_m7_avx512_perm_zmm_imm): Ditto.
	(c86_4g_m7_avx512_perm_zmm_imm_load): Ditto.
	(c86_4g_m7_avx512_perm_zmm_noimm): Ditto.
	(c86_4g_m7_sse_perm_zmm_noimm_load): Ditto.
	(c86_4g_m7_avx512_insertx_ymm): Ditto.
	(c86_4g_m7_avx512_insertx_ymem): Ditto.
	(c86_4g_m7_avx512_insertx_zxmm): Ditto.
	(c86_4g_m7_avx512_insertx_zxmem): Ditto.
	(c86_4g_m7_avx512_insertx_zymm): Ditto.
	(c86_4g_m7_avx512_insertx_zymem): Ditto.
	(c86_4g_m7_avx_insertx_ymm): Ditto.
	(c86_4g_m7_avx_insertx_ymem): Ditto.
	(c86_4g_m7_avx512_shuf_xymm): Ditto.
	(c86_4g_m7_avx512_shuf_zmm): Ditto.
	(c86_4g_m7_avx512_shuf_xymem): Ditto.
	(c86_4g_m7_avx512_shuf_zmem): Ditto.
	(c86_4g_m7_sselogic_xymm): Ditto.
	(c86_4g_m7_sselogic_xymm_load): Ditto.
	(c86_4g_m7_avx512_cmpestr): Ditto.
	(c86_4g_m7_avx512_cmpestr_load): Ditto.
	(c86_4g_m7_avx512_log): Ditto.
	(c86_4g_m7_avx512_log_load): Ditto.
	(c86_4g_m7_avx512_vdbpsadbw_xymm): Ditto.
	(c86_4g_m7_avx512_vdbpsadbw_xymem): Ditto.
	(c86_4g_m7_avx512_vdbpsadbw_zmm): Ditto.
	(c86_4g_m7_avx512_vdbpsadbw_zmem): Ditto.
	(c86_4g_m7_avx512_abs): Ditto.
	(c86_4g_m7_avx512_abs_load): Ditto.
	(c86_4g_m7_avx_sign): Ditto.
	(c86_4g_m7_avx_sign_load): Ditto.
	(c86_4g_m7_avx_blend): Ditto.
	(c86_4g_m7_avx_blend_load): Ditto.
	(c86_4g_m7_avx512_aes): Ditto.
	(c86_4g_m7_avx512_aes_load): Ditto.
	(c86_4g_m7_avx_aes): Ditto.
	(c86_4g_m7_avx_aes_load): Ditto.
	(c86_4g_m7_extr): Ditto.
	(c86_4g_m7_extr_store): Ditto.
	(c86_4g_m7_avx_ssecomi_comi): Ditto.
	(c86_4g_m7_avx_ssecomi_comi_load): Ditto.
	(c86_4g_m7_avx_ssecomi_test): Ditto.
	(c86_4g_m7_avx_ssecomi_test_load): Ditto.
	(c86_4g_m7_avx512_imul): Ditto.
	(c86_4g_m7_avx512_imul_mem): Ditto.
	(c86_4g_m7_avx_imul): Ditto.
	(c86_4g_m7_avx_imul_mem): Ditto.
	(c86_4g_m7_avx512_mov_vmov): Ditto.
	(c86_4g_m7_avx512_mov_vmov_store): Ditto.
	(c86_4g_m7_avx512_mov_vmov_load): Ditto.
	(c86_4g_m7_avx512_vpmovx_y): Ditto.
	(c86_4g_m7_avx512_vpmovx_y_load): Ditto.
	(c86_4g_m7_avx512_vpmovx_z): Ditto.
	(c86_4g_m7_avx512_vpmovx_z_load): Ditto.
	(c86_4g_m7_avx512_vpmovx_x): Ditto.
	(c86_4g_m7_avx512_vpmovx_x_load): Ditto.
	(c86_4g_m7_avx_vpmovx_xx): Ditto.
	(c86_4g_m7_avx_vpmovx_xx_load): Ditto.
	(c86_4g_m7_avx512_expand): Ditto.
	(c86_4g_m7_avx512_expand_load): Ditto.
	(c86_4g_m7_avx512_expand_z): Ditto.
	(c86_4g_m7_avx512_expand_z_load): Ditto.
	(c86_4g_m7_avx512_movnt_load): Ditto.
	(c86_4g_m7_avx512_movnt_store): Ditto.
	(c86_4g_m7_sse_movnt_store): Ditto.
	(c86_4g_m7_sse_movnt): Ditto.
	(c86_4g_m7_avx512_blendv): Ditto.
	(c86_4g_m7_avx512_blendv_load): Ditto.
	(c86_4g_m7_sse_mov2): Ditto.
	(c86_4g_m7_sse_mov2_load): Ditto.
	(c86_4g_m7_avx512_sseishft_aligr): Ditto.
	(c86_4g_m7_avx512_sseishft_aligr_load): Ditto.
	(c86_4g_m7_avx512_sseishft_vshift): Ditto.
	(c86_4g_m7_avx512_sseishft_vshift_load): Ditto.
	(c86_4g_m7_avx512_sseadd_maxmin): Ditto.
	(c86_4g_m7_avx512_sseadd_maxmin_load): Ditto.
	(c86_4g_m7_avx_sseadd_maxmin): Ditto.
	(c86_4g_m7_avx_sseadd_maxmin_load): Ditto.
	(c86_4g_m7_sse_sseadd_maxmin): Ditto.
	(c86_4g_m7_sse_sseadd_maxmin_load): Ditto.
	(c86_4g_m7_avx512_sseadd): Ditto.
	(c86_4g_m7_avx512_sseadd_load): Ditto.
	(c86_4g_m7_avx_sseadd_hplus): Ditto.
	(c86_4g_m7_avx_sseadd_hplus_load): Ditto.
	(c86_4g_m7_avx512_sseiadd_madd): Ditto.
	(c86_4g_m7_avx512_sseiadd_madd_mem): Ditto.
	(c86_4g_m7_avx_sseiadd_sadbw): Ditto.
	(c86_4g_m7_avx_sseiadd_sadbw_mem): Ditto.
	(c86_4g_m7_sse_sseiadd_sadbw): Ditto.
	(c86_4g_m7_sse_sseiadd_sadbw_mem): Ditto.
	(c86_4g_m7_sse_sseiadd_madd): Ditto.
	(c86_4g_m7_sse_sseiadd_madd_mem): Ditto.
	(c86_4g_m7_avx512_sseiadd_avg): Ditto.
	(c86_4g_m7_avx512_sseiadd_avg_load): Ditto.
	(c86_4g_m7_avx_sseiadd_hplus): Ditto.
	(c86_4g_m7_avx_sseiadd_hplus_load): Ditto.
	(c86_4g_m7_sse_sseiadd_hplus): Ditto.
	(c86_4g_m7_sse_sseiadd_hplus_load): Ditto.
	(c86_4g_m8_avx512_ssemul): New reservation.
	(c86_4g_m8_avx512_ssemul_load): Ditto.
	(c86_4g_m7_avx512_ssediv_x): Add c86_4g_m8 to CPU attribute.
	(c86_4g_m7_avx512_ssediv_xmem): Ditto.
	(c86_4g_m7_avx512_ssediv_y): Ditto.
	(c86_4g_m7_avx512_ssediv_ymem): Ditto.
	(c86_4g_m7_avx512_ssediv_z): Ditto.
	(c86_4g_m7_avx512_ssediv_zmem): Ditto.
	(c86_4g_m7_avx512_ssecmp): Ditto.
	(c86_4g_m7_avx512_ssecmp_load): Ditto.
	(c86_4g_m7_avx512_ssecmp_z): Ditto.
	(c86_4g_m7_avx512_ssecmp_z_load): Ditto.
	(c86_4g_m7_avx512_ssecmp_vp): Ditto.
	(c86_4g_m7_avx512_ssecmp_vp_load): Ditto.
	(c86_4g_m7_avx512_ssecmp_vp_z): Ditto.
	(c86_4g_m7_avx512_ssecmp_vp_z_load): Ditto.
	(c86_4g_m7_avx_ssecmp_vp): Ditto.
	(c86_4g_m7_avx_ssecmp_vp_load): Ditto.
	(c86_4g_m7_avx512_ssecmp_test): Ditto.
	(c86_4g_m7_avx512_ssecmp_test_load): Ditto.
	(c86_4g_m7_avx512_ssecvt_xy): Ditto.
	(c86_4g_m7_avx512_ssecvt_xy_load): Ditto.
	(c86_4g_m7_avx512_ssecvt_y_z): Ditto.
	(c86_4g_m7_avx512_ssecvt_y_z_load): Ditto.
	(c86_4g_m7_avx512_ssecvt_z): Ditto.
	(c86_4g_m7_avx512_ssecvt_z_load): Ditto.
	(c86_4g_m7_avx_ssecvt): Ditto.
	(c86_4g_m7_avx_ssecvt_load): Ditto.
	(c86_4g_m7_sse_ssecvt_pspi): Ditto.
	(c86_4g_m7_sse_ssecvt_pspi_load): Ditto.
	(c86_4g_m7_sse_ssecvt_pi): Ditto.
	(c86_4g_m7_sse_ssecvt_pi_load): Ditto.
	(c86_4g_m8_avx512_muladd): New reservation.
	(c86_4g_m8_avx512_muladd_load): Ditto.
	(c86_4g_m7_avx512_muladd_madd): Add c86_4g_m8 to CPU attribute.
	(c86_4g_m7_avx512_muladd_madd_load): Ditto.
	(c86_4g_m7_avx512_sse_range): Ditto.
	(c86_4g_m7_avx512_sse_range_load): Ditto.
	(c86_4g_m7_avx512_sse_conflict_x): Ditto.
	(c86_4g_m7_avx512_sse_conflict_x_load): Ditto.
	(c86_4g_m7_avx512_sse_conflict_y): Ditto.
	(c86_4g_m7_avx512_sse_conflict_y_load): Ditto.
	(c86_4g_m7_avx512_sse_conflict_z): Ditto.
	(c86_4g_m7_avx512_sse_conflict_z_load): Ditto.
	(c86_4g_m7_avx512_sse_class): Ditto.
	(c86_4g_m7_avx512_sse_class_load): Ditto.
	(c86_4g_m7_avx512_sse_class_z): Ditto.
	(c86_4g_m7_avx512_sse_class_z_load): Ditto.
	(c86_4g_m7_avx_sse): Ditto.
	(c86_4g_m7_avx_sse_load): Ditto.
	(c86_4g_m7_avx512_sse_sqrt_sf_x): Ditto.
	(c86_4g_m7_avx512_sse_sqrt_sf_xload): Ditto.
	(c86_4g_m7_avx512_sse_sqrt_sf_y): Ditto.
	(c86_4g_m7_avx512_sse_sqrt_sf_yload): Ditto.
	(c86_4g_m7_avx512_sse_sqrt_sf_z): Ditto.
	(c86_4g_m7_avx512_sse_sqrt_sf_zload): Ditto.
	(c86_4g_m7_avx512_sse_sqrt_df_x): Ditto.
	(c86_4g_m7_avx512_sse_sqrt_df_xload): Ditto.
	(c86_4g_m7_avx512_sse_sqrt_df_y): Ditto.
	(c86_4g_m7_avx512_sse_sqrt_df_yload): Ditto.
	(c86_4g_m7_avx512_sse_sqrt_df_z): Ditto.
	(c86_4g_m7_avx512_sse_sqrt_df_zload): Ditto.
	(c86_4g_m7_avx512_msklog): Ditto.
	(c86_4g_m7_avx512_msklog_vector): Ditto.
	(c86_4g_m7_avx512_mskmov_reg_k): Ditto.
	(c86_4g_m7_avx512_mskmov_xy_k): Ditto.
	(c86_4g_m7_avx512_mskmov_z_k): Ditto.
	(c86_4g_m7_avx512_mskmov_k_k): Ditto.
	(c86_4g_m7_avx512_mskmov_k_reg): Ditto.
	(c86_4g_m7_avx512_mskmov_k_m): Ditto.
	* config/i386/driver-i386.cc (host_detect_local_cpu): Detect
	c86-4g-m8.
	* config/i386/i386-c.cc (ix86_target_macros_internal): Define
	c86-4g-m8 arch and tune macros.
	* config/i386/i386-options.cc (m_C86_4G_M8): New macro.
	(m_C86_4G): Include m_C86_4G_M8.
	(processor_cost_table): Add c86_4g_m8_cost.
	* config/i386/i386.cc (ix86_reassociation_width): Handle
	PROCESSOR_C86_4G_M8.
	* config/i386/i386.h (enum processor_type): Add
	PROCESSOR_C86_4G_M8.
	(PTA_C86_4G_M8): New.
	* config/i386/i386.md: Add c86_4g_m8 to cpu attribute.
	* config/i386/x86-tune-costs.h (c86_4g_m8_cost): New.
	* config/i386/x86-tune-sched.cc (ix86_issue_rate): Handle
	PROCESSOR_C86_4G_M8.
	(ix86_adjust_cost): Likewise.
	* config/i386/x86-tune.def (X86_TUNE_USE_SCATTER_2PARTS): Include
	m_C86_4G_M8.
	(X86_TUNE_USE_SCATTER_4PARTS): Likewise.
	(X86_TUNE_USE_SCATTER_8PARTS): Likewise.
	(X86_TUNE_SSE_REDUCTION_PREFER_PSHUF): Likewise.
	(X86_TUNE_AVX512_SPLIT_REGS): Likewise.
	(X86_TUNE_AVX512_AVOID_VEC_PERM): Likewise.
	(X86_TUNE_AVX512_MOVE_BY_PIECES): Likewise.
	(X86_TUNE_AVX512_MASKED_EPILOGUES): Likewise.
	* doc/extend.texi: Document c86-4g-m8 for __builtin_cpu_is.
	* doc/invoke.texi: Document c86-4g-m8.

2026-06-22  Marek Polacek  <polacek@redhat.com>

	PR c++/125697
	* doc/invoke.texi: Clarify -Wrange-loop-construct description.

2026-06-22  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/125923
	* tree-ssa-phiopt.cc (factor_out_conditional_load): Change
	assert of the vuse being the same to rejecting if they are
	different without a virtual phi.

2026-06-22  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	* tree-ssa-phiopt.cc (cond_store_replacement): Fix comment
	on no load for nontrapping.

2026-06-22  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	* tree-ssa-phiopt.cc (cond_store_replacement): Update
	the vuse on the new load and the vuse/vdef on the new
	store.

2026-06-22  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/125917
	* tree-ssa-phiopt.cc (cond_store_replacement): Just call
	gsi_insert_before instead of checking gsi_end_p.
	(cond_if_else_store_replacement_1): Likewise.

2026-06-22  Georg-Johann Lay  <avr@gjlay.de>

	* splay-tree-utils.cc: Remove -*- C++ -*- tags for Emacs.
	* rtl-ssa/accesses.cc: Same.
	* rtl-ssa/blocks.cc: Same.
	* rtl-ssa/changes.cc: Same.
	* rtl-ssa/functions.cc: Same.
	* rtl-ssa/insns.cc: Same.

2026-06-22  Tobias Burnus  <tburnus@baylibre.com>

	* omp-general.cc (omp_runtime_api_procname): Update for added
	functions and older additions.
	* omp-low.cc (scan_omp_1_stmt): Update for added _dim function.

2026-06-22  Zhongjie Guo  <guozhongjie@hygon.cn>
	    Richard Biener  <rguenther@suse.de>

	* config/i386/i386.cc (ix86_vector_costs::add_stmt_cost): Cost
	comparisons using the comparison operand mode.

2026-06-22  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr-protos.h (avr_log_t) <insert_attributes>: New field.
	* config/avr/avr-log.cc (avr_log_node): New static function.
	(avr_log_vadump) [%N]: Call it.
	(avr_log_set_avr_log) <insert_attributes>: New SET_DUMP_DETAIL.
	* config/avr/avr.cc (avr_pgm_check_var_decl): Don't call avr_edump.
	(avr_insert_attributes) [avr_log.insert_attributes]: Call avr_edump.

2026-06-22  H.J. Lu  <hjl.tools@gmail.com>

	PR target/125895
	* config/i386/i386-features.cc (pass_x86_cse::x86_cse): Use
	integer CONST_VECTOR to load FP CONST_VECTOR converted from
	const_int.

2026-06-22  Pan Li  <pan2.li@intel.com>

	* match-sat-alu.pd: Add fits check before call to
	tree_to_uhwi.

2026-06-22  Pan Li  <pan2.li@intel.com>

	* match-sat-alu.pd: Add pattern for unsigned scalar
	SAT_MUL form 13.

2026-06-21  Iain Sandoe  <iain@sandoe.co.uk>

	* doc/sourcebuild.texi: Document object file checks.

2026-06-21  Iain Sandoe  <iain@sandoe.co.uk>

	* config/aarch64/aarch64-builtins.cc
	(aarch64_expand_prefetch_range_builtin): Use LLONG_MAX instead
	of LONG_LONG_MAX.

2026-06-21  H.J. Lu  <hjl.tools@gmail.com>

	PR target/125883
	* config/i386/i386-features.cc (ix86_broadcast_inner): Skip JUMP
	from asm goto.

2026-06-20  Gerald Pfeifer  <gerald@pfeifer.com>

	* doc/extend.texi (Integer Overflow Builtins): Spell compile time
	without dash when a noun.
	* doc/invoke.texi (Warning Options): Ditto.
	* doc/passes.texi (Tree SSA passes): Ditto.
	* doc/rtl.texi (Conversions): Ditto.

2026-06-20  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr.cc (avr_progmem_p): Use strip_array_types to
	peel off ARRAY_TYPEs.
	(avr_nonconst_pointer_addrspace): Same.
	(avr_insert_attributes): Same.
	(avr_decl_maybe_lds_p): Same.

2026-06-20  Roger Sayle  <roger@nextmovesoftware.com>
	    Hongtao Liu  <hongtao.liu@intel.com>

	* config/i386/i386-features.cc (scalar_chain::convert_op): Check
	if the (DImode) SUBREG being converted by STV has an original mode
	that's tieable to the vector mode (V2DImode), if not (e.g. DDmode)
	emit this "conversion" as a separate move for reload to handle.

2026-06-20  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr.cc (avr_init_builtins): Use XALLOCAVEC
	instead of alloca to locally alloc char[].
	* config/avr/avr-c.cc (avr_cpu_cpp_builtins): Same.
	* config/avr/avr-log.cc (avr_log_set_avr_log): Same.

2026-06-19  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/125857
	* ipa-prop.cc (ipa_record_return_value_range_1): Don't record
	pranges which have non ipa-invariants in it.

2026-06-19  Iain Sandoe  <iain@sandoe.co.uk>

	* config/aarch64/aarch64.cc
	(aarch64_vector_costs::count_ops): Treat vec_deconstruct in the
	same way as vec_construct.

2026-06-19  Peter Bergner  <bergner@tenstorrent.com>

	* config/riscv/riscv-cores.def (RISCV_TUNE)<tt-ascalon-d8>: Rename from
	this...
	(RISCV_TUNE)<tt-ascalon-x>: ...to this.
	(RISCV_CORE)<tt-ascalon-d8>: Likewise.
	(RISCV_CORE)<tt-ascalon-x>: Likewise.
	(RISCV_CORE_ALIAS): Add tt-ascalon-d8 alias for tt-ascalon-x.
	* doc/riscv-mcpu.texi: Document the name change.
	* doc/riscv-mtune.texi: Likewise.

2026-06-19  Peter Bergner  <bergner@tenstorrent.com>

	* common/config/riscv/riscv-common.cc (struct riscv_cpu_alias_info):
	New struct.
	(riscv_cpu_alias_table): New.
	(riscv_find_cpu): Add support for cpu alias names.
	(riscv_get_valid_option_values): Likewise.
	Add an early loop exit if we found a duplicate name.
	* config/riscv/riscv-cores.def (RISCV_CORE_ALIAS): New macro.

2026-06-19  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/122193
	* tree-ssa-phiopt.cc (factor_out_conditional_load): Support non-zero
	offsets.

2026-06-19  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	* tree-ssa-phiopt.cc (is_factor_profitable): Change arg_op
	to operands and opcount.
	(factor_out_conditional_operation): Update call to
	is_factor_profitable.
	(factor_out_conditional_load): Support when merge has
	a virtual phi. The load's vuse needs to be the arguments
	to the virtual phi. Call is_factor_profitable on the new phi
	arguments. Update the vuse on the new load to the virtual phi.

2026-06-19  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>
	    Kyrylo Tkachov  <ktkachov@nvidia.com>

	PR tree-optimization/125557
	* tree-ssa-phiopt.cc (factor_out_conditional_load): New function.
	(factor_out_all):  Call factor_out_conditional_load.

2026-06-19  Xin Wang  <yw987194828@gmail.com>

	* tree-ssa-loop-im.cc (mem_ref_hasher::equal): Refactor
	for clarity.

2026-06-19  Arsen Arsenović  <aarsenovic@baylibre.com>

	* doc/extend.texi: Move @anchor-s referring to tops of nodes
	after their corresponding @node lines.
	* doc/invoke.texi: Ditto.

2026-06-19  Eric Botcazou  <ebotcazou@adacore.com>

	* acinclude.m4 (gcc_GAS_FLAGS): Set to --32 for abi32 targets.
	* configure.ac (TLS support): Use 32-bit sequence for abi32 targets.
	* configure: Regenerate.

2026-06-19  Eric Botcazou  <ebotcazou@adacore.com>

	* tree-nested.cc (lookup_field_for_decl): In the non-pointer case,
	clear DECL_NONADDRESSABLE_P if the DECL is of an aggregate type.

2026-06-19  Kael Andrew Franco  <kaelfandrew@gmail.com>

	PR tree-optimization/125641
	PR tree-optimization/125641
	* match.pd: Add bit_ior/bit_and {bit_not} rshift to min/max.

2026-06-19  Léo Hardt  <leom.hardt@inf.ufrgs.br>

	* ddg.h (GCC_DDG_H): Removed orphaned comment from 60393bbc
	* sel-sched-ir.h (GCC_SEL_SCHED_IR_H): Removed orphaned comment from c7131fb

2026-06-18  Milan Tripkovic  <Milan.Tripkovic@rt-rk.com>

	PR target/125405
	* match.pd: New pattern added.

2026-06-18  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	* config/riscv/riscv.md (splitter for equality test): New splitter.

2026-06-18  Paul Iannetta  <piannetta@kalrayinc.com>
	    Thomas Schwinge  <tschwinge@baylibre.com>

	* tree.h (ENCODE_QUAL_ADDR_SPACE): Add missing parentheses.

2026-06-18  Andrew MacLeod  <amacleod@redhat.com>

	* value-range.cc (prange::intersect): Points-to and away results
	in undefined.

2026-06-18  Andrew MacLeod  <amacleod@redhat.com>

	* value-range.h (prange::pt_invariant_p): Return true or false.
	(prange::pt_invariant_away_p): Likewise.

2026-06-18  Andrew MacLeod  <amacleod@redhat.com>

	* value-range.h (prange::zero_p): Assert that is zero_p is true,
	points_to is unknown.

2026-06-18  Richard Sandiford  <rdsandiford@googlemail.com>

	PR tree-optimization/125872
	* gimple-ssa-backprop.cc (backprop::execute): Don't try to delete
	default definitions.

2026-06-18  Andrew MacLeod  <amacleod@redhat.com>

	* gimple-range-fold.cc (fold_using_range::range_of_phi): Remove
	extranous logical not from expression.

2026-06-18  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/125854
	* gimple-range-fold.cc (fold_using_range::fold_stmt): Check if the
	range_query matches the current one before invoking fold.

2026-06-18  Martin Jambor  <mjambor@suse.cz>

	PR ipa/124128
	* ipa-cp.cc (ipa_vr_intersect_with_arith_jfunc): Move the check if
	the final type conversion needs to happen before the conversion.

2026-06-18  Richard Biener  <rguenther@suse.de>

	* config/i386/i386.cc (ix86_vector_costs::add_stmt_cost):
	Use vector construction scaling also for mult-lane
	VMAT_STRIDED_SLP but use vector composition type recorded
	to avoid excessive over-costing.

2026-06-18  Richard Biener  <rguenther@suse.de>

	* config/i386/i386.cc (ix86_vector_costs::add_stmt_cost):
	Expect vec_deconstruct where formerly handling vec_to_scalar
	for emulated gather/scatter, elementwise and strided accesses.

2026-06-18  Richard Biener  <rguenther@suse.de>

	* config/i386/i386.cc (ix86_vector_cd_cost): New function,
	enhanced and split out from ...
	(ix86_default_vector_cost): ... here.

2026-06-18  Richard Biener  <rguenther@suse.de>

	* target.h (vect_cost_for_stmt::vec_deconstruct): New kind.
	* tree-vect-loop.cc (vect_model_reduction_cost): Use it.
	* tree-vect-stmts.cc (vectorizable_store): Likewise.
	(vectorizable_load): Likewise.
	* tree-vectorizer.cc (dump_stmt_cost): Handle vec_deconstruct.
	* config/aarch64/aarch64.cc (aarch64_builtin_vectorization_cost):
	Handle vec_deconstruct like vec_construct.
	* config/i386/i386.cc (ix86_default_vector_cost): Likewise.
	* config/arm/arm.cc (arm_builtin_vectorization_cost): Likewise.
	* config/loongarch/loongarch.cc (loongarch_builtin_vectorization_cost):
	Likewise.
	* config/riscv/riscv.cc (riscv_builtin_vectorization_cost):
	Likewise.
	* config/rs6000/rs6000.cc (rs6000_builtin_vectorization_cost):
	Likewise.
	* config/s390/s390.cc (s390_builtin_vectorization_cost): Likewise.
	* targhooks.cc (default_builtin_vectorization_cost): Likewise.

2026-06-18  Richard Biener  <rguenther@suse.de>

	* tree-vectorizer.h (vect_load_store_data::ls_eltype): New field.
	* tree-vect-stmts.cc (vectorizable_load): Record ltype
	as ls_eltype for VMAT_STRIDED_SLP.
	(vectorizable_store): Likewise.

2026-06-17  James K. Lowden  <jklowden@cobolworx.com>

	* doc/install.texi: COBOL requires Bison 3.8.2.

2026-06-17  Tamar Christina  <tamar.christina@arm.com>

	PR tree-optimization/125804
	* tree-vect-loop-manip.cc (vect_do_peeling): Have
	LOOP_VINFO_EARLY_BREAKS_VECT_PEELED require epilog.

2026-06-17  Dhruv Chawla  <dhruvc@nvidia.com>

	PR fortran/125717
	* lto-streamer-in.cc (input_cfg): Stream loop->can_be_parallel in.
	* lto-streamer-out.cc (output_cfg): Stream loop->can_be_parallel out.

2026-06-17  Zhongjie Guo  <guozhongjie@hygon.cn>

	* config/i386/x86-tune-costs.h (c86_4g_m7_cost): Increase
	512-bit load/store and unaligned load/store costs.

2026-06-17  Xin Liu  <liulxx@hygon.cn>

	* config/i386/c86-4g-m7.md (c86_4g_m7_imov_xchg): Adjust
	reservation units.
	(c86_4g_m7_imov_xchg_load): Ditto.
	(c86_4g_m7_call): Ditto.
	(c86_4g_m7_branch): Ditto.
	(c86_4g_m7_branch_load): Ditto.
	(c86_4g_m7_fp_spc_direct): Add missing store unit.
	(c86_4g_m7_sse_pinsr_reg): Adjust reservation units.
	(c86_4g_m7_avx512_insertx_ymm): Ditto.
	(c86_4g_m7_avx512_insertx_ymem): Ditto.
	(c86_4g_m7_avx512_insertx_zxmm): Ditto.
	(c86_4g_m7_avx512_insertx_zxmem): Ditto.
	(c86_4g_m7_avx512_abs_load): Add missing store unit.
	(c86_4g_m7_avx_sign): Use combined FPU reservation.
	(c86_4g_m7_avx_sign_load): Ditto.
	(c86_4g_m7_avx_aes): Ditto.
	(c86_4g_m7_avx_aes_load): Ditto.
	(c86_4g_m7_extr_load): Rename to ...
	(c86_4g_m7_extr_store): ... this and restrict to store memory.
	(c86_4g_m7_avx_imul): Use combined FPU reservation.
	(c86_4g_m7_avx_imul_mem): Ditto.
	(c86_4g_m7_avx512_vpmovx_y_load): Add missing store unit.
	(c86_4g_m7_avx_vpmovx_xx_load): Ditto.
	(c86_4g_m7_avx512_sseadd_maxmin_xy): Rename to ...
	(c86_4g_m7_avx512_sseadd_maxmin): ... this and simplify
	memory attribute check.
	(c86_4g_m7_avx512_sseadd_maxmin_xy_load): Rename to ...
	(c86_4g_m7_avx512_sseadd_maxmin_load): ... this and simplify
	memory attribute check.
	(c86_4g_m7_avx512_sseadd_xy): Rename to ...
	(c86_4g_m7_avx512_sseadd): ... this.
	(c86_4g_m7_avx512_sseadd_xy_load): Rename to ...
	(c86_4g_m7_avx512_sseadd_load): ... this.
	(c86_4g_m7_sse_sseiadd_sadbw): Use combined FPU reservation.
	(c86_4g_m7_sse_sseiadd_sadbw_mem): Ditto.
	(c86_4g_m7_avx512_ssecmp_vp_z): Adjust reservation units.
	(c86_4g_m7_avx512_ssecmp_vp_z_load): Ditto.
	(c86_4g_m7_avx512_ssecmp_test_load): Ditto.
	(c86_4g_m7_avx512_mskmov_k_m): Adjust latency.

2026-06-17  Robin Dapp  <rdapp.gcc@gmail.com>

	PR target/125478
	* config/riscv/vector.md: Set widen-alu mode_idx to 3.

2026-06-17  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	Revert:
	2026-06-15  Jim Tsung-Chun Lin  <jim@andestech.com>

	* common/config/riscv/riscv-common.cc (riscv_select_multilib):
	Don't set riscv_no_matched_multi_lib here; let the caller own
	the flag.
	(riscv_compute_multilib): Drop the early return that accepted
	the generic-matched multilib_dir; always run the smart matcher
	and set riscv_no_matched_multi_lib when it finds no candidate.

2026-06-17  Andrew MacLeod  <amacleod@redhat.com>

	* gimple-range-cache.cc (ranger_cache::set_global_range): Nonzero
	pointer ranges are no longer invariant.

2026-06-17  Andrew MacLeod  <amacleod@redhat.com>

	* Makefile.in (OBJS): Remove value-pointer-equiv.o.
	* tree-vrp.cc (rvrp_folder::m_pta): Delete member.
	(rvrp_folder::rvrp_folder): Remove m_pta allocation.
	(rvrp_folder::~rvrp_folder): Delete.
	(rvrp_folder::pre_fold_bb): Remove m_pta reference.
	(rvrp_folder::post_fold_bb): Delete.
	(rvrp_folder::pre_fold_stmt): Remove m_pta reference.
	* value-pointer-equiv.cc: Delete.
	* value-pointer-equiv.h: Delete.

2026-06-17  Andrew MacLeod  <amacleod@redhat.com>

	* tree-vrp.cc (rvrp_folder::value_of_expr): Use prange PTA info.
	(value_on_edge): Likewise.

2026-06-17  Andrew MacLeod  <amacleod@redhat.com>

	* gimple-range-fold.cc (x_fold_context): New.
	(pta_valueize): New.
	(fold_using_range::fold_stmt): Set PTA fields.
	(fold_using_range::range_of_phi): Ditto.
	* ipa-prop.cc (ipa_vr::ipa_vr): Allocate unshared range.
	* range-op-ptr.cc (pointer_plus_operator::fold_range): Handle PTA.
	(pointer_plus_operator::op2_range): Ditto.
	(operator_pointer_diff::fold_range): Ditto.
	(operator_cast::fold_range): Ditto.
	(operator_cast::lhs_op1_relation): Ditto.
	(operator_equal::fold_range): Ditto.
	(operator_not_equal::fold_range): Ditto.
	* value-query.cc (range_query::get_tree_range): Ditto.
	* value-range-pretty-print.cc (vrange_printer::print_pt): New.
	(vrange_printer::visit): Add print support.
	* value-range-pretty-print.h (vrange_printer::print_pt): New prototype.
	* value-range-storage.cc (vrange_allocator::clone): Allow unshared
	expression allocation.
	(vrange_storage::alloc): Likewise.
	(prange_storage::alloc): Likewise.
	(prange_storage::prange_format): Copy PTA.
	(prange_storage::set_prange): Ditto.
	(prange_storage::get_prange): Ditto.
	(prange_storage::equal_p): Compare points-to data.
	(ggc_alloc_vrange_storage): Allow unshared expression.
	* value-range-storage.h (clone): Adjust param list.
	(prange_storage::m_pt, m_points_to_p): New.
	* value-range.cc (inchash::add_vrange): Add points-to to hash value.
	(prange::set_pt): New.
	(prange::pt_base): New.
	(prange::pt_offset): New.
	(prange::pt_size): New.
	(prange::set): Initialize PTA field.
	(prange::union_): Handle PTA cases.
	(prange::intersect): Ditto.
	(prange::operator=): Ditto.
	(prange::operator==): Ditto.
	(prange::invert): Handle PTA cases.
	(prange::verify_range): Ditto.
	* value-range.h (set_pt, set_pt_unknown, pt_unknown_p,
	pt_invariant, pt_invariant_away, pt_invariant_p, pt_invariant_away_p,
	pt_invert, pt_inverted_p, pt_base, pt_offset, pt_size,
	pt_equal_p): New prange prototypes.
	(prange::m_pt, prange::m_points_to_p): New members.
	(prange::set_undefined): Clear PTA fields.
	(prange::set_varying): Ditto.
	(prange::set_nonzero): Ditto.
	(prange::set_zero): Ditto.
	(prange::zero_p): Check PTA fields.
	(varying_compatible_p): Ditto.
	(prange::set_pt): New.
	(prange::set_pt_unknown): New.
	(prange::pt_unknown_p): New.
	(prange::pt_equal_p): New prange prototypes.
	(prange::pt_inverted_p): New.
	(prange::pt_invert): New.
	(prange::pt_invariant): New.
	(prange::pt_invariant_away): New.
	(prange::pt_invariant_p): New.
	(prange::pt_invariant_away_p): New.

2026-06-16  H.J. Lu  <hjl.tools@gmail.com>

	PR c/125226
	* targhooks.cc (default_stack_protect_guard): If UINTPTR_TYPE
	isn't NULL, call unsigned_integer_tree_node_for_type with
	UINTPTR_TYPE to get unsigned integer type for uintptr_t.
	* tree.cc (unsigned_integer_tree_node_for_type): New function.
	(build_common_tree_nodes): Call unsigned_integer_tree_node with
	SIZE_TYPE to get unsigned integer type for size_t.
	* tree.h (unsigned_integer_tree_node_for_type): New prototype.

2026-06-16  Jakub Jelinek  <jakub@redhat.com>

	* doc/invoke.texi (-std=c++2d, -std=c++29, -std=gnu++2d,
	-std=gnu++29): Document.
	(-std=c++2c, -std=c++26, -std=gnu++2c, -std=gnu++26): Tweak so that
	26 comes first and is meant as the supported option.
	* doc/cpp.texi: Adjust expected __cplusplus value for -std=c++26,
	document value for -std=c++29.
	* dwarf2out.cc (highest_c_language): Handle C++29.
	(gen_compile_unit_die): Likewise.  Adjust lversion for C++26.

2026-06-16  Robin Dapp  <rdapp.gcc@gmail.com>

	PR tree-optimization/125516
	* tree-vect-data-refs.cc (vect_gather_scatter_fn_p): Set
	supported_offset_vectype.
	* tree-vect-stmts.cc (vectorizable_store): Skip nop conversions
	when costing scatters.
	(vectorizable_load): Ditto for gathers.

2026-06-16  Abhishek Kaushik  <abhishek.kaushik@arm.com>

	* tree-ssa-loop-niter.cc (determine_value_range): Query ranger
	for integral expressions, not only SSA_NAMEs.  Query ranges on the
	loop preheader edge.

2026-06-16  Kyrylo Tkachov  <ktkachov@nvidia.com>

	* tree-vect-data-refs.cc (vect_slp_analyze_data_ref_dependence):
	Return a three-way tree result (chrec_known when independent,
	chrec_dont_know when the affine test cannot analyze the pair, the
	dependence otherwise) instead of a bool.
	(vect_slp_analyze_store_dependences): Resort to the alias oracle on
	an unknown dependence as well as on a missing data reference; a
	store is being moved so do not use TBAA.
	(vect_slp_analyze_load_dependences): Likewise on the load-hoist
	paths, using TBAA as a load is being hoisted; also record that the
	ao_ref has been initialized in check_hoist.

2026-06-16  Robin Dapp  <rdapp.gcc@gmail.com>

	PR target/125670
	* config/riscv/autovec-opt.md: Use avl_type operand number.

2026-06-16  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/125730
	* tree-ssa-loop-ivopts.cc (alloc_iv): Do not convert pointer
	IVs to unsigned before canonicalizing.

2026-06-16  Richard Biener  <rguenther@suse.de>

	* fold-const.cc (fold_plusminus_mult_expr): Use
	wide_int for the case of two INTEGER_CST multiplicands.

2026-06-16  Kyrylo Tkachov  <ktkachov@nvidia.com>

	PR target/125794
	* config/aarch64/aarch64.cc (aarch64_simd_valid_imm): Do not fall
	through to the replicating SVE immediate forms for a 128-bit
	Advanced SIMD constant whose high 64 bits are zero (output_width
	!= 0).

2026-06-16  Avinash Jayakar  <avinashd@linux.ibm.com>

	PR tree-optimization/59429
	* match.pd: New match patterns to recognize spaceship variants.
	* tree-ssa-math-opts.cc (gimple_spaceship): Match function declaration.
	(match_spaceship): New function to recognize spaceship given phi node.
	(math_opts_dom_walker::after_dom_children): Add match_spaceship check.

2026-06-16  H.J. Lu  <hjl.tools@gmail.com>

	PR target/125614
	* config/i386/i386-features.cc (replace_vector_const): Replace
	gen_rtx_SUBREG with gen_lowpart.

2026-06-15  Roger Sayle  <roger@nextmovesoftware.com>

	* config/i386/i386.cc (ix86_insn_cost): Add a suitable penalty
	for USE of a MEM in a PARALLEL (for *<absneg>[sd]f2_1 splitter).

2026-06-15  Kyrylo Tkachov  <ktkachov@nvidia.com>

	PR target/125795
	* config/aarch64/aarch64-early-ra.cc (early_ra::allocate_colors):
	Compute the allocated-FPR mask as
	((1ULL << color->group->size) - 1) << best.

2026-06-15  Kael Andrew Franco  <kaelfandrew@gmail.com>

	PR tree-optimization/125737
	PR tree-optimization/125737
	* match.pd: Use tree_expr_nonnegative_p for X % Y < Y to true.

2026-06-15  Kael Andrew Franco  <kaelfandrew@gmail.com>

	PR tree-optimization/125756
	* match.pd: Use tree_expr_nonnegative_p for X < (typeof X)(X != 0) to false.

2026-06-15  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	* tree-ssa-phiopt.cc (factor_out_all): New function.
	(pass_phiopt::execute): Call factor_out_all isntead
	of factor_out_conditional_operation and
	cond_if_else_store_replacement_limited.

2026-06-15  Konstantinos Eleftheriou  <konstantinos.eleftheriou@vrull.eu>

	PR rtl-optimization/123754
	* expmed.cc (store_integral_bit_field): When the SUBREG
	narrowing fails, defer to store_split_bit_field instead of
	asserting.

2026-06-15  Jim Tsung-Chun Lin  <jim@andestech.com>

	* common/config/riscv/riscv-common.cc (riscv_select_multilib):
	Don't set riscv_no_matched_multi_lib here; let the caller own
	the flag.
	(riscv_compute_multilib): Drop the early return that accepted
	the generic-matched multilib_dir; always run the smart matcher
	and set riscv_no_matched_multi_lib when it finds no candidate.

2026-06-15  Filip Kastl  <fkastl@suse.cz>

	PR sanitizer/124206
	* gcc.cc (driver::global_initializations): Ask for 128MB stack
	instead of just 64MB when __SANITIZE_ADDRESS__ is defined.
	* toplev.cc (toplev::main): Ditto.

2026-06-15  Richard Biener  <rguenther@suse.de>

	* tree-ssa-reassoc.cc (ovce_extract_ops): Fixup
	false value matching for the inverted comparison case.

2026-06-15  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/125786
	* tree-ssa-reassoc.cc (optimize_vec_cond_expr): Create a new
	stmt instead of rewriting an existing possibly multi-use one.

2026-06-15  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr-protos.h (avr_out_delay_loop): New proto.
	* config/avr/avr.cc (avr_out_delay_loop): New function.
	(avr_adjust_insn_length) [ADJUST_LEN_DELAY_LOOP]: Handle case.
	(avr_expand_delay_cycles): Overhaul.  Allow loop counts of
	zero; they represent a power of 2.
	* config/avr/avr.md (adjust_len) [delay_loop]: Add.
	(*delay_cycles_1): Use avr_out_delay_loop for asm out.
	(*delay_cycles_4): Same.
	(*delay_cycles_3): Same.
	(*delay_cycles_2): Same.  Relax constraints to "d".
	Use two QImode scratch regs instead of one HImode one.

2026-06-15  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/125790
	* match.pd (`(~x)>>x`): Reject truncation of shifter.

2026-06-15  Monk Chiang  <62004175+monkchiang@users.noreply.github.com>

	* config/riscv/riscv-zicfilp.cc (rest_of_insert_landing_pad):
	Remove gen_lpad_align before non-local goto labels; LABEL_ALIGN
	now handles their alignment.  Simplify gpr_save handling: the
	pattern now outputs the full CFI sequence itself.
	* config/riscv/riscv.cc (riscv_output_mi_thunk): Add
	gen_lpad_align before entry lpad.
	* config/riscv/riscv.h (LABEL_ALIGN): New macro; ensures 4-byte
	alignment for Zicfilp non-local goto target labels.
	* config/riscv/riscv.md (gpr_save): When is_zicfilp_p, output
	.p2align 2, .option push/norelax/norvc, call, .option pop, lpad 0.

2026-06-15  Monk Chiang  <monk.chiang@sifive.com>

	* config/riscv/riscv-protos.h (riscv_call_needs_lpad_p): Declare.
	* config/riscv/riscv.cc (riscv_gnu_attributes): Register new
	indirect_return attribute for function declarations.
	(riscv_call_needs_lpad_p): New function.
	* config/riscv/riscv.md (call_internal_cfi): New insn pattern with
	length attribute.
	(call_value_internal_cfi): Likewise for call-with-return-value,
	with comment and length attribute.
	(define_expand "call"): Emit call_internal_cfi when
	riscv_call_needs_lpad_p returns true.
	(define_expand "call_value"): Likewise.

2026-06-14  Stafford Horne  <shorne@gmail.com>

	* config/or1k/or1k.md (cbranchsi4): Add clobber clause.

2026-06-14  Stafford Horne  <shorne@gmail.com>

	* config/or1k/or1k.h (SHIFT_COUNT_TRUNCATED): Define.
	* config/or1k/or1k.md (rotrsi3): Rename reg_or_u6_operand to
	reg_or_u5_operand.
	(<shift_op>si3): Ditto.
	* config/or1k/predicates.md (reg_or_u6_operand): Remove.
	(reg_or_u5_operand): New predicate.

2026-06-14  François-Xavier Coudert  <fxcoudert@gcc.gnu.org>

	PR target/120645
	* config/darwin-driver.cc: Account for latest macOS numbering
	scheme.

2026-06-14  Souradipto Das  <souradiptodas6@gmail.com>

	* match.pd: Add simplification rules for
	(a == 0) | ((a | b) == 0) -> (a == 0) and
	(a != 0) & ((a | b) != 0) -> (a != 0).

2026-06-14  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/125774
	* gimple-range-fold.cc (fold_using_range::relation_fold_and_or): Use
	relation_swap rather than relation_negate when the operands are exchanged.

2026-06-13  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/125776
	* tree-ssa-phiopt.cc (is_factor_profitable): An
	usage in a debug stmt should be ignored.

2026-06-13  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	* gcc.cc (find_a_program): Implement the new behavior described
	above.
	(driver::set_up_specs): Initilize variable. It would be nice to
	have less spooky-action-at-a-distince using C++ features, but I
	just matched how the corresponding suffix variable worked for
	now for uniformity.

2026-06-13  John Ericson  <git@JohnEricson.me>

	* gcc.cc (for_each_path): Pass an additional boolean argument to
	the callback specifying whether the current directly being
	searched is machine-specific, as described above.
	(build_search_list): Add unused parameter to lambda match new
	callback type.
	(find_a_file): Add unused parameter to lambda match new callback
	type.
	(find_a_program): Add unused parameter to lambda match new
	callback type.
	(spec_path::operator()): Add unused parameter to match new
	callback type.

2026-06-13  panciyan@eswincomputing.com  <panciyan@eswincomputing.com>

	* config/riscv/crypto.md (riscv_pack): Change HISI iterator to
	HX as we must match half a target word for pack.

2026-06-13  Gerald Pfeifer  <gerald@pfeifer.com>

	* doc/install.texi (Configuration): Use AE spelling for "behavior".

2026-06-13  Kyrylo Tkachov  <ktkachov@nvidia.com>

	PR tree-optimization/125750
	* match.pd (mult of a 0/1 value by a negated 0/1 value): New
	simplification.

2026-06-13  Kael Andrew Alonzo Franco  <kaelfandrew@gmail.com>

	PR tree-optimization/125707
	PR tree-optimization/125707
	* match.pd: Add (~a) >> a to -1 for signed a.

2026-06-13  Sunil Dora  <sunilkumar.dora@windriver.com>

	PR driver/111527
	* defaults.h (COLLECT2_OPTIONS_MAX_LENGTH): New macro.
	* collect-utils.cc (read_collect_gcc_options): New function.
	* collect-utils.h (read_collect_gcc_options): Declare.
	* collect2.cc (main): Use read_collect_gcc_options instead
	of getenv.
	* doc/hostconfig.texi (Host Misc): Document
	COLLECT2_OPTIONS_MAX_LENGTH.
	* doc/invoke.texi (Environment Variables): Document the
	@file form of COLLECT_GCC_OPTIONS.
	* gcc.cc (xsetenv_collect_gcc_options): New function.
	(set_collect_gcc_options): Use xsetenv_collect_gcc_options.
	* lto-wrapper.cc (run_gcc): Use read_collect_gcc_options
	instead of getenv.

2026-06-12  Claudio Bantaloukas  <claudio.bantaloukas@arm.com>

	* config/aarch64/aarch64-cores.def (cortex-a320): Update core.
	* config/aarch64/aarch64.cc: Add cortexa320.h.
	* config/aarch64/tuning_models/cortexa320.h: New file.

2026-06-12  Ramin Moussavi  <lordrasmus@gmail.com>

	* config/microblaze/microblaze.h (DWARF_ALT_FRAME_RETURN_COLUMN):
	Define.

2026-06-12  Thomas Schwinge  <tschwinge@baylibre.com>

	PR target/101484
	* config/gcn/gcn.cc (TARGET_ADDR_SPACE_ZERO_ADDRESS_VALID): Implement.

2026-06-12  Stefan Schulze Frielinghaus  <stefansf@gcc.gnu.org>

	* lra-constraints.cc (reload_section_anchor_p): New function.
	(curr_insn_transform): For offsetable MEMs, try reloading the
	section anchor only.

2026-06-12  Tamar Christina  <tamar.christina@arm.com>

	PR tree-optimization/125597
	* tree-vect-loop-manip.cc (vect_do_peeling): Create IFN_VARYING for
	early break scalar IV.
	* tree-vect-loop.cc (vect_update_ivs_after_vectorizer_for_early_breaks):
	Replace the IFN_VARYING with actual value.

2026-06-12  Tamar Christina  <tamar.christina@arm.com>

	PR tree-optimization/125597
	(vect_do_peeling): Create IFN_VARYING for masks.
	* tree-vect-loop-manip.cc (vect_set_loop_condition): Replace the
	IFN_VARYING.

2026-06-12  Tamar Christina  <tamar.christina@arm.com>

	PR tree-optimization/125597
	* internal-fn.def (VARYING): New.
	* doc/ifn.texi: Document it.
	* internal-fn.cc (expand_VARYING): New.
	* internal-fn.h (expand_VARYING): New.
	* tree-cfg.cc (verify_gimple_call): Check for leaked IFN_VARYING.

2026-06-12  Stefan Schulze Frielinghaus  <stefansf@gcc.gnu.org>

	PR rtl-optimization/125173
	* ira.cc (combine_and_move_insns): Allow multiple uses within
	an insn.

2026-06-12  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>
	    Kyrylo Tkachov  <ktkachov@nvidia.com>

	PR tree-optimization/125557
	PR tree-optimization/64700
	PR tree-optimization/29144
	PR tree-optimization/94274
	* tree-if-conv.cc (find_different_opnum): Move to ...
	* gimple-match-exports.cc (find_different_opnum): Here.
	* gimple-match.h (find_different_opnum): New decl.
	* tree-ssa-phiopt.cc (is_factor_profitable): Take
	gimple_match_op instead of one operand.
	Rearrange the code to check the lifetime of the operands last.
	(factor_out_conditional_operation): Handle operands > 1,
	including operands communitive operands. Add early_p argument
	for costing. Update call of is_factor_profitable.
	(pass_phiopt::execute): Pass early_p to
	factor_out_conditional_operation.
	* tree.h (int_divide_or_mod_p): New function.

2026-06-12  Stefan Schulze Frielinghaus  <stefansf@gcc.gnu.org>

	* ira-costs.cc (find_costs_and_classes): Do not honour equivs if
	they get rejected by LRA anyway.
	* ira-int.h (CONST_POOL_OK_P): Move CONST_POOL_OK_P here ...
	* lra-constraints.cc (CONST_POOL_OK_P): from there.

2026-06-11  Iain Sandoe  <iain@sandoe.co.uk>

	* common/config/aarch64/aarch64-common.cc: Make the asm
	crc bug workaround configurable.

2026-06-11  Georg-Johann Lay  <avr@gjlay.de>

	PR target/125751
	* config/avr/avr.cc (avr_out_fract): Fix too small sequence
	lengths in avr_asm_len calls.

2026-06-11  Roman Beliaev  <r.beliaev@ispras.ru>

	* gcov.cc (solve_flow_graph): Fix condition.

2026-06-11  Karl Meakin  <karl.meakin@arm.com>

	* doc/rtl.texi: Replace "fixed-point" with "integral" where
	appropriate.

2026-06-11  Andrew MacLeod  <amacleod@redhat.com>

	PR tree-optimization/125706
	* range-op.cc (operator_trunc_mod::wi_fold): Apply fixed
	quotient refinement.

2026-06-11  Andrew Stubbs  <ams@baylibre.com>

	* config/gcn/gcn.h (REG_CLASS_NAMES): Add missing comma.

2026-06-11  Naveen  <naveen.siddegowda@oss.qualcomm.com>

	PR target/113926
	* config/aarch64/aarch64.cc (struct simd_immediate_info): Add width
	field to record AdvSIMD output vector width.
	(simd_immediate_info::simd_immediate_info): Initialize width to zero
	in all constructors.
	(aarch64_simd_valid_imm): Allow 128-bit AdvSIMD MOV immediates with
	zero high 64 bits to be materialized using 64-bit MOVI.
	(aarch64_output_simd_imm): Use recorded immediate width when outputting
	AdvSIMD immediates.

2026-06-11  Zhongyao Chen  <chenzhongyao.hit@gmail.com>

	PR tree-optimization/123343
	* tree-vect-slp.cc (vect_analyze_slp_reduction_group): Return
	false for group_size <= 1 at entry.
	(vect_analyze_slp_reductions): Add loop exit check for
	group_size <= 1.

2026-06-11  Torbjörn SVENSSON  <torbjorn.svensson@foss.st.com>

	PR testsuite/113276
	* doc/sourcebuild.texi (arm_mixed_fp): Document.

2026-06-11  Hongyu Wang  <hongyu.wang@intel.com>

	* common/config/i386/i386-cpuinfo.h (enum feature_priority):
	Add P_AVX10_2, P_APX_F, P_PROC_AVX10_2.
	* common/config/i386/i386-isas.h: Set P_AVX10_2 for avx10.2
	and P_APX_F for apxf.
	* common/config/i386/i386-common.cc (processor_alias_table):
	Use P_PROC_AVX10_2 for diamondrapids and novalake.

2026-06-11  Zhongyao Chen  <chen.zhongyao@zte.com.cn>

	PR tree-optimization/125567
	* tree-vect-slp.cc (least_upthread_swappable_op_distance): New.
	(vect_build_slp_tree_2): Compute swap checks before building operand
	zero.  Skip external fallback while swap retry is possible.  Reuse the
	swap checks in the retry path.

2026-06-10  Andrew MacLeod  <amacleod@redhat.com>

	* value-range-storage.cc (irange_storage::irange_storage):
	Explicitly initialize vrange_storage.
	(prange_storage::prange_storage): Likewise.
	* value-range-storage.h (vrange_storage): Add GTY marker and
	discriminator field.
	(irange_storage): Add GTY marker.
	(prange_storage): Add GTY marker and friend GTY functions.
	(frange_storage): Add GTY marker and explcitly initialize
	vrange_storage.

2026-06-10  Andrew MacLeod  <amacleod@redhat.com>

	* value-range-storage.cc (prange_storage::equal_p): Compare just
	the required fields.

2026-06-10  Andrew MacLeod  <amacleod@redhat.com>

	* value-range-storage.cc (prange_storage::alloc): Use new
	prange_format function.
	(prange_storage::prange_storage): Likewise.
	(prange_storage::prange_format): Rename from prange_format
	constructor and rework.
	(prange_storage::set_prange): Use prange_format function.
	(prange_storage::fits_p): Likewise.
	* value-range-storage.h (enum prange_kind): Move out of
	prange_storage class.
	(PRANGE_STORAGE_NINTS): Likewise.
	(class prange_format): remove.
	(m_trailing_ints): Use PRANGE_STORAGE_NINTS.

2026-06-10  tobby.li  <tobby.li@armchina.com>

	* config/arm/arm-cpus.in (cortex-m52): Remove quirk_vlldm.
	* doc/invoke.texi: Remove cortex-m52 from the list of CPUs that
	enable -mfix-cmse-cve-2021-35465 by default.  Fix typo in CVE
	number (CVE-2021-365465 -> CVE-2021-35465).

2026-06-10  Chung-Lin Tang  <cltang@baylibre.com>

	PR fortran/122910
	* langhooks-def.h (LANG_HOOKS_OMP_ARRAY_DATA_PRIVATIZE): Define.
	* langhooks.h (struct lang_hooks_for_decls): Define
	omp_array_data_privatize hook.
	* omp-low.cc (scan_sharing_clauses): Add new calls to
	lang_hooks.decls.omp_array_data_privatize,
	(lower_omp_target): Likewise.

2026-06-10  tobby.li  <tobby.li@armchina.com>

	* config/arm/arm-cpus.in (star-mc3): New CPU.
	* config/arm/arm-tables.opt: Regenerate.
	* config/arm/arm-tune.md: Regenerate.
	* doc/invoke.texi: Update docs.

2026-06-10  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	PR ipa/125699
	* ipa-param-manipulation.cc (ipa_param_body_adjustments::prepare_debug_expressions): Fix
	lifetime issue with m_dead_ssa_debug_equiv usage.

2026-06-10  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	* config/riscv/zicond.md (combined sCC splitters): Avoid using
	PUT_MODE to change existing RTL.  Instead just generate a new node.

2026-06-10  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/125686
	* tree-vect-patterns.cc (synth_lshift_by_additions): Specify
	pattern vector type.
	(apply_binop_and_append_stmt): Likewise.
	(vect_synth_mult_by_constant): Adjust.

2026-06-09  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr.cc: Fix typos in comments.
	* config/avr/avr-c.cc: Same.
	* config/avr/avr-passes.cc: Same.
	* config/avr/avr-passes-fuse-move.h: Same.

2026-06-09  Uros Bizjak  <ubizjak@gmail.com>

	PR target/125636
	* config/i386/i386.md (extendqihi2): Use movsbl instead of movsbw.
	Adjust the destination operand to use %k0 and update the mode
	attribute accordingly.

2026-06-09  Ciprian Arbone  <Ciprian.Arbone@microchip.com>
	    Senthil Kumar Selvaraj  <saaadhu@gcc.gnu.org>

	PR target/124077
	* config/arm/arm.cc (thumb1_final_prescan_insn): Also skip
	condition code update for thumb1_cbz instructions.
	* config/arm/thumb1.md (thumb1_cbz): Use const0_rtx as the
	recorded cc_op1 instead of operands[2].

2026-06-09  Lino Hsing-Yu Peng  <linopeng@andestech.com>

	* config/riscv/riscv-protos.h (enum altfmt_type): New.
	* config/riscv/riscv-v.cc (emit_hard_vlmax_vsetvl): Pass
	ALTFMT_NONE to gen_vsetvl.
	(gen_no_side_effects_vsetvl_rtx): Pass ALTFMT_NONE to
	gen_vsetvl_no_side_effects.
	* config/riscv/riscv-vector-builtins-bases.cc: Include insn-attr.h.
	(vsetvl::expand): Pass ALTFMT_NONE to gen_vsetvl_no_side_effects.
	* config/riscv/riscv-vsetvl.cc (altfmt_to_str): New function.
	(get_altfmt): New function.
	(demand_flags): Add DEMAND_ALTFMT_P.
	(altfmt_demand_type): New enum.
	(vsetvl_info): Track altfmt.
	(demand_system): Add altfmt compatibility, availability, and merge handling.
	* config/riscv/riscv-vsetvl.def: Add altfmt rules.
	* config/riscv/vector.md (altfmt): New attribute, numeric with
	INVALID_ATTRIBUTE default.
	(@vsetvl<mode>, vsetvl_vtype_change_only,
	@vsetvl_discard_result<mode>, @vsetvl<mode>_no_side_effects,
	*vsetvldi_no_side_effects_si_extend): Add altfmt operand.

2026-06-09  Georg-Johann Lay  <avr@gjlay.de>

	* config/avr/avr.md: Fix typos in comments.
	* config/avr/avr-fixed.md: Same.
	* config/avr/avr-passes.cc: Same
	* config/avr/avr-passes-fuse-move.h: Same.

2026-06-09  Wilco Dijkstra  <wilco.dijkstra@arm.com>

	* config/aarch64/aarch64-sve.md: Remove zeroing movprfx of merging MOV

2026-06-09  Artemiy Volkov  <artemiy.volkov@arm.com>

	PR target/125550
	* config/aarch64/aarch64-simd.md
	(*aarch64_combine_internal<mode>): Use zip1 instead of uzp1
	to concatenate values residing in SIMD registers.
	(*aarch64_combine_internal_be<mode>): Likewise.

2026-06-09  JRobinNTA  <johnrobin044@gmail.com>

	PR target/125395
	* config/riscv/thead.cc (th_asm_output_opcode): Add VFCVT
	and VFWCVT blocks. Add offset logic for static rounding suffixes.

2026-06-09  Alex Coplan  <alex.coplan@arm.com>

	PR middle-end/125621
	* expmed.cc (make_tree): Fix CONST_POLY_INT case to pass type
	instead of t, move it to its own switch case.

2026-06-09  Monk Chiang  <monk.chiang@sifive.com>
	     "Jim Wilson  <jimw@sifive.com>

	* config/riscv/riscv-protos.h (riscv_zero_offset_address_bypass_p):
	New function.
	* config/riscv/riscv.cc (riscv_zero_offset_address_bypass_p): New
	function.
	* config/riscv/sifive-7.md: Add bypass definition.

2026-06-09  Monk Chiang  <monk.chiang@sifive.com>

	* config/riscv/riscv.cc (riscv_trampoline_init): Remove redundant
	LUI instruction.

2026-06-09  Martin Jambor  <mjambor@suse.cz>

	* config/pdp11/pdp11.cc (pdp11_conditional_register_usage): Change i
	from int to unsigned int.

2026-06-09  Xi Ruoyao  <xry111@xry111.site>

	PR rtl-optimization/125609
	PR middle-end/122992
	* hard-reg-set.h
	(build_error_on_rvalue): New function.
	(EXECUTE_IF_SET_IN_HARD_REG_SET): Call the function above.

2026-06-09  Jeevitha Palanisamy  <jeevitha@linux.ibm.com>

	* config/rs6000/amo.h (_AMO_LD): Add _AMO_LD_CS_EQ enumerator, gated on
	_ARCH_FUTURE.
	(amo_lwat_cas_eq, amo_lwat_scas_eq, amo_ldat_cas_eq,
	amo_ldat_scas_eq): New compare-and-swap equal helper functions.
	(_AMO_ERR_CMPSWP): New macro for error-attribute stubs on non-Future
	targets.
	* doc/extend.texi (PowerPC Atomic Memory Operation Functions): Document
	new functions.

2026-06-08  Sam James  <sam@gentoo.org>

	* doc/tm.texi: Regenerate.

2026-06-08  Gerald Pfeifer  <gerald@pfeifer.com>

	* doc/cpp.texi: Spell "command-line option" with a dash.
	(Binary Resource Inclusion): Ditto.
	* doc/fragments.texi (Target Fragment): Ditto.
	* doc/gcc.texi: Ditto.
	(Indices): Ditto.
	* doc/gccint.texi: Ditto.
	(Top): Ditto.
	(Option Index): Ditto.
	* doc/gcov.texi (Invoking Gcov): Ditto. And fix grammar.
	* doc/gm2.texi (Compiler options): Ditto.
	(Extensions): Ditto.
	(The PIM system module): Ditto.
	(The ISO system module): Ditto.
	* doc/invoke.texi (Debugging Options): Ditto.
	(AVR Options): Ditto.
	* doc/lto.texi (LTO object file layout): Ditto.
	(WHOPR): Ditto.
	* doc/md.texi (Machine Constraints): Ditto.
	* doc/objc.texi (Constant string objects): Ditto. And fix grammar.
	(Exceptions): Ditto.
	(Synchronization): Ditto.
	* doc/tm.texi.in: Ditto. And standardize on "option" over
	"flag".
	(strategy): Ditto. And standardize on "option" over "switch"
	and fix grammar.
	* target.def: Ditto.
	* doc/tm.texi: Regenerate.

2026-06-08  Alfie Richards  <alfie.richards@arm.com>

	* config/aarch64/aarch64-builtins.cc (enum aarch64_builtins):
	Add AARCH64_PREFETCH_PLD_RANGE and AARCH64_PREFETCH_PLDX_RANGE.
	(aarch64_init_prefetch_builtins): Add initialization of
	__pld_range and __pldx_range.
	(require_const_argument): Update to return the minval if value
	is out of range.
	(aarch64_expand_prefetch_range_builtin): New function.
	(aarch64_general_expand_builtin): Add support for
	AARCH64_PREFETCH_PLD_RANGE and AARCH64_PREFETCH_PLDX_RANGE.
	* config/aarch64/aarch64-c.cc (aarch64_update_cpp_builtins): Add
	__ARM_PREFETCH_RANGE macro.
	* config/aarch64/aarch64.md (unspec): Add UNSPEC_PLDX_RANGE and
	UNSPEC_PLD_RANGE
	(aarch64_rprfm): New instruction.

2026-06-08  Alfie Richards  <alfie.richards@arm.com>

	* config/aarch64/aarch64.h (TARGET_FPRCVT): New macro definition.
	* config/aarch64/aarch64.md (arches): Add fprcvt.
	(arch_enabled): Add fprcvt.
	(l<fcvt_pattern><su_optab><GPF_F16:mode><GPI:mode>2): Add
	FEAT_FPRCVT variant.
	(<optab>_trunchf<GPI:mode>2): Likewise.
	(<optab>_trunc<fcvt_change_mode><GPI:mode>2): Likewise.
	(fix_to_zero_extend<mode>di2): Likewise.
	(<optab><fcvt_iesize><GPF:mode>2): Likewise.
	(define_insn "aarch64_fp16_<optab><mode>hf2): Likewise.
	* config/aarch64/iterators.md (fpw): Add SF and DF variants.

2026-06-08  Alfie Richards  <alfie.richards@arm.com>

	* config/aarch64/aarch64-simd-builtins.def: (lround): Add new
	forms for new conversions.
	(lroundu): Likewise.
	(lceil): Likewise.
	(lceilu): Likewise.
	(lfloor): Likewise.
	(lflooru): Likewise.
	(lfrintn): Likewise.
	(lfrintnu): Likewise.
	* config/aarch64/arm_neon.h (vcvtd_s32_f64): New intrinsic.
	(vcvtd_s32_f64): Likewise.
	(vcvtd_u32_f64): Likewise.
	(vcvts_s64_f32): Likewise.
	(vcvts_u64_f32): Likewise.
	(vcvtad_s32_f64): Likewise.
	(vcvtad_u32_f64): Likewise.
	(vcvtas_s64_f32): Likewise.
	(vcvtas_u64_f32): Likewise.
	(vcvtmd_s32_f64): Likewise.
	(vcvtmd_u32_f64): Likewise.
	(vcvtms_s64_f32): Likewise.
	(vcvtms_u64_f32): Likewise.
	(vcvtnd_s32_f64): Likewise.
	(vcvtnd_u32_f64): Likewise.
	(vcvtns_s64_f32): Likewise.
	(vcvtns_u64_f32): Likewise.
	(vcvtpd_s32_f64): Likewise.
	(vcvtpd_u32_f64): Likewise.
	(vcvtps_s64_f32): Likewise.
	(vcvtps_u64_f32): Likewise.

2026-06-08  Alfie Richards  <alfie.richards@arm.com>

	* config/aarch64/aarch64-c.cc (aarch64_update_cpp_builtins): Add
	__ARM_FEATURE_SSVE_FEXPA.
	* config/aarch64/aarch64-sve-builtins-base.def (svexpa): Change
	gating to streaming compatible if AARCH64_FL_SSVE_FEXPA is
	supported.
	* config/aarch64/aarch64-sve.md: Update gating to be enabled if
	TARGET_SSVE_FEXPA.
	* config/aarch64/aarch64.h (TARGET_SVE_FEXPA): New macro.
	* config/aarch64/iterators.md (SVE_FP_UNARY_INT): Update FEXPA
	gating.

2026-06-08  Alfie Richards  <alfie.richards@arm.com>

	* config/aarch64/aarch64-c.cc (aarch64_update_cpp_builtins): Add
	__ARM_FEATURE_SSVE_BITPERM.
	* config/aarch64/aarch64-sve-builtins-sve2.def:
	Make sve-bitperm intrinsics streaming compatible.
	* config/aarch64/aarch64-sve2.md: Change gating of sve-bitperm
	instructions.
	* config/aarch64/aarch64.h (TARGET_SVE_BITPERM): New macro.
	(TARGET_SVE2_BITPERM): Removed.

2026-06-08  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/125668
	* tree-ssa-forwprop.cc (forward_propagate_addr_expr_1):
	Preserve alignment of the original access also for propagating
	into the LHS.

2026-06-08  Richard Sandiford  <rdsandiford@googlemail.com>

	PR tree-optimization/125653
	* gimple-ssa-backprop.cc (backprop::process_var): Avoid early
	return for SSA names that occur in abnormal phis.

2026-06-08  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/125652
	* tree-chrec.cc (chrec_fold_plus_poly_poly): Avoid UB
	integer overflow in accumulating CHREC_RIGHT.

2026-06-08  Richard Biener  <rguenther@suse.de>

	PR tree-optimization/125646
	* tree-vect-patterns.cc (vect_synth_mult_by_constant): Assign
	vector type to the pattern def sequence stmts.

2026-06-08  Andreas Schwab  <schwab@suse.de>

	PR rtl-optimization/122992
	* config/m68k/m68k.cc (m68k_conditional_register_usage): Fix
	signedness of register number var.
	(m68k_zero_call_used_regs): Fix missing declaration.

2026-06-08  Richard Sandiford  <rdsandiford@googlemail.com>

	* config/aarch64/aarch64-sve.md
	(*aarch64_vec_duplicate_subvector<vconsv><vconq><mode>): Remove
	<vconq> from name.

2026-06-08  Richard Sandiford  <rdsandiford@googlemail.com>

	* simplify-rtx.cc (simplify_context::simplify_unary_operation_1):
	Simplify vec_duplicates of vec_duplicates.
	* config/aarch64/aarch64-sve.md
	(*aarch64_vec_duplicate_subvector<vconsv><vconq><mode>): Remove
	nested vec_duplicate.

2026-06-08  Richard Sandiford  <rdsandiford@googlemail.com>

	* config/sh/sh.md (bswapsi): Remove can_create_pseudo_p () check.

2026-06-08  Xi Ruoyao  <xry111@xry111.site>

	* config/mips/sync.md (sync_old_<optab><mode>): Fix
	uninitialized operand use.
	(sync_new_<optab><mode>): Fix uninitialized operand use, use the
	same expression for the set source of operand 0 and 1.

2026-06-08  Naveen  <naveen.siddegowda@oss.qualcomm.com>

	* match.pd: ((type) minmax (wide) a, wide (b)): New pattern.

2026-06-07  Richard Sandiford  <rdsandiford@googlemail.com>

	* doc/sourcebuild.texi: Document that check-function-bodies
	automatically adds the check_function_bodies options.

2026-06-07  Andrew Pinski  <andrew.pinski@oss.qualcomm.com>

	PR tree-optimization/125612
	* tree-ssa-phiopt.cc (cond_store_replacement): For the case where
	lhs is "known" to be nontrapping make sure there are no loads in
	the middle bb.

2026-06-07  Jeff Law  <jeffrey.law@oss.qualcomm.com>

	* config/sh/sh.md (bswapsi2): Move check for can_create_pseudos_p
	into condition rather than FAILing.

2026-06-07  John Ericson  <git@JohnEricson.me>

	* gcc.cc (find_a_file): Remove mode parameter, because always
	R_OK. Skip suffix logic, because suffix is always empty in that
	case.
	(read_specs): Remove mode from find_a_file call.
	(find_a_program): Suffix is unconditional, inline mode constant.
	(end_going_arg): Remove mode from find_a_file call.
	(find_file): Remove mode from find_a_file call.
	(driver::set_up_specs): Remove mode from find_a_file call.
